/*
 * Khoros: $Id: ghost.h,v 1.4 1996/04/04 22:38:29 fas Exp $
 */



/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Contains #defines and routine declarations used
   >>>>		       by the ghost library, the ghostreader
   >>>>		       and ghostwriter programs.
   >>>>
   >>>>    Written By: Danielle Argiro
   >>>>
   >>>>          Date: Jul 13, 1992 10:27
   >>>>
   >>>> Modifications: Converted from ghost.h in Khoros 1.0 (DA)
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kcms_ghost_h_
#define _kcms_ghost_h_

	/*-------------------------------------*
        |       #include
        ---------------------------------------*/

	/*-------------------------------------*
        |       #defines
        ---------------------------------------*/

#define MAX_NAME_LENGTH		9
#define MAX_ME_GROUPNUM		50
#define MAX_TOGGLENUM		75
#define MAX_PROGSPEC_SIZE	39L
#define MAX_LINELENGTH		80
#define MAX_TEXTBLOCK		200
#define MAX_CMDLINE_ARGS	200

#define LONG_CPRIGHT   1
#define SHORT_CPRIGHT  2
#define SCRIPT_CPRIGHT  3


	/* #defines for prog spec array */

#define AUTHORS			0L	/* -authors                */

#define MAN1_LONGDESC		1L       /* -man1_long_description  */
#define MAN1_EXAMPLES		2L	/* -man1_examples          */
#define MAN1_RESTRICTIONS	3L	/* -man1_restrictions      */
#define MAN1_REFERENCES		4L	/* references              */
#define MAN1_SEEALSO		5L	/* -man1_see_also          */

#define USAGEADD		6L	/* -usage_additions        */

#define INCLUDE_INCLUDES	7L	/* -include_includes       */
#define INCLUDE_DEFINES	        8L	/* -include_defines        */
#define INCLUDE_TYPEDEFS        9L	/* -include_typedefs       */
#define INCLUDE_VARIABLES       10L	/* -include_variables      */
#define INCLUDE_MACROS		11L	/* -include_macros         */
#define INCLUDE_ROUTINES	12L	/* -include_routines       */
#define INCLUDE_ADDITIONS	13L	/* -include_additions      */

#define MAIN_VARIABLES		14L	/* -main_variable_list     */
#define MAIN_GETARGS		15L	/* -main_get_args_call     */
#define MAIN_BEFORELIB		16L	/* -main_before_lib_call   */
#define MAIN_LIBCALL		17L	/* -main_library_call      */
#define MAIN_AFTERLIB		18L	/* -main_after_lib_call    */

#define FREEHANDADD		19L	/* -free_handler_additions */

#define LIBRARY_SHORTDESC	20L	/* short lib description   */
#define LIBRARY_LONGDESC	21L	/* long lib description    */
#define LIBRARY_INPUT		22L      /* -library_input          */
#define LIBRARY_OUTPUT		23L      /* -library_output         */
#define LIBRARY_RETURNS		24L      /* -library_returns        */
#define LIBRARY_RESTRICT	25L      /* -library_restrictions   */
#define LIBRARY_VERIFY		26L      /* -library_verify         */
#define LIBRARY_SIDEEFF		27L      /* -library_sideeffects    */
#define LIBRARY_EXAMPLES	28L      /* -library_examples       */
#define LIBRARY_MODS		29L	/* -library_mods           */
#define LIBRARY_HDRDEF		30L	/* -library_hdrdef         */
#define LIBRARY_DEF		31L	/* -library_def            */
#define LIBRARY_CODE		32L	/* -library_code           */
#define LIBRARY_INCLUDES	33L	/* -library_includes       */

#define MAN3_SHORTDESC          34L      /* -man3_shortdesc         */
#define MAN3_LONGDESC           35L      /* -man3_longdesc          */
#define MAN3_ADDINFO            36L      /* -man3_addinfo           */
#define MAN3_SEEALSO            37L      /* -man3_seealso           */
#define MAN3_MANUAL             38L      /* -man3_manual            */

	/* #defines for a toolbox log file */

#define VersionNum		0
#define AuthorsList		1
#define RevisionLog		2
#define LibPath			3
#define BinPath			4
#define LibSearch		5
#define IncSearch		6
#define CompDef			7
#define ToolLibs		8
#define XLibs			9
#define ForLibs			10

        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

#endif /* _kcms_ghost_h_ */
/* Don't add after this point*/
