/*
 * Khoros: $Id: kexpr.h,v 1.4 1996/04/04 22:38:43 fas Exp $
 */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: The Khoros Expression declaration file
   >>>>
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Jan 10, 1993 00:37
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kexpr_kexpr_h_
#define _kexpr_kexpr_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include <kexpr/kevaluate.h>


	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

#define KEXPR_GLOBAL_ID   -1
#define KEXPR_FUNCTION_ID -2
#define KEXPR_CONSTANT_ID -3

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/* routines.c */
int   kexpr_evaluate_generic PROTO((long, char *, int, kaddr, char *));
kaddr kexpr_compile_function PROTO((long, char *, char *));
int   kexpr_execute_function PROTO((kaddr, int, kaddr, char *, kvalist));
int   kexpr_parent_set       PROTO((long, long));
int   kexpr_parent_unset     PROTO((long));
int   kexpr_variables_print  PROTO((long, kfile *));
char  **kexpr_variables_list PROTO((long, int, int *));
char  **kexpr_variables_def  PROTO((long, int *));
int   kexpr_variables_copy   PROTO((long, long));
int   kexpr_variables_clear  PROTO((long));
int   kexpr_variables_reset  PROTO((long));
int   kexpr_variable_delete  PROTO((long, char *));
int   kexpr_variable_add     PROTO((long, char *));

/* private routines */
int   kexpr_evaluate   PROTO((long, klist *));
int   kexpr_set_array  PROTO((long, char *, int, int, kaddr));
kaddr kexpr_get_array  PROTO((long, char *, int *, int *));
klist *kexpr_create    PROTO((long, char *));

#endif /* _kexpr_kexpr_h_ */
/* Don't add after this point */
