/*
 * Khoros: $Id: khash.h,v 1.7 1996/05/30 20:15:50 mirage Exp $
 */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose:  To provide function declarations and
   >>>>			definitions for the kutils hash utilities
   >>>>
   >>>>    Written By:  Mark Young
   >>>>
   >>>>          Date:  Sep 13, 1995
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kutils_khash_h_
#define _kutils_khash_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

        /*-------------------------------------*
        |       defines
        ---------------------------------------*/

        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct
{
	ssize_t  size;
	int      type;
	int     *num;
	kaddr  **table; 
	kaddr  **data; 
} khash;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/


        /*-------------------------------------*
        |       macros
        ---------------------------------------*/


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

khash *khash_init      PROTO((int, ssize_t));
int   khash_add        PROTO((khash *, kvalist));
int   khash_clientdata PROTO((khash *, kvalist));
int   khash_check      PROTO((khash *, kvalist));
int   khash_delete     PROTO((khash *, kvalist));
int   khash_free       PROTO((khash *, void (*routine) PROTO((kaddr))));
unsigned long khash_value PROTO((register const char *, register ssize_t));

#endif /* _kutils_khash_h_ */
/* Don't add after this point. */
