/*
 * Khoros: $Id: kstrings.h,v 1.6 1996/04/04 22:39:09 fas Exp $
 */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose:  To provide function declarations and
   >>>>			definitions for the kutils string utilities
   >>>>
   >>>>    Written By:  Mark Young
   >>>>          Date:  Nov 29, 1992
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kutils_kstrings_h_
#define _kutils_kstrings_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/


        /*-------------------------------------*
        |       macros
        ---------------------------------------*/


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

/* strings.c */
char  *kstrstr		  PROTO((const char *, const char *));
char  *kstrpbrk		  PROTO((const char *, const char *));
char  *kstrtok		  PROTO((char *, const char *));
char  *kstrdup		  PROTO((const char *));
char  *kstrchr		  PROTO((const char *, int));
char  *kstrrchr		  PROTO((const char *, int));
char  *kstrcpy		  PROTO((char *, const char *));
char  *kstrncpy		  PROTO((char *, const char *, size_t));
char  *kstrcat		  PROTO((char *, const char *));
char  *kstrncat		  PROTO((char *, const char *, size_t));
char  *kstring_lower	  PROTO((const char *, char *));
char  *kstring_upper	  PROTO((const char *, char *));
char  *kstring_capitalize PROTO((const char *, char *));
char  *kstring_replace	  PROTO((const char *, const char *, const char *,
				 char *));
char  *kchar_replace	  PROTO((const char *, int, int, char *));
char  *kstring_cleanup	  PROTO((const char *, char *));
char  *kstring_cat	  PROTO((const char *, const char *, char *));
char  *kstring_ncat	  PROTO((const char *, const char *, ssize_t, ssize_t,
				 char *));
char  *kstring_3cat	  PROTO((const char *, const char *, const char *,
				 char *));
int    kstring_subcmp	  PROTO((const char *, const char *));
char  *kstring_copy	  PROTO((const char *, char *));
char  *kstring_ncopy	  PROTO((const char *, size_t, char *));
char  *kstring_detab	  PROTO((const char *, char *));
size_t kstrspn		  PROTO((const char *, const char *));
size_t kstrcspn		  PROTO((const char *, const char *));
size_t kstrlen		  PROTO((const char *));
int    kstrcasecmp	  PROTO((const char *, const char *));
int    kstrncasecmp	  PROTO((const char *, const char *, size_t));
int    kstrcmp		  PROTO((const char *, const char *));
int    kstrncmp		  PROTO((const char *, const char *, size_t));

#endif /* _kutils_kstrings_h_ */
/* Don't add after this point. */
