 /*
  * Khoros: $Id: kgenstruct.h,v 1.15 1996/07/05 01:33:24 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kgenstruct
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kgenstruct_h_
#define _kgenstruct_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <bootstrap.h>

/* -include_includes */
#include "rpc_parse.h"
#include "rpc_scan.h"
#include "rpc_util.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$BOOTSTRAP/objects/kroutine/kgenstruct/uis/kgenstruct.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  structure specification (required infile)
 */
char	*x_file;	/* structure specification FILENAME */
int	 x_flag;	/* structure specification FLAG */

/*----- optional MI group ----*/
/*
 *  Toolbox to run kgenstruct on (optional string)
 */
char	*tb_string;	/* Toolbox to run kgenstruct on STRING */
int	 tb_flag;   	/* Toolbox to run kgenstruct on FLAG */

/*
 *  Object name to run kgenstruct on (optional string)
 */
char	*oname_string;	/* Object name to run kgenstruct on STRING */
int	 oname_flag;   	/* Object name to run kgenstruct on FLAG */

/*-- optional MI group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void kgenstruct_get_args PROTO((kform *));
void kgenstruct_usage_additions PROTO((void));
void kgenstruct_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/*-- rpc_cout.c --*/
void emit_definition PROTO((definition *));

/*-- rpc_hout.c --*/
void print_datadef PROTO((definition *));

/*-- rpc_main.c --*/
void c_output PROTO((char *, kobject));
void h_output PROTO((char *, kobject));

/*-- rpc_parse.c --*/
definition *get_definition PROTO((void));

/*-- rpc_scan.c --*/
void generate_directives PROTO((int));

void scan      PROTO((tok_kind, token *));
void scan2     PROTO((tok_kind, tok_kind, token *));
void scan3     PROTO((tok_kind, tok_kind, tok_kind, token *));
void scan_num  PROTO((token *));
void peek      PROTO((token *));
int  peekscan  PROTO((tok_kind, token *));
void get_token PROTO((token *));

/*-- rpc_util.c --*/
void  reinitialize   	 PROTO((void));
int   streq          	 PROTO((char *, char *));
char *findval        	 PROTO((list *, kaddr, kfunc_int));
void  storeval       	 PROTO((list **, kaddr));
char *fixtype        	 PROTO((char *));
definition  *resolve_type       PROTO((char *, char *));
declaration *resolve_typedef    PROTO((declaration *));
char *stringfix      	 PROTO((char *));
void  ptype          	 PROTO((char *, char *, int));
int   is_structure   	 PROTO((char *));
int   is_c_type      	 PROTO((char *));
int   is_typedef_c_type  PROTO((definition *def));
int   is_typedef_pointer PROTO((definition *def));
int   is_typedef_array   PROTO((definition *def));
void  pvname         	 PROTO((char *, char *));
void  error          	 PROTO((char *));
void  expected1      	 PROTO((tok_kind));
void  expected2      	 PROTO((tok_kind, tok_kind));
void  expected3      	 PROTO((tok_kind, tok_kind, tok_kind));
void  tabify         	 PROTO((kfile *, int));
      
char *type_name      	 PROTO((char *));
void pkhoros_hhdr PROTO((char *, kobject, kstring, kstring));
void pkhoros_chdr PROTO((char *, kobject, kstring, kstring));
/* -include_routines_end */

#endif
