/*
 * Khoros: $Id: Tli.c,v 1.8 1996/05/30 20:26:46 mirage Exp $
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: Tli.c,v 1.8 1996/05/30 20:26:46 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Transport Layer Interface Routines
   >>>>		
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"


#if !defined(KTLI_DEF)
TransportInformation tli_transport[] = { {NULL} };
#else

#include <tiuser.h>

static int tli_tempnam	   PROTO((const char *, const char *, char *));
static int tli_open	   PROTO((const char *, int, int, kfile *));
static int tli_close	   PROTO((kfile *));
static ssize_t tli_read	   PROTO((kfile *, char *, int));
static ssize_t tli_write   PROTO((kfile *, char *, int));
static int tli_unlink	   PROTO((char *, char *));
static int tli_lock	   PROTO((kfile *, int));
static int tli_descriptors PROTO((kfile *, int *, int *));

TransportInformation tli_transport[] =
{
    {
	"Transport Layer Interface (sysV)",
	"tli",
	FALSE,
	tli_tempnam,
	tli_open,
	tli_close,
	tli_read,
	tli_write,
	NULL,
	NULL,
	tli_unlink,
	tli_lock,
	tli_descriptors,
    }
};

/*
 *  Internal resource structures for "Transport Layer Interface (sysV)"
 *  transport
 */
typedef struct
{
	int	dummy; /* make compiler happy */
} ResourceStruct;


/*-------------------------------------------------------------------*
|  
|		  Private Transport Layer Interface Routines
|  
--------------------------------------------------------------------*/


#endif  /* KTLI_DEF */
/* don't add after the endif */
