/*
 * Khoros: $Id: khoros.c,v 1.20 1996/08/14 01:00:00 fas Exp $
 */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

static char *CopyRight[] =
{
"",
"                       KHOROS USE LICENSE ",
"",
"ACCEPTANCE ",
"Please read this license agreement before using Khoros. Do not use,",
"copy, or distribute this software until you have read and agreed to the",
"Terms and Conditions of this License Agreement. This is a contract with",
"important legal consequences. You, as the Licensee, agree to the Terms",
"and Conditions of this agreement by using, copying, or distributing",
"this software.",
"",
"REGISTRATION ",
"Please register your license with Khoral Research, Inc. (KRI). If",
"you do not have an attached registration form, execute the Khoros",
"program xvregister, or request a registration form from KRI. Completed",
"registration forms can be sent to KRI via email, postal mail or FAX.",
"",
"DEFINITIONS ",
"\"Khoros Software\" is defined to include source code, object code,",
"executables, libraries, user interface specifications, and documentation",
"of Khoros, all of which is owned by KRI. Khoros also includes components",
"that are not owned by KRI; these components are clearly marked and",
"contain the owner's notices.",
"",
"\"Loaded\" is defined to mean combining object code to form an executable.",
"",
"RIGHT TO REDISTRIBUTE ",
"Permission to distribute this Software using electronic media and at no",
"cost is granted, provided that the Software contains no modifications,",
"provided that the distribution is not assigned any price or value in any",
"way, provided that the distribution is not combined with any product",
"or service in any way, and provided that the distributed Software is",
"identical to the Software that is currently being distributed at no cost",
"via computer network (File Transfer Protocal or World Wide Web) by KRI.",
"",
"DERIVATIVE WORKS ",
"Permission to prepare derivative works or to modify the Khoros Software",
"for internal use only is granted to Licensee. However, all rights to",
"such modifications and derivative works, including all copyrights, are",
"the property of KRI. New software developed by Licensee as a result of",
"using the Khoros Software belongs to the author and is not bound by this",
"license agreement. However, any Khoros Software that is Loaded with the",
"author's software is bound by this license agreement.",
"",
"LICENSEE AGREES ",
"By distributing the Khoros Software, the Licensee agrees to abide by",
"the copyright law and all other applicable laws of the U.S. and foreign",
"countries, including, but not limited to, export control laws, and the",
"terms of this license.",
"",
"TERMINATION ",
"KRI shall have the right to terminate this license immediately by written",
"notice upon Licensee's breach of, or non-compliance with, any of the terms",
"of this license. Upon termination of this License Agreement, Licensee",
"shall remove all copies of the Khoros Software. Licensee may be held",
"legally responsible for any copyright infringement that is caused or",
"encouraged by Licensee's failure to abide by the terms of this license.",
"",
"GOVERNMENT USE RIGHTS ",
"Use, duplication, or disclosure by the U.S. Government is subject to",
"restrictions set forth in subparagraphs (a) through (d) of the Commercial",
"Computer Restricted Rights clause of FAR 52.227-19 when applicable, or",
"in the Commercial Computer Software paragraph in DFARS 227-7202, and in",
"similar clauses in the NASA FAR Supplement.",
"",
"ADDITIONAL RIGHTS AND CONSORTIUM MEMBERSHIP ",
"No additional rights or Khoros Consortium membership are granted.",
"For more information on additional rights and Khoros Consortium",
"membership, contact KRI at the address below.",
"",
"ENTIRE AGREEMENT ",
"This License Agreement constitutes the entire agreement between KRI and",
"Licensee and may be amended or changed only by written agreement signed",
"by both parties. This License Agreement is governed by the laws of the",
"State of New Mexico.",
"",
"DISCLAIMER OF WARRANTY ",
"THIS SOFTWARE IS PROVIDED BY KRI \"AS IS\" AND ANY EXPRESS OR IMPLIED",
"WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF",
"MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, ARE DISCLAIMED. IN",
"NO EVENT SHALL KRI BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,",
"SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED",
"TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR",
"PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF",
"LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING",
"NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS",
"SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.",
"",
"QUESTIONS AND INFORMATION",
"If you have any questions concerning this license agreement, the",
"copyright, or trademarks, please contact KRI via electronic mail at",
"info@khoral.com or via postal mail at Khoral Research, Inc., 6001 Indian",
"School Road N.E., Suite 200, Albuquerque, NM 87110.",
"",
"COPYRIGHT NOTICE ",
"\"Copyright 1993-1996 Khoral Research, Inc. (KRI), All Rights Reserved.\"",
"Licensee can not remove or obscure any of the copyright or trademark",
"notices in this software. \"Khoros\" is a registered trademark of Khoral",
"Research, Inc. Cantata, Composer, Craftsman, Guise, and Xprism",
"are trademarks of KRI.",
"",
"Khoral Research, Inc.  ",
"6001 Indian School Rd, NE Suite 200 ",
"Albuquerque, NM 87110 USA",
""
};

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Khoros Initialization Routine
   >>>>		
   >>>>   Public:
   >>>>                 khoros_imprint()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"
static size_t num_lines = knumber(CopyRight);


/************************************************************
*
*  Routine Name: khoros_imprint - imprint the khoros toolbox
*
*       Purpose: Imprint information about the user into the
*                khoros toolbox.
*
*         Input: 
*        Output:
*       Returns:
*
*  Restrictions:
*    Written By: Mark Young
*          Date: Oct 23, 1993
*      Verified:
*  Side Effects:
* Modifications:
*
*************************************************************/

int khoros_imprint(void)
{
	char  *library = "kutils";
	char  *routine = "khoros_imprint";
        char  register_command[KLENGTH];
        char  *tb_path;
        char  *calling_program_name;
        int   registration_status = FALSE;
        int   license_status = FALSE;
	int   called_xvregister = FALSE;

        /*-------------------------------------------------------------------
        |  This routine 'khoros_imprint' is called from 'xvw_init_display'
        |  which is in turn called from 'xvw_initalize'.  All khoros
        |  xvroutines called 'xvw_initialize' and since the registration
        |  program 'xvregister' is an xvroutine, we don't want it recursively
        |  checking if the user is registered.
        |
        |  A static global variable called re_enter_check is used to manage
        |  re-entrant code by xvroutines that don't really need to check
        |  whether the user is registered.  By default, the variable is
        |  set to FALSE and then set to TRUE inside so that the next time
        |  the code is re-entered by 'xvregester', it will be true and the
        |  routine will simply return.
        -------------------------------------------------------------------*/
        calling_program_name = kprog_get_program();
        if (kstrcmp(calling_program_name, "xvregister") == 0 ||
            kstrcmp(calling_program_name, "khelp") == 0      ||
            kstrcmp(calling_program_name, "klicense") == 0   ||
            kgetenv("khoros_registration") != NULL)
           return(TRUE);


        /*-------------------------------------------------------------------
        |  Next, we need to check and see if the user is currently registerd.
        |  Thus, we call 'verify_registration' which returns TRUE if the
        |  user has registered or FALSE if the user has not registered.  If
        |  the user is un-registered, then the xvroutine 'xvregister' is
        |  called to allow the user to register their version of Khoros.
        |  If the ksystem should fail, we report the error and treat the
        |  the user as un-registered.
        -------------------------------------------------------------------*/
        if (!verify_khoros_dotfile() || 
            (registration_status = verify_registration()) != TRUE)
	{
	   tb_path = kfullpath("$DESIGNBIN/xvregister", NULL, NULL);
	   ksprintf(register_command, "%s", tb_path);
	   if (ksystem (register_command) != 0)
	   {
              if ((registration_status = verify_registration()) != TRUE &&
                  (license_status = verify_licensed()) == TRUE)
              {
                 kerror(routine,library,
                        "Unable to system off Khoros registration program "
                        "'xvregister' or error occured in 'xvregister'. Your "
			"version of Khoros is being treated as 'unregistered'.");
	         return(TRUE);
              }
              else if (license_status != TRUE)
              {
                 kerror(routine,library,
			"Your version of Khoros is not licensed. You cannot "
                        "run Khoros interactive applications without agreeing "
			"to the license agreement.");
	         return(display_license(license_status));
              }
           }
           called_xvregister = TRUE;
           kputenv("khoros_registration=posted");
        }

        if ((license_status = verify_licensed()) != TRUE)
        {
           kerror(routine,library,
		  "Your version of Khoros is not licensed. You cannot run "
                  "Khoros interactive applications without agreeing to the "
		  "license agreement.");
	   return(display_license(license_status));
        }

        return(TRUE);
}

int display_license(
	int license_status)
{
	int   continue_application = FALSE;
        int   agreed_to_license = FALSE;
	int   set_license = FALSE;
	int   set_registration;
	int   khoros_imprint_status;

	agreed_to_license = show_license();

	if (license_status == NOT_CURRENT_VERSION &&
	    agreed_to_license == FALSE) 
	   set_license = KEEP_OLD_LIC_FIELD;

	if (license_status == TRUE)
	{
	   set_license = KEEP_OLD_LIC_FIELD;
	   continue_application = TRUE;
	}
	else if (license_status != TRUE && agreed_to_license == TRUE)
	{
	   set_license = LICENSED;
	   continue_application = TRUE;
	}
	else if (license_status != TRUE && 
	         license_status != NOT_CURRENT_VERSION &&
	         agreed_to_license == FALSE)
	{
	   set_license = UNLICENSED;
	}

	set_registration = KEEP_OLD_REG_FIELD;

	khoros_imprint_status = 
	   update_khoros_dotfile(set_license, set_registration);

	return(inform_user(khoros_imprint_status));
}

/*-----------------------------------------------------------
|
|  Routine Name: verify_khoros_dotfile -
|
|       Purpose:
|
|         Input:
|        Output:
|       Returns:
|
|  Restrictions:
|    Written By: John M. Salas & Becky Bishop
|          Date: Mar 15, 1996
|      Verified:
|  Side Effects:
| Modifications:
|
-----------------------------------------------------------*/

int verify_khoros_dotfile(void)
{
   char 	*dot_file_fp;
   
   dot_file_fp = kfullpath("~/.khoros", NULL, NULL);
   if (!kaccess(dot_file_fp, F_OK))
   {
      kfree(dot_file_fp);
      return(TRUE);
   }
   kfree(dot_file_fp);
   return(FALSE);
}

/*-----------------------------------------------------------
|
|  Routine Name: verify_registration -
|
|       Purpose:
|
|         Input:
|        Output:
|       Returns:
|
|  Restrictions:
|    Written By: John M. Salas & Becky Bishop
|          Date: Mar 15, 1996
|      Verified:
|  Side Effects:
| Modifications:
|
-----------------------------------------------------------*/

int verify_registration(void)
{
	char   vers[80];
	char   buffer[KLENGTH];
	char   reg_buffer[20];
	char   ver_buffer[20];
        kfile  *file_fp;
	char   registration_string[80];
	int    registered = FALSE;
	int    keep_parsing = TRUE;

    	if ((file_fp = kfopen("~/.khoros", "r")) == NULL) return (-1);

	ksprintf(vers,"%d.%d", 
		 KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);

	ksprintf(registration_string,
	   "(\\[UN\\])?REGISTERED\\s+-\\s+(.*version\\s+(.*))$");
        while (kfgets(buffer, KLENGTH, file_fp) != NULL && keep_parsing)
        {
	   kre_comp(registration_string);
	   if (kre_exec(buffer))
	   {
	      keep_parsing = FALSE;
	      kre_subs("\\1", reg_buffer);
              kre_subs("\\3", ver_buffer);
	      if (kstrcmp(reg_buffer,"[UN]") != 0 && 
	          kstrcmp(ver_buffer, vers) == 0)
	         registered = TRUE;
	      else if (kstrcmp(reg_buffer, "[UN]") != 0 &&
                       kstrcmp(ver_buffer, vers)   != 0 &&
	               kstrlen(ver_buffer) > 0)
                 registered = NOT_CURRENT_VERSION;
	      else if (kstrcmp(reg_buffer, "[UN]") == 0)
                 registered = FALSE;
	   }
 	}
	kfclose(file_fp);
        return(registered);
}

/*-----------------------------------------------------------
|
|  Routine Name: verify_licensed - 
|
|       Purpose: 
|
|         Input:
|        Output:
|       Returns:
|
|  Restrictions:
|    Written By: John M. Salas & Becky Bishop
|          Date: Mar 15, 1996
|      Verified:
|  Side Effects:
| Modifications:
|
-----------------------------------------------------------*/

int verify_licensed(void)
{
	char   vers[80];
	char   buffer[KLENGTH];
	char   lic_buffer[20];
	char   ver_buffer[20];
        kfile  *file_fp;
	char   licensed_string[100];
	int    licensed = FALSE;
	int    keep_parsing = TRUE;

    	if ((file_fp = kfopen("~/.khoros", "r")) == NULL) return (-1);

	ksprintf(vers,"%d.%d", 
		 KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);

        while (kfgets(buffer, KLENGTH, file_fp) != NULL && keep_parsing)
        {

	   ksprintf(licensed_string,
		"(\\[UN\\])?LICENSED\\s+-\\s+(.*version\\s+(.*))$");

	   kre_comp(licensed_string);
	   if (kre_exec(buffer))
	   {
	      keep_parsing = FALSE;
	      kre_subs("\\1", lic_buffer);
	      kre_subs("\\3", ver_buffer);
	      if (kstrcmp(lic_buffer,"[UN]") != 0 && 
		  kstrcmp(ver_buffer, vers) == 0)
	         licensed = TRUE;
	      else if (kstrcmp(lic_buffer, "[UN]") != 0 &&
                       kstrcmp(ver_buffer, vers)   != 0 &&
	               kstrlen(ver_buffer) > 0)
                 licensed = NOT_CURRENT_VERSION;
	      else if (kstrcmp(lic_buffer, "[UN]") == 0)
                 licensed = FALSE;
	   }
 	}
	kfclose(file_fp);
        return(licensed);
}

/*-----------------------------------------------------------
|
|  Routine Name: update_khoros_dotfile - 
|
|       Purpose: 
|
|         Input:
|        Output:
|       Returns:
|
|  Restrictions:
|    Written By: John M. Salas & Becky Bishop
|          Date: Mar 26, 1996
|      Verified:
|  Side Effects:
| Modifications:
|
-----------------------------------------------------------*/
int update_khoros_dotfile(int set_license, int set_registration)
{
        kfile           *file_fp;
	kfile		*tmp_fp;
	time_t          timeval;
	struct tm       *tmval;
	struct passwd   *passwd_ent;
	char            *tmp, *domain, *tmp_file;
	char            temp[KLENGTH], name[KLENGTH], date[KLENGTH];
	char		buffer[KLENGTH], buffer_temp[KLENGTH];
	char		vers[KLENGTH];
	char		registration_string[KLENGTH];
	char		licensed_string[KLENGTH];
	char		reg_lic_string[KLENGTH];
	int		old_reg_file = TRUE;

	if (kgethostname(name, KLENGTH) == 0)
	{
	   if ((tmp = kstrchr(name, '.')) != NULL)
	      domain = ++tmp;
	   else
	      domain = name;
	}
	else
	   domain = "UnknownDomainName";

	passwd_ent = getpwuid(getuid());
	(void) ksprintf(temp, "%s@%s", passwd_ent->pw_name, domain);
	timeval = time(NULL);
	tmval = localtime(&timeval);
	kstrftime(date, (size_t) KLENGTH, "%h %d, 19%y %H:%M", tmval);

 	ksprintf(vers, "%d.%d", KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);

 	if (!verify_khoros_dotfile())
        {
           /* create the file for the first time */

	   if ((file_fp = kfopen("~/.khoros", "w")) == NULL)
              return(CANNOT_CREATE_NEW_DOT_FILE);
	   else
	   {
	      kfprintf(file_fp, "%s:\n", temp);
	      if (set_registration == REGISTERED)
	         kfprintf(file_fp, "REGISTERED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	      else if (set_registration == UNREGISTERED)
	         kfprintf(file_fp, "[UN]REGISTERED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	      else if (set_registration == KEEP_OLD_REG_FIELD)
	         kfprintf(file_fp, "%s\n", buffer);

	      if (set_license == LICENSED)
	         kfprintf(file_fp, "LICENSED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	      else if (set_license == UNLICENSED)
	         kfprintf(file_fp, "[UN]LICENSED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	      else if (set_license == KEEP_OLD_LIC_FIELD)
	         kfprintf(file_fp, "%s\n", buffer);
	      kfclose(file_fp);
              return(TRUE);
           }
	}
        else
        {
           int seen_registration_line = FALSE;
           int seen_license_line = FALSE;

	   if (kaccess("~/.khoros", W_OK) != 0)
              return (CANNOT_WRITE_EXISTING_DOT_FILE);

    	   if ((file_fp = kfopen("~/.khoros", "r")) == NULL)
              return (CANNOT_READ_EXISTING_DOT_FILE);

 	   tmp_file = ktempnam("file", "dot_file");
	   tmp_file = kstrchr(tmp_file, '=');
	   tmp_file++;

	   if ((tmp_fp = kfopen(tmp_file, "w")) == NULL)
	      return(CANNOT_OPEN_TEMP_DOTFILE);

	   kfprintf(tmp_fp, "%s:\n", temp);

	   ksprintf(registration_string,
	        "(\\[UN\\])?REGISTERED\\s+-\\s+(.*version\\s+(.*))$");
	   ksprintf(licensed_string,
	        "(\\[UN\\])?LICENSED\\s+-\\s+(.*version\\s+(.*))$");
	   ksprintf(reg_lic_string,
	       "(\\[UN\\])?(REGISTERED|LICENSED)\\s+-\\s+(.*version\\s+(.*))$");
	   ksprintf(vers, "%d.%d", 
		    KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);

	   while (kfgets(buffer, KLENGTH, file_fp))
	   {
	      ksprintf(buffer_temp, "%s", buffer);

              kre_comp(reg_lic_string);
              if (kre_exec(buffer_temp))
              {
		 old_reg_file = FALSE;
	         kre_comp(registration_string);
	         if (kre_exec(buffer_temp))
	         {
		    if (set_registration == REGISTERED)
		    {
	               kfprintf(tmp_fp, "REGISTERED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
		    }
		    else if (set_registration == UNREGISTERED)
		    {
	               kfprintf(tmp_fp, "[UN]REGISTERED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
		    }
                    else if (set_registration == KEEP_OLD_REG_FIELD)
                    {
		       kfprintf(tmp_fp, buffer);
                    }
		    seen_registration_line = TRUE;
	         }

                 kre_comp(licensed_string);
	         if (kre_exec(buffer_temp))
	         {
		    if (set_license == LICENSED)
		    {
	               kfprintf(tmp_fp, "LICENSED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
		    }
		    else if (set_license == UNLICENSED)
		    {
	               kfprintf(tmp_fp, "[UN]LICENSED - %s version %d.%d\n",
		          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
		    }
                    else if (set_license == KEEP_OLD_LIC_FIELD)
                    {
		       kfprintf(tmp_fp, buffer);
                    }
                    seen_license_line = TRUE;
	         }
	      }
           }
           if (!seen_registration_line)
           {
              if (set_registration == REGISTERED)
                 kfprintf(tmp_fp, "REGISTERED - %s version %d.%d\n",
                          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
              else if (set_registration == UNREGISTERED)
                 kfprintf(tmp_fp, "[UN]REGISTERED - %s version %d.%d\n",
                          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
           }
           if (!seen_license_line)
           {
              if (set_license == LICENSED)
                 kfprintf(tmp_fp, "LICENSED - %s version %d.%d\n",
                          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
              else if (set_license == UNLICENSED)
                 kfprintf(tmp_fp, "[UN]LICENSED - %s version %d.%d\n",
                          date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
           }

	   kfclose(tmp_fp);
	   kfclose(file_fp);
	   krename(tmp_file,"~/.khoros");
	   return(TRUE);
	}
}

/*-----------------------------------------------------------
|
|  Routine Name: show_license - 
|
|       Purpose: 
|
|         Input:
|        Output:
|       Returns:
|
|  Restrictions:
|    Written By: John M. Salas & Becky Bishop
|          Date: Mar 26, 1996
|      Verified:
|  Side Effects:
| Modifications:
|
-----------------------------------------------------------*/

int show_license(void)
{
        static char *copyright = NULL;

        copyright = karray_to_string(CopyRight, KSTRING, num_lines, "\n");
        if (kprompt(KFORCE, NULL, NULL, TRUE, 
	            "Do You Agree To Abide By These Conditions?\n\n%s",
		     copyright))
           return(TRUE);
     
 	return(FALSE);
}

/*-----------------------------------------------------------
|
|  Routine Name: get_reg_ver - 
|
|       Purpose: 
|
|         Input:
|        Output:
|       Returns:
|
|  Restrictions:
|    Written By: John M. Salas & Becky Bishop
|          Date: Mar 26, 1996
|      Verified:
|  Side Effects:
| Modifications:
|
-----------------------------------------------------------*/

char *get_reg_ver(void)
{
	kfile	*file_fp;
	char	vers[KLENGTH];
	char	registration_string[KLENGTH];
	char	buffer[KLENGTH];
	char	ver_buffer[KLENGTH];
	int	keep_parsing = TRUE;
	char	*registration_version = NULL;
	
    	if ((file_fp = kfopen("~/.khoros", "r")) == NULL) return (NULL);

	ksprintf(vers,"version %d.%d", 
		 KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);

	ksprintf(registration_string,
	   "(\\[UN\\])?REGISTERED\\s+-\\s+(.*version\\s+(.*))$");
        while (kfgets(buffer, KLENGTH, file_fp) != NULL && keep_parsing)
        {
	   kre_comp(registration_string);
	   if (kre_exec(buffer))
	   {
	      keep_parsing = FALSE;
              kre_subs("\\3", ver_buffer);
	      if (kstrlen(ver_buffer) > 0)
	         registration_version = kstrdup(ver_buffer);
	   }
 	}
	kfclose(file_fp);
	return(registration_version);
}
/*-----------------------------------------------------------
|
|  Routine Name: get_lic_ver - 
|
|       Purpose: 
|
|         Input:
|        Output:
|       Returns:
|
|  Restrictions:
|    Written By: John M. Salas & Becky Bishop
|          Date: Mar 26, 1996
|      Verified:
|  Side Effects:
| Modifications:
|
-----------------------------------------------------------*/

char *get_lic_ver(void)
{
	kfile	*file_fp;
	char	vers[KLENGTH];
	char	licensed_string[KLENGTH];
	char	buffer[KLENGTH];
	char	ver_buffer[KLENGTH];
	int	keep_parsing = TRUE;
	char	*licensed_version = NULL;
	
    	if ((file_fp = kfopen("~/.khoros", "r")) == NULL) return (NULL);

	ksprintf(vers,"version %d.%d", 
		 KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);

	ksprintf(licensed_string,
	   "(\\[UN\\])?REGISTERED\\s+-\\s+(.*version\\s+(.*))$");
        while (kfgets(buffer, KLENGTH, file_fp) != NULL && keep_parsing)
        {
	   kre_comp(licensed_string);
	   if (kre_exec(buffer))
	   {
	      keep_parsing = FALSE;
              kre_subs("\\3", ver_buffer);
	      if (kstrlen(ver_buffer) > 0)
	         licensed_version = kstrdup(ver_buffer);
	   }
 	}
	kfclose(file_fp);
	return(licensed_version);
}

int create_khoros_dotfile(int registration_status, int licensed_status)
{
        kfile           *file_fp;
	time_t          timeval;
	struct tm       *tmval;
	struct passwd   *passwd_ent;
	char            *tmp, *domain;
	char            temp[KLENGTH], name[KLENGTH], date[KLENGTH];

    	if ((file_fp = kfopen("~/.khoros", "w")) == NULL) 
           return (FALSE);

	if (kgethostname(name, KLENGTH) == 0)
	{
	   if ((tmp = kstrchr(name, '.')) != NULL)
	      domain = ++tmp;
	   else
	      domain = name;
	}
	else
	   domain = "UnknownDomainName";

	passwd_ent = getpwuid(getuid());
	(void) ksprintf(temp, "%s@%s", passwd_ent->pw_name, domain);
	timeval = time(NULL);
	tmval = localtime(&timeval);
	kstrftime(date, (size_t) KLENGTH, "%h %d, 19%y %H:%M", tmval);

	kfprintf(file_fp, "%s:\n", temp);

	if (registration_status)
	   kfprintf(file_fp, "REGISTERED - %s version %d.%d\n",
                    date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	else
	   kfprintf(file_fp, "[UN]REGISTERED - %s version %d.%d\n",
                    date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	if (licensed_status)
	   kfprintf(file_fp, "LICENSED - %s version %d.%d\n",
                    date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	else
	   kfprintf(file_fp, "[UN]LICENSED - %s version %d.%d\n",
                    date, KHOROS_RELEASE_VERSION, KHOROS_RELEASE_MAJOR);
	return(TRUE);
}

/*-----------------------------------------------------------
|
|  Routine Name: inform_user - informs the user of the status of their license
|                              registration
|
|       Purpose:
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE if success
|       	 FALSE if failure
|
|    Written By: John M. Salas
|          Date: August 11, 1996
| Modifications:
|
------------------------------------------------------------*/
int inform_user(
        int xvregister_status)
{
   int set_registration, set_license;

   set_registration = verify_registration();
   set_license = verify_licensed();

   if (xvregister_status == CANNOT_CREATE_NEW_DOT_FILE)
   {
      kerror("kutils", "inform_user",
             "Unable to update your registration.  Please verfiy that "
             "the permissions to $HOME are writable.");
      return(FALSE);
   }
   else if (xvregister_status == CANNOT_WRITE_EXISTING_DOT_FILE)
   {
      kerror("kutils", "inform_user",
             "You have an existing registration in your home file "
             "'~/.khoros', that is not writable.  Add write permissions "
             "to this file.");
      return(FALSE);
   }
   else if (xvregister_status == CANNOT_READ_EXISTING_DOT_FILE)
   {
      kerror("kutils", "inform_user",
             "You have an existing registration in your home file "
             "'~/.khoros', that is not readable.  Add read permissions "
             "to this file.");
      return(FALSE);
   }
   else if (xvregister_status == CANNOT_OPEN_TEMP_DOTFILE)
   {
      kerror("kutils", "inform_user",
             "Unable to open a temporary file for updating your Khoros "
             "registration.  Please ensure that your $TMPDIR variable "
             "is set to point to writable temporary space.");
      return(FALSE);
   }
   else
   {
      if (set_registration == -1 || set_license == -1)
      {
         kinfo(KFORCE,
               "You have an existing registration in your home file "
               "'~/.khoros', that is not readable.  Add read permissions "
               "to this file.");
         return(FALSE);
      }
      else if (set_registration == TRUE && set_license == TRUE)
         kinfo(KFORCE,
	       "Thank you for registering and licensing your "
               "version of Khoros!!");
      else if (set_license == TRUE && set_registration != TRUE)
         kinfo(KFORCE,
               "Your version of Khoros is LICENSED but not REGISTERED. "
               "The next time you run an interactive Khoros application, "
               "you will be prompted to register your version of Khoros.");
      else if (set_license != TRUE && set_registration != TRUE)
      {
         kinfo(KFORCE,
               "Your version of Khoros is not LICENSED or REGISTERED. "
               "You cannot run Khoros interactive applications without "
               "agreeing to the license agreement.");
         return(FALSE);
      }
      else if (set_license != TRUE && set_registration == TRUE)
      {
         kinfo(KFORCE,
               "Your version of Khoros is not LICENSED or but is REGISTERED. "
               "You cannot run Khoros interactive applications without "
               "agreeing to the license agreement.");
         return(FALSE);
      }
   }
   return(TRUE);
}

