#!/bin/sh

#
# Khoros: $Id: kversion.sh,v 1.2 1996/08/10 03:15:24 mirage Exp $
#

# Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.


#************************************************************
#
#  Routine Name: kversion - This script will print out the version of Khoros
#                           stuff
#
#       Purpose: This script will print out the version of Khoros,
#		 toolboxes and objects 
#
#         Input:
#
#    Written By: John M. Salas
#          Date: May 29, 1996
# Modifications: Added -date, -name and -version July 22, 1996
#                JMAS and TK
#
#************************************************************/

tb=""
oname=""
versiononly=0
nameonly=0
dateonly=0

while [ x"$1" != x ]; do
    case $1 in
        -tb)
            tb=$2
            shift
            shift
            ;;

        -oname)
            oname=$2
            shift
            shift
            ;;

        -version)
            versiononly=1
            shift
            ;;

        -name)
            nameonly=1
            shift
            ;;

        -date)
            dateonly=1
            shift
            ;;

        -U)
            echo ""
	    echo "Usage for kversion: This script will print out the version of Khoros"
            echo ""
            echo "  [-tb]       (string) toolbox name"
            echo "              (default = {none})"
            echo "  [-oname]    (string) Program or Library Object Name"
            echo "              (default = {none})"
            echo "  [-date]     (flag) Display the date only"
	    echo "              ignored if -tb and/or -oname specified"
            echo "  [-name]     (flag) Display the name only"
	    echo "              ignored if -tb and/or -oname specified"
            echo "  [-version]  (flag) Display the numerical version only"
	    echo "              ignored if -tb and/or -oname specified"
            echo ""
            exit 0

            ;;
        *)
            shift
            ;;
    esac
done

if [ "$oname" != "" -a "$tb" != "" ]; then

    kecho -echo version -tb $tb -oname $oname
    exit $?

elif [ "$oname" != "" -a "$tb" = "" ]; then

    echo ""
    echo "Must specify -tb if -oname specified."
    echo ""
    exit 1

elif [ "$tb" != "" ]; then

    kecho -echo version -tb $tb
    exit $?

else

    filetoparse=`kecho -echo path -tb bootstrap`/include/bootstrap.h

    if [ ! -f "$filetoparse" ]; then
       echo ""
       echo "Can not find file with Khoros version information."
       echo ""
       exit 1
    fi

    name=`grep KHOROS_RELEASE_NAME $filetoparse | awk -F\" '{print $2}'`
    date=`grep KHOROS_RELEASE_DATE $filetoparse | awk -F\" '{print $2}'`
    version=`grep KHOROS_RELEASE_VERSION $filetoparse | awk '{print $NF}'`
    major=`grep KHOROS_RELEASE_MAJOR $filetoparse | awk '{print $NF}'`
    minor=`grep KHOROS_RELEASE_MINOR $filetoparse | awk '{print $NF}'`

    if [ $versiononly = 1 ]; then
       echo "$version.$major.$minor"
    elif [ $nameonly = 1 ]; then
       echo "$name"
    elif [ $dateonly = 1 ]; then
       echo "$date"
    else
       echo "$name $version.$major.$minor ($date)"
    fi
fi

exit 0

