#include "bootstrap.h"
 
void main(
   int  argc,
   char *argv[])
{
	FILE  *outfile1;
	kfile *infile, *outfile2;

	ssize_t size;
	int     num1, num2;
	char    buf[KLENGTH], kpath[KLENGTH], temp[KLENGTH], filename[KLENGTH];
	char   *out1, *out2, *path;


	if (argc > 1)
	   path = kfullpath(argv[1], NULL, filename);
	else
	   kexit(KEXIT_FAILURE);

	kremote_file("$KHOROS_TESTHOST", path, kpath);
	if ((infile = kfopen(kpath, "r")) == NULL)
	   kexit(KEXIT_FAILURE);

	out1 = ktempnam(NULL, "test"); out2 = ktempnam(NULL, "test");
	if ((outfile1 = fopen(out1, "w"))  == NULL ||
	    (outfile2 = kfopen(out2, "w")) == NULL)
	{
	   kexit(KEXIT_FAILURE);
	}
	setvbuf(outfile1, buf, _IOFBF, (size_t) KLENGTH);

        do
        {
           size = kfread(temp, (size_t) 1, (size_t) KLENGTH, infile);
	   if (size <= 0) break;

           num1 = fwrite(temp, (size_t) 1, (size_t) size, outfile1);
           num2 = kfwrite(temp, (size_t) 1, (size_t) size, outfile2);
	   if (num1 != num2)
	   {
	      kfprintf(kstderr,"Wrote different number of bytes '%d' & '%d'!\n",
			num1, num2);
	      kunlink(out1); kunlink(out2);
              kexit(KEXIT_FAILURE);
	   }
        } while (num1 != 0 && num2 != 0);
	kfclose(infile);
	fclose(outfile1); kfclose(outfile2);

	if (kcomparefile(out1, out2, (size_t) 0, NULL) != 0)
	{
	   kfprintf(kstderr,"Comparison of output files '%s' & '%s' failed!\n",
			out1, out2);
	   kunlink(out1); kunlink(out2);
	   kexit(KEXIT_FAILURE);
	}
	kunlink(out1); kunlink(out2);
	kprintf("Success!\n");
	kexit(KEXIT_SUCCESS);
}
