#include "bootstrap.h"
 
void main(
   int  argc,
   char *argv[])
{
	int     infid, outfid1, outfid2;
	ssize_t size, num1, num2;
	char    kpath[KLENGTH], temp[KLENGTH], filename[KLENGTH];
	char   *out1, *out2, *path;


	if (argc > 1)
	   path = kfullpath(argv[1], NULL, filename);
	else
	   kexit(KEXIT_FAILURE);

	kremote_file("$KHOROS_TESTHOST", path, kpath);
	if ((infid = kopen(kpath,  O_RDONLY, 0666)) == -1)
	   kexit(KEXIT_FAILURE);

	out1 = ktempnam(NULL, "test"); out2 = ktempnam(NULL, "test");
	if ((outfid1 = open(out1, O_WRONLY|O_TRUNC|O_CREAT, 0666))  == -1 ||
	    (outfid2 = kopen(out2, O_WRONLY|O_TRUNC|O_CREAT, 0666)) == -1)
	{
	   kexit(KEXIT_FAILURE);
	}

        do
        {
           size = kread(infid, temp, (size_t) KLENGTH);
	   if (size <= 0) break;

           num1 = write(outfid1, temp, (size_t) size);
           num2 = kwrite(outfid2, temp, (size_t) size);
	   if (num1 != num2)
	   {
	      kfprintf(kstderr,"Wrote different number of bytes '%d' & '%d'!\n",
			num1, num2);
	      kunlink(out1); kunlink(out2);
              kexit(KEXIT_FAILURE);
	   }
        } while (num1 != 0 && num2 != 0);
	kclose(infid);
	close(outfid1); kclose(outfid2);

	if (kcomparefile(out1, out2, (size_t) 0, NULL) != 0)
	{
	   kfprintf(kstderr,"Comparison of output files '%s' & '%s' failed!\n",
			out1, out2);
	   kunlink(out1); kunlink(out2);
	   kexit(KEXIT_FAILURE);
	}
	kunlink(out1); kunlink(out2);
	kprintf("Success!\n");
	kexit(KEXIT_SUCCESS);
}
