#include "bootstrap.h"
 
void main(
   int  argc,
   char *argv[])
{
	FILE  *outfile1;
	kfile *infile, *outfile2;

	int     i, len;
	ssize_t size, position, num1, num2;
	char    buf[KLENGTH], kpath[KLENGTH], temp[KLENGTH], *out1, *out2, *path;


	if (argc > 1)
	   path = argv[1];

	kremote_file("$KHOROS_TESTHOST", path, kpath);
	if ((infile = kfopen(kpath, "r")) == NULL)
	   kexit(KEXIT_FAILURE);

	out1 = ktempnam(NULL, "test");
	if ((outfile1 = fopen(out1, "w"))  == NULL)
	   kexit(KEXIT_FAILURE);
	setvbuf(outfile1, buf, _IOFBF, (size_t) KLENGTH);

	out2 = ktempnam(NULL, "test");
	ksprintf(temp, "cat > %s", out2);
	if ((outfile2 = kpopen(temp, "w")) == NULL)
	   kexit(KEXIT_FAILURE);

        do
        {
           size = kfread(temp, (size_t) 1, (size_t) KLENGTH, infile);
	   if (size <= 0) break;

           num1 = fwrite(temp, (size_t) 1, (size_t) size, outfile1);
           num2 = kfwrite(temp, (size_t) 1, (size_t) size, outfile2);
	   if (num1 != num2)
	   {
	      kfprintf(kstderr,"Wrote different number of bytes '%d' & '%d'!\n",
			num1, num2);
	      kunlink(out1); kunlink(out2);
              kexit(KEXIT_FAILURE);
	   }
        } while (num1 != EOF && num2 != EOF);

	len = kftell(infile);
        for (i = 0; i < len; i++)
        {
	   position = (long) (kurng() * (len-1));
	   kfseek(infile, position, SEEK_SET);
	   size = kfread(temp, (size_t) 1, (size_t) KLENGTH, infile);

	   position = (long) (kurng() * (len-1));
	   fseek(outfile1, position, SEEK_SET);
	   kfseek(outfile2, position, SEEK_SET);
	   num1 = fwrite(temp, (size_t) 1, (size_t) size, outfile1);
	   num2 = kfwrite(temp, (size_t) 1, (size_t) size, outfile2);
	   if (num1 != num2)
	   {
	      kfprintf(kstderr,"Wrote different number of bytes '%d' & '%d'!\n",
			num1, num2);
	      kunlink(out1); kunlink(out2);
	      kexit(KEXIT_FAILURE);
           }
        }
	kfclose(infile);
	fclose(outfile1); kpclose(outfile2);

	if (kcomparefile(out1, out2, (size_t) 0, NULL) != 0)
	{
	   kfprintf(kstderr,"Comparison of output files '%s' & '%s' failed!\n",
			out1, out2);
	   kunlink(out1); kunlink(out2);
	   kexit(KEXIT_FAILURE);
	}
	kunlink(out1); kunlink(out2);
	kprintf("Success!\n");
	kexit(KEXIT_SUCCESS);
}
