#include <bootstrap.h>

#define NUM_BYTES 7
#define NUM_UBYTES  NUM_BYTES
#define NUM_SHORTS  NUM_BYTES
#define NUM_USHORTS NUM_BYTES
#define NUM_INTS    NUM_BYTES
#define NUM_UINTS   NUM_BYTES
#define NUM_LONGS   NUM_BYTES
#define NUM_ULONGS  NUM_BYTES
#define NUM_FLOATS  NUM_BYTES
#define NUM_DOUBLES NUM_BYTES

kaddr data;
int fid;
int k;
 
int myopen(char *filename)
{
   char kpath[KLENGTH], temp[KLENGTH];

   ksprintf(temp,"$BOOTSTRAP/testsuite/kdce/27.kdce_convert_read/%s", filename);
   kremote_file("$KHOROS_TESTHOST", temp, kpath);
   return(kopen(kpath, KOPEN_RDONLY, 0x0));
}

void
do_byte(void)
{
   kprintf("char\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/char.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_byte(fid, data, (size_t) NUM_BYTES) != NUM_BYTES)
   {
      kprintf("vax byte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_BYTES; k++)
      kprintf("%d ",(int)((signed char *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/char.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_byte(fid, data, (size_t) NUM_BYTES) != NUM_BYTES)
   {
      kprintf("ieee big endian byte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_BYTES; k++)
      kprintf("%d ",(int)((signed char *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/char.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_byte(fid, data, (size_t) NUM_BYTES) != NUM_BYTES)
   {
      kprintf("ieee little endian byte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_BYTES; k++)
      kprintf("%d ",(int)((signed char *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/char.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_byte(fid, data, (size_t) NUM_BYTES) != NUM_BYTES)
   {
      kprintf("alpha byte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_BYTES; k++)
      kprintf("%d ",(int)((signed char *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/char.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_byte(fid, data, (size_t) NUM_BYTES) != NUM_BYTES)
   {
      kprintf("cray byte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_BYTES; k++)
      kprintf("%d ",(int)((signed char *)data)[k]);
   kprintf("\n");
   
   return;
}

void
do_ubyte(void)
{
   kprintf("unsigned char\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/uchar.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_ubyte(fid, data, (size_t) NUM_UBYTES) != NUM_UBYTES)
   {
      kprintf("vax ubyte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_UBYTES; k++)
      kprintf("%u ",(unsigned int)((unsigned char *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/uchar.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_ubyte(fid, data, (size_t) NUM_UBYTES) != NUM_UBYTES)
   {
      kprintf("ieee big endian ubyte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_UBYTES; k++)
      kprintf("%u ",(unsigned int)((unsigned char *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/uchar.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_ubyte(fid, data, (size_t) NUM_UBYTES) != NUM_UBYTES)
   {
      kprintf("ieee little endian ubyte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_UBYTES; k++)
      kprintf("%u ",(unsigned int)((unsigned char *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/uchar.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_ubyte(fid, data, (size_t) NUM_UBYTES) != NUM_UBYTES)
   {
      kprintf("alpha ubyte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_UBYTES; k++)
      kprintf("%u ",(unsigned int)((unsigned char *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/uchar.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_ubyte(fid, data, (size_t) NUM_UBYTES) != NUM_UBYTES)
   {
      kprintf("cray ubyte failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_UBYTES; k++)
      kprintf("%u ",(unsigned int)((unsigned char *)data)[k]);
   kprintf("\n");
   
   return;
}

 
void
do_short(void)
{
   kprintf("short\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/short.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_short(fid, data, (size_t) NUM_SHORTS) != NUM_SHORTS)
   {
      kprintf("vax short failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_SHORTS; k++)
      kprintf("%d ",(int)((short *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/short.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_short(fid, data, (size_t) NUM_SHORTS) != NUM_SHORTS)
   {
      kprintf("ieee big endian short failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_SHORTS; k++)
      kprintf("%d ",(int)((short *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/short.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_short(fid, data, (size_t) NUM_SHORTS) != NUM_SHORTS)
   {
      kprintf("ieee little endian short failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_SHORTS; k++)
      kprintf("%d ",(int)((short *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/short.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_short(fid, data, (size_t) NUM_SHORTS) != NUM_SHORTS)
   {
      kprintf("alpha short failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_SHORTS; k++)
      kprintf("%d ",(int)((short *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/short.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_short(fid, data, (size_t) NUM_SHORTS) != NUM_SHORTS)
   {
      kprintf("cray short failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_SHORTS; k++)
      kprintf("%d ",(int)((short *)data)[k]);
   kprintf("\n");
   
   return;
}

 
void
do_ushort(void)
{
   kprintf("unsigned short\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/ushort.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_ushort(fid, data, (size_t) NUM_USHORTS) != NUM_USHORTS)
   {
      kprintf("vax ushort failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_USHORTS; k++)
      kprintf("%u ",(unsigned int)((unsigned short *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/ushort.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_ushort(fid, data, (size_t) NUM_USHORTS) != NUM_USHORTS)
   {
      kprintf("ieee big endian ushort failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_USHORTS; k++)
      kprintf("%u ",(unsigned int)((unsigned short *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/ushort.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_ushort(fid, data, (size_t) NUM_USHORTS) != NUM_USHORTS)
   {
      kprintf("ieee little endian ushort failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_USHORTS; k++)
      kprintf("%u ",(unsigned int)((unsigned short *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/ushort.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_ushort(fid, data, (size_t) NUM_USHORTS) != NUM_USHORTS)
   {
      kprintf("alpha ushort failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_USHORTS; k++)
      kprintf("%u ",(unsigned int)((unsigned short *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/ushort.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_ushort(fid, data, (size_t) NUM_USHORTS) != NUM_USHORTS)
   {
      kprintf("cray ushort failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_USHORTS; k++)
      kprintf("%u ",(unsigned int)((unsigned short *)data)[k]);
   kprintf("\n");
   
   return;
}
 
void
do_int(void)
{
   kprintf("int\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/int.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_int(fid, data, (size_t) NUM_INTS) != NUM_INTS)
   {
      kprintf("vax int failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_INTS; k++)
      kprintf("%d ",(int)((int *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/int.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_int(fid, data, (size_t) NUM_INTS) != NUM_INTS)
   {
      kprintf("ieee big endian int failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_INTS; k++)
      kprintf("%d ",(int)((int *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/int.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_int(fid, data, (size_t) NUM_INTS) != NUM_INTS)
   {
      kprintf("ieee little endian int failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_INTS; k++)
      kprintf("%d ",(int)((int *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/int.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_int(fid, data, (size_t) NUM_INTS) != NUM_INTS)
   {
      kprintf("alpha int failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_INTS; k++)
      kprintf("%d ",(int)((int *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/int.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_int(fid, data, (size_t) NUM_INTS) != NUM_INTS)
   {
      kprintf("cray int failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_INTS; k++)
      kprintf("%d ",(int)((int *)data)[k]);
   kprintf("\n");
   
   return;
}

 
void
do_uint(void)
{
   kprintf("unsigned int\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/uint.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_uint(fid, data, (size_t) NUM_UINTS) != NUM_UINTS)
   {
      kprintf("vax uint failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_UINTS; k++)
      kprintf("%u ",(unsigned int)((unsigned int *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/uint.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_uint(fid, data, (size_t) NUM_UINTS) != NUM_UINTS)
   {
      kprintf("ieee big endian uint failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_UINTS; k++)
      kprintf("%u ",(unsigned int)((unsigned int *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/uint.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_uint(fid, data, (size_t) NUM_UINTS) != NUM_UINTS)
   {
      kprintf("ieee little endian uint failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_UINTS; k++)
      kprintf("%u ",(unsigned int)((unsigned int *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/uint.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_uint(fid, data, (size_t) NUM_UINTS) != NUM_UINTS)
   {
      kprintf("alpha uint failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_UINTS; k++)
      kprintf("%u ",(unsigned int)((unsigned int *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/uint.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_uint(fid, data, (size_t) NUM_UINTS) != NUM_UINTS)
   {
      kprintf("cray uint failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_UINTS; k++)
      kprintf("%u ",(unsigned int)((unsigned int *)data)[k]);
   kprintf("\n");
   
   return;
}

 
void
do_long(void)
{
   kprintf("long\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/long.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_long(fid, data, (size_t) NUM_LONGS) != NUM_LONGS)
   {
      kprintf("vax long failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_LONGS; k++)
      kprintf("%ld ",(long)((long *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/long.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_long(fid, data, (size_t) NUM_LONGS) != NUM_LONGS)
   {
      kprintf("ieee big endian long failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_LONGS; k++)
      kprintf("%ld ",(long)((long *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/long.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_long(fid, data, (size_t) NUM_LONGS) != NUM_LONGS)
   {
      kprintf("ieee little endian long failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_LONGS; k++)
      kprintf("%ld ",(long)((long *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/long.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_long(fid, data, (size_t) NUM_LONGS) != NUM_LONGS)
   {
      kprintf("alpha long failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_LONGS; k++)
      kprintf("%ld ",(long)((long *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/long.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_long(fid, data, (size_t) NUM_LONGS) != NUM_LONGS)
   {
      kprintf("cray long failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_LONGS; k++)
      kprintf("%ld ",(long)((long *)data)[k]);
   kprintf("\n");
   
   return;
}

 
void
do_ulong(void)
{
   kprintf("unsigned long\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/ulong.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_ulong(fid, data, (size_t) NUM_ULONGS) != NUM_ULONGS)
   {
      kprintf("vax ulong failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_ULONGS; k++)
      kprintf("%u ",(unsigned long)((unsigned long *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/ulong.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_ulong(fid, data, (size_t) NUM_ULONGS) != NUM_ULONGS)
   {
      kprintf("ieee big endian ulong failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_ULONGS; k++)
      kprintf("%u ",(unsigned long)((unsigned long *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/ulong.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_ulong(fid, data, (size_t) NUM_ULONGS) != NUM_ULONGS)
   {
      kprintf("ieee little endian ulong failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_ULONGS; k++)
      kprintf("%u ",(unsigned long)((unsigned long *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/ulong.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_ulong(fid, data, (size_t) NUM_ULONGS) != NUM_ULONGS)
   {
      kprintf("alpha ulong failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_ULONGS; k++)
      kprintf("%u ",(unsigned long)((unsigned long *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/ulong.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_ulong(fid, data, (size_t) NUM_ULONGS) != NUM_ULONGS)
   {
      kprintf("cray ulong failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_ULONGS; k++)
      kprintf("%u ",(unsigned long)((unsigned long *)data)[k]);
   kprintf("\n");
   
   return;
}

void
do_float(void)
{
   kprintf("float\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/float.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_float(fid, data, (size_t) NUM_FLOATS) != NUM_FLOATS)
   {
      kprintf("vax float failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_FLOATS; k++)
      kprintf("%e ", ((float *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/float.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_float(fid, data, (size_t) NUM_FLOATS) != NUM_FLOATS)
   {
      kprintf("ieee big endian float failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_FLOATS; k++)
      kprintf("%e ", ((float *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/float.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_float(fid, data, (size_t) NUM_FLOATS) != NUM_FLOATS)
   {
      kprintf("ieee little endian float failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_FLOATS; k++)
      kprintf("%e ", ((float *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/float.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_float(fid, data, (size_t) NUM_FLOATS) != NUM_FLOATS)
   {
      kprintf("alpha float failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_FLOATS; k++)
      kprintf("%e ", ((float *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/float.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_float(fid, data, (size_t) NUM_FLOATS) != NUM_FLOATS)
   {
      kprintf("cray float failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_FLOATS; k++)
      kprintf("%e ", ((float *)data)[k]);
   kprintf("\n");
   
   return;
}


void
do_double(void)
{
   kprintf("double\n");
   
   /*
    * the little endian vax case
    */
   fid = myopen("data/double.vax");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_VAX);
   if (kread_double(fid, data, (size_t) NUM_DOUBLES) != NUM_DOUBLES)
   {
      kprintf("vax double failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("vax:                  ");
   for (k = 0; k < NUM_DOUBLES; k++)
      kprintf("%e ", ((double *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit big-endian ieee case
    */
   fid = myopen("data/double.ieee_be");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_IEEE);
   if (kread_double(fid, data, (size_t) NUM_DOUBLES) != NUM_DOUBLES)
   {
      kprintf("ieee big endian double failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (big endian):    ");
   for (k = 0; k < NUM_DOUBLES; k++)
      kprintf("%e ", ((double *)data)[k]);
   kprintf("\n");
   
   /*
    * the 32bit little-endian ieee case
    */
   fid = myopen("data/double.ieee_le");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_IEEE);
   if (kread_double(fid, data, (size_t) NUM_DOUBLES) != NUM_DOUBLES)
   {
      kprintf("ieee little endian double failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("ieee (little endian): ");
   for (k = 0; k < NUM_DOUBLES; k++)
      kprintf("%e ", ((double *)data)[k]);
   kprintf("\n");
   
   /*
    * the DEC alpha case
    */
   fid = myopen("data/double.alpha");
   kfile_setmachtype(fid,KMACH_LITTLE_ENDIAN_ALPHA);
   if (kread_double(fid, data, (size_t) NUM_DOUBLES) != NUM_DOUBLES)
   {
      kprintf("alpha double failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("alpha:                ");
   for (k = 0; k < NUM_DOUBLES; k++)
      kprintf("%e ", ((double *)data)[k]);
   kprintf("\n");
   
   /*
    * the cray case
    */
   fid = myopen("data/double.cray");
   kfile_setmachtype(fid,KMACH_BIG_ENDIAN_CRAY);
   if (kread_double(fid, data, (size_t) NUM_DOUBLES) != NUM_DOUBLES)
   {
      kprintf("cray double failure\n");
      kexit(1);
   }
   kclose(fid);
   kprintf("cray:                 ");
   for (k = 0; k < NUM_DOUBLES; k++)
      kprintf("%e ", ((double *)data)[k]);
   kprintf("\n");
   
   return;
}


void main(int argc, char **argv)
{
   if (argc < 2)
   {
      kprintf("No data type specified.\n");
      kexit(1);
   }
   
   data = kmalloc((size_t) KLENGTH);
   
   switch (atoi(argv[1]))
   {
      case KBYTE:
	 do_byte();
	 break;
      case KUBYTE:
	 do_ubyte();
	 break;
      case KSHORT:
	 do_short();
	 break;
      case KUSHORT:
	 do_ushort();
	 break;
      case KINT:
	 do_int();
	 break;
      case KUINT:
	 do_uint();
	 break;
      case KLONG:
	 do_long();
	 break;
      case KULONG:
	 do_ulong();
	 break;
      case KFLOAT:
	 do_float();
	 break;
      case KDOUBLE:
	 do_double();
	 break;
   }

   kexit(0);
   return;
}
