#include <bootstrap.h>

#define TOL 1.0e-5
#define zerosky(a) \
  ((a > 0.0 - TOL && a < 0.0 + TOL) ? +0.0 : a)


main()
{
   int max;
   int i;
   float a1[7] = { 23.0, 12.3, 132.1, 1.0, -243.1, 10.2, 21.1 };
   float a2[7] = { 4.0, 5.1, 6.1, 7.2, 8.3, 9.12, 123.0 };
   float m1[4] = { 2.0, 3.0, -1.0, -4.0};
   float m2[9] = {1, 1, 1, 2, 2, 2, 3, 3, 3};
   float m3[9]= {1,13.5,27,
                 1,73.5,27,
                 1,46.8,37};
   float m4[16] = {2.847, 1.721, 1.638, 0.843, 
		   2.012, 0.945, 4.237, 1.658,
		   1.013, 1.426, 2.166, 0.881,
		   0.980, 0.879, 2.257, 1.743};
   float m4a[16] = {1,0,0,0,
                    0,2,0,0,
                    0,0,3,0,
                    0,0,0,4};
   float m4b[16] = {1,0,0,0,
                    0,0,2,0,
                    0,0,0,3,
                    0,4,0,0};
   double M4[16] = {2.847, 1.721, 1.638, 0.843,
                   2.012, 0.945, 4.237, 1.658,
                   1.013, 1.426, 2.166, 0.881,
                   0.980, 0.879, 2.257, 1.743};
   double M3[9]= {1,13.5,27,
                  1,73.5,27,
                  1,46.8,37};

   float m3i[9];
   float m4i[16];
   double M4i[16];
   double M3i[16];
   
   float work[16];
   float out[16];
   double OUT[16];
   float det[16];
   int   pivot[4];
   int   info;
   int   n, incx = 1, incy = 1;
   int   j;
   
   kprintf("testing sscal ...\n");
   kblas_sscal(a1, 2, 7, 1);
   kprintf("A1 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a1[i])); kprintf("\n");
   kprintf("\n");

   kprintf("testing sscal ...\n");
   kblas_sscal(a1, 0.5, 7, 1);
   kprintf("A1 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a1[i])); kprintf("\n");
   kprintf("A2 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a2[i])); kprintf("\n");
   kprintf("\n");

   kprintf("testing saxpy ...\n");
   kblas_saxpy(a1, a2, 2.0, 7, 1, 1);
   kprintf("A1:"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a1[i])); kprintf("\n");
   kprintf("A2:"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a2[i])); kprintf("\n");
   kprintf("\n");

   kprintf("testing sswap ...\n");
   kblas_sswap(a1, a2, 7, 1, 1);
   kprintf("A1 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a1[i])); kprintf("\n");
   kprintf("A2 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a2[i])); kprintf("\n");
   kprintf("\n");

   kprintf("testing sswap ...\n");
   kblas_sswap(a1, a2, 2, 2, 2);
   kprintf("A1 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a1[i])); kprintf("\n");
   kprintf("A2 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a2[i])); kprintf("\n");
   kprintf("\n");
   
   kprintf("testing sswap ...\n");
   kblas_sswap(a1, a2, 2, 3, 3);
   kprintf("A1 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a1[i])); kprintf("\n");
   kprintf("A2 :"); for(i=0;i<7;i++) kprintf("%g ", zerosky(a2[i])); kprintf("\n");
   kprintf("\n");

   kprintf("testing kfmatrix_inverse (4x4)...\n");
   kfmatrix_inverse(m4, 4, m4i);
   kprintf("Inverted Matrix\n"); 
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[4+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[8+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[12+i])); kprintf("\n");

   kprintf("\ntesting kfmatrix_multiply (4x4)...\n");
   kfmatrix_multiply(m4, 4, 4, m4i, 4, 4, out);
   kprintf("Matrix multiplied by its Inverted Matrix\n"); 
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(out[i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(out[4+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(out[8+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(out[12+i])); kprintf("\n");

   kprintf("\ntesting kfmatrix_inverse again with diagonal matrix (4x4)...\n");
   kfmatrix_inverse(m4a, 4, m4i);
   kprintf("Inverted Matrix\n");
   for (i=0; i<16; i++) if (kfabs((double)m4i[i]) < TOL) m4i[i] = 0.0;
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[4+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[8+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[12+i])); kprintf("\n");

   kprintf("\ntesting kfmatrix_inverse again with sparse matrix (4x4)...\n");
   kfmatrix_inverse(m4b, 4, m4i);
   kprintf("Inverted Matrix\n");
   for (i=0; i<16; i++) if (kfabs((double)m4i[i]) < TOL) m4i[i] = 0.0;
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[4+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[8+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(m4i[12+i])); kprintf("\n");

   kprintf("\ntesting kfmatrix_inverse (3x3)...\n");
   kfmatrix_inverse(m3, 3, m3i);
   kprintf("Inverted Matrix\n");
   for (i=0; i<9; i++) if (kfabs((double)m3[i]) < TOL) m3i[i] = 0.0;
   for(i=0;i<3;i++) kprintf("%4.4f ", zerosky(m3i[i])); kprintf("\n");
   for(i=0;i<3;i++) kprintf("%4.4f ", zerosky(m3i[3+i])); kprintf("\n");
   for(i=0;i<3;i++) kprintf("%4.4f ", zerosky(m3i[6+i])); kprintf("\n");

   kprintf("\ntesting kdmatrix_inverse (4x4)...\n");
   kdmatrix_inverse(M4, 4, M4i);
   kprintf("Inverted Matrix\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(M4i[i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(M4i[4+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(M4i[8+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.4f ", zerosky(M4i[12+i])); kprintf("\n");
 
   kprintf("\ntesting kdmatrix_multiply (4x4)...\n");
   kdmatrix_multiply(M4, 4, 4, M4i, 4, 4, OUT);
   kprintf("Matrix multiplied by its Inverted Matrix\n");
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(OUT[i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(OUT[4+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(OUT[8+i])); kprintf("\n");
   for(i=0;i<4;i++) kprintf("%4.1f ", kabs(OUT[12+i])); kprintf("\n");

   kprintf("\ntesting kdmatrix_inverse (3x3)...\n");
   kdmatrix_inverse(M3, 3, M3i);
   kprintf("Inverted Matrix\n");
   for (i=0; i<9; i++) if (kfabs(M3[i]) < TOL) M3i[i] = 0.0;
   for(i=0;i<3;i++) kprintf("%4.4f ", zerosky(M3i[i])); kprintf("\n");
   for(i=0;i<3;i++) kprintf("%4.4f ", zerosky(M3i[3+i])); kprintf("\n");
   for(i=0;i<3;i++) kprintf("%4.4f ", zerosky(M3i[6+i])); kprintf("\n");

   kexit(KEXIT_SUCCESS);
}
