
#include <bootstrap.h>
#include "io_test.h"

list *
create_list(int start)
{
   list *rlist = NULL;
   int   z = start;

   rlist = (list *) kmalloc(sizeof(list));

   rlist->c[0] = z++;
   rlist->c[1] = z++;
   rlist->c[2] = z++;
   rlist->c[3] = z++;
   rlist->c[4] = z++;
   
   rlist->d.d_len = 3;
   rlist->d.d_val = (int *) kmalloc(sizeof(int) * 3);
   rlist->d.d_val[0] = z++;
   rlist->d.d_val[1] = z++;
   rlist->d.d_val[2] = z++;

   rlist->e.e_len = 4;
   rlist->e.e_val = (int *) kmalloc(sizeof(int) * 4);
   rlist->e.e_val[0] = z++;
   rlist->e.e_val[1] = z++;
   rlist->e.e_val[2] = z++;
   rlist->e.e_val[3] = z++;

   rlist->f.a = z++;
   rlist->f.b = z++;
   
   rlist->g[0].a = z++;
   rlist->g[0].b = z++;
   rlist->g[1].a = z++;
   rlist->g[1].b = z++;
   rlist->g[2].a = z++;
   rlist->g[2].b = z++;

   rlist->h.h_len = 1;
   rlist->h.h_val = kmalloc(sizeof(simple) * 1);
   rlist->h.h_val[0].a = (char)  z++;
   rlist->h.h_val[0].b = (float) z++;

   rlist->j = kmalloc(sizeof(int));
   *rlist->j = (float) z++;
   
   rlist->next = NULL;
   rlist->prev = NULL;
   return rlist;
}
   

int
compare_list(list *a, list *b)
{
   int i;
   
   if (a->c[0] != b->c[0])
      return FALSE;
   if (a->c[1] != b->c[1])
      return FALSE;
   if (a->c[2] != b->c[2])
      return FALSE;
   if (a->c[3] != b->c[3])
      return FALSE;
   if (a->c[4] != b->c[4])
      return FALSE;

   if (a->d.d_len != b->d.d_len)
      return FALSE;
   for (i = 0; i < a->d.d_len; i++)
      if (a->d.d_val[i] != b->d.d_val[i])
	 return FALSE;

   if (a->e.e_len != b->e.e_len)
      return FALSE;
   for (i = 0; i < a->e.e_len; i++)
      if (a->e.e_val[i] != b->e.e_val[i])
	 return FALSE;

   if (a->f.a != b->f.a)
      return FALSE;
   if (a->f.b != b->f.b)
      return FALSE;

   if (a->g[0].a != b->g[0].a)
      return FALSE;
   if (a->g[0].b != b->g[0].b)
      return FALSE;
   if (a->g[1].a != b->g[1].a)
      return FALSE;
   if (a->g[1].b != b->g[1].b)
      return FALSE;
   if (a->g[2].a != b->g[2].a)
      return FALSE;
   if (a->g[2].b != b->g[2].b)
      return FALSE;

   if (a->h.h_len != b->h.h_len)
      return FALSE;
   for (i = 0; i < a->h.h_len; i++)
   {
      if (a->h.h_val[i].a != b->h.h_val[i].a)
	 return FALSE;
      if (a->h.h_val[i].b != b->h.h_val[i].b)
	 return FALSE;
   }

   if (a->j != NULL && b->j != NULL)
      if (*a->j != *b->j)
	 return FALSE;
   
   if (a->next != NULL && b->next != NULL)
   {
      /* check previous pointers */
      if (a->next->prev != a)
      {
         kprintf("previous pointer munched for original list!\n");
 	 return FALSE;
      }

      if (b->next->prev != b)
      {
         kprintf("previous pointer munched for restored list!\n");
 	 return FALSE;
      }

      return (compare_list(a->next, b->next));
   }
   else
      return TRUE;
}

void
main()
{
   list *o_list;
   list *i_list;
   int fid, status;
   float *common;

   kdefine__simple();
   kdefine_simple();
   kdefine__list();
   kdefine_list();
   
   o_list = create_list(3);

   /*-- double-link in next node --*/
   o_list->next = create_list(5);
   o_list->next->prev = o_list;

   /*-- double-link in next node --*/
   o_list->next->next = create_list(7);
   o_list->next->next->prev = o_list->next; 

   /*-- set up common link to a single float --*/
   common = kmalloc(sizeof(float));
   *common = 36.35;
   o_list->common             = common;
   o_list->next->common       = common;
   o_list->next->next->common = common;

   fid = kopen("./t.data", O_WRONLY|O_CREAT|O_TRUNC, 0644);
   kwrite_struct(fid, (kaddr) o_list, KTYPE_LIST);
   kclose(fid);
   
   fid = kopen("./t.data", O_RDONLY, 0644);
   kread_struct(fid, (kaddr) &i_list, KTYPE_LIST);
   kclose(fid);
  
   status = KEXIT_SUCCESS;
   if (compare_list(o_list, i_list))
      kprintf("identical!\n");
   else
   {
      kprintf("different!\n");
      status = KEXIT_FAILURE;
   }

   /* check common pointer value */
   if ( i_list->common != NULL &&
       *i_list->common             == *common &&
       *i_list->next->common       == *common &&
       *i_list->next->next->common == *common)
      kprintf("common pointer value identical!\n");
   else
   {
      kprintf("common pointer value different!\n");
      status = KEXIT_FAILURE;
   }

   /* check common pointer */
   if (i_list->common == i_list->next->common && 
       i_list->common == i_list->next->next->common)
      kprintf("common pointer identical!\n");
   else
   {
      kprintf("common pointer different!\n");
      status = KEXIT_FAILURE;
   }

   kexit(status);
}
