#include "bootstrap.h"
 
int main(
   int  argc,
   char *argv[])
{
	FILE  *outfile1;
	kfile *infile, *outfile2;

	size_t i;
	long   len, position;
	int    status1, status2;
	char   buf[KLENGTH], temp[KLENGTH], *data, *out1, *out2, *path;


	if (argc > 1)
	   path = argv[1];
	else
	   kexit(KEXIT_FAILURE);

	if ((infile = kfopen(path, "r")) == NULL)
	   kexit(KEXIT_FAILURE);

	out1 = ktempnam(NULL, "test"); out2 = ktempnam(NULL, "test");
	if ((outfile1 = fopen(out1, "w"))  == NULL ||
	    (outfile2 = kfopen(out2, "w")) == NULL)
	{
	   kexit(KEXIT_FAILURE);
	}
	setvbuf(outfile1, buf, _IOFBF, (size_t) KLENGTH);

        do
        {
           data = kfgets(temp, KLENGTH, infile);
	   if (!data) break;

           status1 = fputs(data, outfile1);
           status2 = kfputs(data, outfile2);
	   if (status1 != status2 && (status1 == EOF || status2 == EOF))
	   {
	      kfprintf(kstderr,"Write failed for UNIX fputs() or kfputs()\n");
	      kunlink(out1); kunlink(out2);
              kexit(KEXIT_FAILURE);
	   }
        } while (status1 != EOF && status2 != EOF);

	len = kftell(infile);
        for (i = 0; i < len; i++)
        {
	   position = (long) (kurng() * (len-1));
	   kfseek(infile, position, SEEK_SET);
	   data = kfgets(temp, KLENGTH, infile);

	   position = (long) (kurng() * (len-1));
	   fseek(outfile1, position, SEEK_SET);
	   kfseek(outfile2, position, SEEK_SET);
	   status1 = fputs(data, outfile1);
	   status2 = kfputs(data, outfile2);
	   if (status1 != status2 && (status1 == EOF || status2 == EOF))
	   {
	      kfprintf(kstderr,"Write failed for UNIX fputs() or kfputs()\n");
	      kunlink(out1); kunlink(out2);
              kexit(KEXIT_FAILURE);
	   }
        }
	kfclose(infile);
	fclose(outfile1); kfclose(outfile2);

	if (kcomparefile(out1, out2, (size_t) 0, NULL) != 0)
	{
	   kfprintf(kstderr,"Comparison of output files '%s' & '%s' failed!\n",
			out1, out2);
	   kunlink(out1); kunlink(out2);
	   kexit(KEXIT_FAILURE);
	}
	kunlink(out1); kunlink(out2);
	kprintf("Success!\n");
	kexit(KEXIT_SUCCESS);
}
