#include "bootstrap.h"
 
int main(
   int  argc,
   char *argv[])
{
        char    temp[KLENGTH], *out1, *out2, *path;
        int     infid, outfid1, outfid2;
	size_t  i;
	ssize_t size, num1, num2;
	off_t   len, position;
 
 
        if (argc > 1)
           path = argv[1];
	else
           kexit(KEXIT_FAILURE);
 
        if ((infid = kopen(path,  O_RDONLY, 0666)) == -1)
           kexit(KEXIT_FAILURE);
 
        out1 = ktempnam(NULL, "test"); out2 = ktempnam(NULL, "test");
        if ((outfid1 = open(out1, O_WRONLY|O_TRUNC|O_CREAT, 0666))  == -1 ||
            (outfid2 = kopen(out2, O_WRONLY|O_TRUNC|O_CREAT, 0666)) == -1)
        {
           kexit(KEXIT_FAILURE);
        }
 
        do
        {
           size = kread(infid, temp, (size_t) KLENGTH);
           if (size <= 0) break;
 
           num1 = write(outfid1, temp, (size_t) size);
           num2 = kwrite(outfid2, temp, (size_t) size);
           if (num1 != num2)
           {
              kfprintf(kstderr,"Wrote different number of bytes '%ld' & '%ld'!\n", (long) num1, (long) num2);
              kunlink(out1); kunlink(out2);
              kexit(KEXIT_FAILURE);
           }
        } while (num1 != 0 && num2 != 0);

	len = ktell(infid);
        for (i = 0; i < len; i++)
        {
	   position = (off_t) (kurng() * (len-1));
	   lseek(infid, position, SEEK_SET);
	   size = kread(infid, temp, (size_t) KLENGTH);

	   position = (off_t) (kurng() * (len-1));
	   lseek(outfid1, position, SEEK_SET);
	   klseek(outfid2, position, SEEK_SET);
           num1 = write(outfid1, temp, (size_t)size);
           num2 = kwrite(outfid2, temp, (size_t)size);
	   if (num1 != num2)
	   {
	      kfprintf(kstderr,"Wrote different number of bytes '%ld' & '%ld'!\n", (long) num1, (long) num2);
	      kunlink(out1); kunlink(out2);
	      kexit(KEXIT_FAILURE);
           }
        }
        kclose(infid);
        close(outfid1); kclose(outfid2);

	if (kcomparefile(out1, out2, (size_t) 0, NULL) != 0)
	{
	   kfprintf(kstderr,"Comparison of output files '%s' & '%s' failed!\n",
			out1, out2);
	   kunlink(out1); kunlink(out2);
	   kexit(KEXIT_FAILURE);
	}
	kunlink(out1); kunlink(out2);
	kprintf("Success!\n");
	kexit(KEXIT_SUCCESS);
}
