#include "bootstrap.h"
 
int main(
   int  argc,
   char *argv[])
{
	FILE  *outfile1;
	kfile *infile, *outfile2;

	size_t size, num1, num2;
	char   buf[KLENGTH], temp[KLENGTH], *out1, *out2, *path;


	if (argc > 1)
	   path = argv[1];
	else
	   kexit(KEXIT_FAILURE);

	if ((infile = kfopen(path, "r")) == NULL)
	   kexit(KEXIT_FAILURE);

	out1 = ktempnam(NULL, "test");
	if ((outfile1 = fopen(out1, "w"))  == NULL)
	   kexit(KEXIT_FAILURE);
	setvbuf(outfile1, buf, _IOFBF, (size_t) KLENGTH);

	out2 = ktempnam(NULL, "test");
	ksprintf(temp, "cat > %s", out2);
	if ((outfile2 = kpopen(temp, "w")) == NULL)
	   kexit(KEXIT_FAILURE);

        do
        {
           size = kfread(temp, (size_t) 1, (size_t) KLENGTH, infile);
	   if (size <= 0) break;

           num1 = fwrite(temp, (size_t) 1, size, outfile1);
           num2 = kfwrite(temp, (size_t) 1, size, outfile2);
	   if (num1 != num2)
	   {
	      kfprintf(kstderr,"Wrote different number of bytes '%ld' & '%ld'!\n", (long) num1, (long) num2);
	      kunlink(out1); kunlink(out2);
              kexit(KEXIT_FAILURE);
	   }
        } while (num1 != 0 && num2 != 0);
	kfclose(infile);
	fclose(outfile1); kpclose(outfile2);

	if (kcomparefile(out1, out2, (size_t) 0, NULL) != 0)
	{
	   kfprintf(kstderr,"Comparison of output files '%s' & '%s' failed!\n",
			out1, out2);
	   kunlink(out1); kunlink(out2);
	   kexit(KEXIT_FAILURE);
	}
	kunlink(out1); kunlink(out2);
	kprintf("Success!\n");
	kexit(KEXIT_SUCCESS);
}
