#include "bootstrap.h"
 
#define add(array, datatype, identifier, num) \
	karray_insert(array, datatype, identifier, num, KLIST_TAIL, TRUE)

#define doit(type, datatype, size) \
	{								     \
		ssize_t  i;						     \
		type *array = NULL;					     \
									     \
		for (i = 0; i < size; i++)				     \
		   array = add(array, datatype, (type) i, i);		     \
									     \
		for (i = size-1; i >= 0; i--)				     \
		   if (karray_locate(array, datatype, (type) i, size) == -1) \
		      kexit(KEXIT_FAILURE);				     \
									     \
		karray_free(array, datatype, size, NULL);		     \
	}

int main(
   int  argc,
   char *argv[])
{
	int    datatype = KBYTE;
	size_t size = 10;

	if (argc > 1)
	   datatype = kdatatype_to_define(argv[1]);
	if (argc > 2)
	   size = atoi(argv[2]);

	switch (datatype)
	{
	   case KBYTE:
		doit(signed char, datatype, size);
		break;

	   case KUBYTE:
		doit(signed char, datatype, size);
		break;

	   case KSHORT:
		doit(signed short, datatype, size);
		break;

	   case KUSHORT:
		doit(unsigned short, datatype, size);
		break;

	   case KINT:
		doit(signed int, datatype, size);
		break;

	   case KUINT:
		doit(unsigned int, datatype, size);
		break;

	   case KLONG:
		doit(signed long, datatype, size);
		break;

	   case KULONG:
		doit(unsigned long, datatype, size);
		break;

	   case KFLOAT:
		doit(float, datatype, size);
		break;

	   case KDOUBLE:
		doit(double, datatype, size);
		break;

	   default:
	        kexit(KEXIT_FAILURE);
	}
	kexit(KEXIT_SUCCESS);
}
