#include "bootstrap.h"
 
int main(
   int  argc,
   char *argv[])
{
	kfile *file;
	size_t  i, num;
	int     status;
	char  **words, *path = "Makefile";


	if (argc > 1)
	   path = argv[1];

	if ((file = kfopen(path, "r")) == NULL)
	{
	   kprintf("Unable to open file '%s'", path);
	   kexit(KEXIT_FAILURE);
	}

	if ((words = kparse_file_scan_delimit(file, KPARSE_BOF, KPARSE_EOF,
                  KLITERAL, " \t\n", NULL, NULL, (ssize_t *) &num,
		  &status)) == NULL)
        {
           kprintf("Cannot read contents of file '%s'\n", path);
           kexit(KEXIT_FAILURE);
        }

	words = karray_sort(words, KSTRING, num, TRUE);
	for (i = 1; i < num; i++)
	{
	   if (kstrcmp(words[i-1], words[i]) > 0)
	   {
	      kprintf("'%s' is suppose to be lexically less than '%s'\n",
				words[i-1], words[i]);
	      kexit(KEXIT_FAILURE);
	   }
	}
	karray_free(words, KSTRING, num, NULL);
	kexit(KEXIT_SUCCESS);
}
