#include "bootstrap.h"
 
#define doit(type, datatype, size) \
	{								\
                size_t  i;                                              \
                khash *hash = khash_init(datatype, (size_t) 500);       \
                                                                        \
                for (i = 0; i < size; i++)                              \
                   khash_add(hash, (type) i, (kaddr) i);                \
                                                                        \
                for (i = 0; i < size; i++)                              \
                   if (khash_check(hash, (type) i) == FALSE)		\
		      kexit(KEXIT_FAILURE);          			\
                                                                        \
                khash_free(hash, NULL);                                 \
	}

int main(
   int  argc,
   char *argv[])
{
	int    datatype = KBYTE;
	size_t size = 10;

	if (argc > 1)
	   datatype = kdatatype_to_define(argv[1]);
	if (argc > 2)
	   size = atoi(argv[2]);

	switch (datatype)
	{
	   case KBYTE:
		doit(signed char, datatype, size);
		break;

	   case KUBYTE:
		doit(signed char, datatype, size);
		break;

	   case KSHORT:
		doit(signed short, datatype, size);
		break;

	   case KUSHORT:
		doit(unsigned short, datatype, size);
		break;

	   case KINT:
		doit(signed int, datatype, size);
		break;

	   case KUINT:
		doit(unsigned int, datatype, size);
		break;

	   case KLONG:
		doit(signed long, datatype, size);
		break;

	   case KULONG:
		doit(unsigned long, datatype, size);
		break;

	   case KFLOAT:
		doit(float, datatype, size);
		break;

	   case KDOUBLE:
		doit(double, datatype, size);
		break;

	   default:
	        kexit(KEXIT_FAILURE);
	}
	kexit(KEXIT_SUCCESS);
}
