 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 01:57:11 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 01:57:11 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcmplx2real.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcmplx2real_get_args
| 
|       Purpose: Gets command line args for kcmplx2real
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcmplx2real
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void kcmplx2real_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for kcmplx2real is out of sync with arguments specified in kcmplx2real's *.pane file; please rerun ghostwriter on kcmplx2real.";


	/*
	 * allocate the kcmplx2real structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "or",
			  &(clui_info->or_file),
			  &(clui_info->or_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "oi",
			  &(clui_info->oi_file),
			  &(clui_info->oi_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "op",
			  &(clui_info->op_file),
			  &(clui_info->op_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "om",
			  &(clui_info->om_file),
			  &(clui_info->om_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mag",
			  &(clui_info->mag_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "magsq",
			  &(clui_info->magsq_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmag1",
			  &(clui_info->logmag1_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmagsq1",
			  &(clui_info->logmagsq1_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmag",
			  &(clui_info->logmag_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmagsq",
			  &(clui_info->logmagsq_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



