 /*
  * Khoros: $Id: kelevation.h,v 1.5 1996/07/05 01:58:57 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kelevation
   >>>> 
   >>>>    Written By: Steve Kubica
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kelevation_h_
#define _kelevation_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$DATAMANIP/objects/kroutine/kelevation/uis/kelevation.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input value data object to use for elevation (required infile)
 */
char	*i_file;	/* Input value data object to use for elevation FILENAME */
int	 i_flag;	/* Input value data object to use for elevation FLAG */

/*
 *  Resulting Output Object with elevation (required outfile)
 */
char	*o_file;	/* Resulting Output Object with elevation FILENAME */
int	 o_flag;	/* Resulting Output Object with elevation FLAG */

/*
 *  Explicit Location Begin for X dimension (optional double)
 */
double	 xbegin_double;	/* Explicit Location Begin for X dimension DOUBLE */
int	 xbegin_flag;   	/* Explicit Location Begin for X dimension FLAG */

/*
 *  Explicit Location End for X dimension (optional double)
 */
double	 xend_double;	/* Explicit Location End for X dimension DOUBLE */
int	 xend_flag;   	/* Explicit Location End for X dimension FLAG */

/*
 *  Explicit Location Begin for Y dimension (optional double)
 */
double	 ybegin_double;	/* Explicit Location Begin for Y dimension DOUBLE */
int	 ybegin_flag;   	/* Explicit Location Begin for Y dimension FLAG */

/*
 *  Explicit Location End for Y dimension (optional double)
 */
double	 yend_double;	/* Explicit Location End for Y dimension DOUBLE */
int	 yend_flag;   	/* Explicit Location End for Y dimension FLAG */

/*
 *  Depth of Value Plane to transfer (optional integer)
 */
int	 doff_int; 	/* Depth of Value Plane to transfer INT */
int	 doff_flag;	/* Depth of Value Plane to transfer FLAG */

/*
 *  Time of Value Plane to transfer (optional integer)
 */
int	 toff_int; 	/* Time of Value Plane to transfer INT */
int	 toff_flag;	/* Time of Value Plane to transfer FLAG */

/*
 *  Element of Value Plane to transfer (optional integer)
 */
int	 eoff_int; 	/* Element of Value Plane to transfer INT */
int	 eoff_flag;	/* Element of Value Plane to transfer FLAG */

/*
 *  Resulting Elevation will be in data type (Optional list)
 */
int	 type_list;	/* Resulting Elevation will be in data type LIST INDEX */
char	 *type_label;	/* Resulting Elevation will be in data type LIST LABEL */
int	 type_flag;	/* Resulting Elevation will be in data type FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void kelevation_get_args PROTO((kform *));
void kelevation_usage_additions PROTO((void));
void kelevation_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
