 /*
  * Khoros: $Id: kimportraw.h,v 1.12 1996/07/05 02:02:21 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kimportraw
   >>>> 
   >>>>    Written By: Scott Wilson, Jeremy Worley
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kimportraw_h_
#define _kimportraw_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include <kdatamanip/kdatamanip.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$DATAMANIP/objects/kroutine/kimportraw/uis/kimportraw.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  raw (binary) input (required infile)
 */
char	*i1_file;	/* raw (binary) input FILENAME */
int	 i1_flag;	/* raw (binary) input FLAG */

/*
 *  output object (required outfile)
 */
char	*o_file;	/* output object FILENAME */
int	 o_flag;	/* output object FLAG */

/*
 *  Object to which the new data should be added (optional infile)
 */
char	*i2_file;	/* Object to which the new data should be added FILENAME */
int	 i2_flag;	/* Object to which the new data should be added FLAG */

/*
 *  data source architecture (Optional list)
 */
int	 arch_list;	/* data source architecture LIST INDEX */
char	 *arch_label;	/* data source architecture LIST LABEL */
int	 arch_flag;	/* data source architecture FLAG */

/*
 *  data type of raw data (Optional list)
 */
int	 type_list;	/* data type of raw data LIST INDEX */
char	 *type_label;	/* data type of raw data LIST LABEL */
int	 type_flag;	/* data type of raw data FLAG */

/*
 *  Size of width dimension (optional integer)
 */
int	 wsize_int; 	/* Size of width dimension INT */
int	 wsize_flag;	/* Size of width dimension FLAG */

/*
 *  Size of height dimension (optional integer)
 */
int	 hsize_int; 	/* Size of height dimension INT */
int	 hsize_flag;	/* Size of height dimension FLAG */

/*
 *  Size of depth dimension (optional integer)
 */
int	 dsize_int; 	/* Size of depth dimension INT */
int	 dsize_flag;	/* Size of depth dimension FLAG */

/*
 *  Size of time dimension (optional integer)
 */
int	 tsize_int; 	/* Size of time dimension INT */
int	 tsize_flag;	/* Size of time dimension FLAG */

/*
 *  Size of elements dimension (optional integer)
 */
int	 esize_int; 	/* Size of elements dimension INT */
int	 esize_flag;	/* Size of elements dimension FLAG */

/*
 *  skip this number of bytes before reading (optional integer)
 */
int	 skip_int; 	/* skip this number of bytes before reading INT */
int	 skip_flag;	/* skip this number of bytes before reading FLAG */

/*
 *  destination for incoming data  (Optional list)
 */
int	 segment_list;	/* destination for incoming data  LIST INDEX */
char	 *segment_label;	/* destination for incoming data  LIST LABEL */
int	 segment_flag;	/* destination for incoming data  FLAG */

/*
 *  color space model for data (Optional list)
 */
int	 color_list;	/* color space model for data LIST INDEX */
char	 *color_label;	/* color space model for data LIST LABEL */
int	 color_flag;	/* color space model for data FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void kimportraw_get_args PROTO((kform *));
void kimportraw_usage_additions PROTO((void));
void kimportraw_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
