 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 02:05:00 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 02:05:00 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kmsquish.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kmsquish_get_args
| 
|       Purpose: Gets command line args for kmsquish
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kmsquish
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void kmsquish_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for kmsquish is out of sync with arguments specified in kmsquish's *.pane file; please rerun ghostwriter on kmsquish.";

	char  *value_string;


	/*
	 * allocate the kmsquish structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "map",
			  &(clui_info->map_logic),
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->t_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



