 /*
  * Khoros: $Id: usage.c,v 1.12 1996/07/05 02:08:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.12 1996/07/05 02:08:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ksetdattr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ksetdattr_get_args
| 
|       Purpose: Gets command line args for ksetdattr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ksetdattr
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void ksetdattr_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for ksetdattr is out of sync with arguments specified in ksetdattr's *.pane file; please rerun ghostwriter on ksetdattr.";


	/*
	 * allocate the ksetdattr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "maskpres", KVF_LIST_LABEL,
			  &(clui_info->maskpres_label),
			  &(clui_info->maskpres_flag)) &&
	      kclui_get_value(pane, "maskpres", KVF_LIST_VAL,
			  &(clui_info->maskpres_list),
			  &(clui_info->maskpres_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wkernel",
			  &(clui_info->wkernel_int),
			  &(clui_info->wkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tkernel",
			  &(clui_info->tkernel_int),
			  &(clui_info->tkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hkernel",
			  &(clui_info->hkernel_int),
			  &(clui_info->hkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ekernel",
			  &(clui_info->ekernel_int),
			  &(clui_info->ekernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dkernel",
			  &(clui_info->dkernel_int),
			  &(clui_info->dkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xbegin",
			  &(clui_info->xbegin_double),
			  &(clui_info->xbegin_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xend",
			  &(clui_info->xend_double),
			  &(clui_info->xend_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ybegin",
			  &(clui_info->ybegin_double),
			  &(clui_info->ybegin_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "yend",
			  &(clui_info->yend_double),
			  &(clui_info->yend_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "zbegin",
			  &(clui_info->zbegin_double),
			  &(clui_info->zbegin_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "zend",
			  &(clui_info->zend_double),
			  &(clui_info->zend_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wpos",
			  &(clui_info->wpos_int),
			  &(clui_info->wpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wpsize",
			  &(clui_info->wpsize_double),
			  &(clui_info->wpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hpos",
			  &(clui_info->hpos_int),
			  &(clui_info->hpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hpsize",
			  &(clui_info->hpsize_double),
			  &(clui_info->hpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dpos",
			  &(clui_info->dpos_int),
			  &(clui_info->dpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dpsize",
			  &(clui_info->dpsize_double),
			  &(clui_info->dpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tpos",
			  &(clui_info->tpos_int),
			  &(clui_info->tpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tpsize",
			  &(clui_info->tpsize_double),
			  &(clui_info->tpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "epos",
			  &(clui_info->epos_int),
			  &(clui_info->epos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "epsize",
			  &(clui_info->epsize_double),
			  &(clui_info->epsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "cspace", KVF_LIST_LABEL,
			  &(clui_info->cspace_label),
			  &(clui_info->cspace_flag)) &&
	      kclui_get_value(pane, "cspace", KVF_LIST_VAL,
			  &(clui_info->cspace_list),
			  &(clui_info->cspace_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alpha", KVF_LIST_LABEL,
			  &(clui_info->alpha_label),
			  &(clui_info->alpha_flag)) &&
	      kclui_get_value(pane, "alpha", KVF_LIST_VAL,
			  &(clui_info->alpha_list),
			  &(clui_info->alpha_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "rmasksub",
			  &(clui_info->rmasksub_double),
			  &(clui_info->rmasksub_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imasksub",
			  &(clui_info->imasksub_double),
			  &(clui_info->imasksub_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



