/*
 * Khoros: $Id: segment.h,v 1.2 1996/04/04 23:06:52 fas Exp $
 */
 
 
/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: definitions and prototypes for 
   >>>>		       data services segment code
   >>>>
   >>>>    Written By: Steve Kubica
   >>>>
   >>>>          Date: October 12, 1995
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kdataccess_segment_h_
#define _kdataccess_segment_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include <bootstrap.h>

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

#define KHOROS_THRESHOLD_SIZE_DEFAULT		3145728   /* 512x512x3x4 */

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

   /*----------------------------------------------------------------
   |   kdas_segment structure
   |   . . . . . . . . . . . . . . 
   |
   |   This is the core structure for data services, where the actual 
   |   physical data characteristics, and the physical data itself 
   |   is stored.
   \-----------------------------------------------------------------*/
typedef struct _kdas_segment 
{
   /*-- tokenized version of the segment name --*/
   ktoken id;

   /*-- physical attributes --*/
   klist *attributes;

   /*-- segment callbacks --*/
   klist *callbacks;

   /*-- segment characteristics --*/
   int    dimension;
   int    datatype;
   int   *size;
   int   *order;

   /*-- initial value --*/
   double rval;
   double ival;

   /*-- segment data is found in only *one* of the following places --*/
   kaddr           data;
   kdas_transport *temp;

   kdas_format    *format;   /*-- inherited from object --*/

   kobject         object;   /*-- mommy! --*/

   /*-- all presentations which make reference to this segment --*/
   klist          *references;

} kdas_segment;


	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

	/*-------------------------------------*
	|       macros
	---------------------------------------*/

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

#endif /* _kdataccess_segment_h_ */
/* Don't add after this point */
