#include <xvinclude.h>

/*
 *  This example tests the quit dialog box produced 
 *  by a call to the xvutils utility xvu_quit_wait().  
 *
 *  The quit dialog box is displayed until you click on 
 *  "Exit" or "Cancel"; the example prints your selection to the tty.
 *
 *  This is repeated three times.
 */
void main(
   int  argc,
   char **argv)
{
	int status, count = 0;

        /* initialize Khoros program */
        khoros_initialize(argc, argv, "CANTATA");

	/* initialize the xvwidgets lib */
	if (!xvw_initialize(XVW_MENUS_XVFORMS))
	{
	   kerror(NULL, "main", "Cannot open display");
	   kexit(KEXIT_FAILURE);
	}

	while (count < 3)
	{
 	    if (xvu_quit_wait(NULL, NULL, NULL)) 
	        kfprintf(kstderr, "\nYou clicked on 'Exit'\n"); 
	    else kfprintf(kstderr, "\nYou clicked on 'Cancel'\n");

	    count++;
	}

	kexit(KEXIT_SUCCESS);
}
