#include <xvinclude.h>

/*
 *  This example tests the save dialog box produced 
 *  by a call to the xvutils utility xvu_save_wait().  
 *
 *  The save dialog box blocks is displayed you click on
 *  "Save", "Discard", or "Ok"; the example prints your
 *   selection to the tty.
 *
 *  This is repeated three times.
 */
void main(
   int  argc,
   char **argv)
{
	int status, count = 0;

        /* initialize Khoros program */
        khoros_initialize(argc, argv, "CANTATA");

	/* initialize the xvwidgets lib */
	if (!xvw_initialize(XVW_MENUS_XVFORMS))
	{
	   kerror(NULL, "main", "Cannot open display");
	   kexit(KEXIT_FAILURE);
	}

	while (count < 3)
	{
	    char *filename = "my file";
 	    status = xvu_save_wait(NULL, NULL, NULL, NULL, NULL);
/*
	    status = ksave(KSTANDARD, "Save changes to %s?", filename);
*/
	    if (status == 2)
	        kfprintf(kstderr, "\nYou clicked on 'Save'\n");
	    else if (status == 1)
	        kfprintf(kstderr, "\nYou clicked on 'Discard'\n");
	    else if (status == 0)
	        kfprintf(kstderr, "\nYou clicked on 'Cancel'\n");
	    else  kfprintf(kstderr, "\nBogus status returned\n");

	    count++;
	}

	kexit(KEXIT_SUCCESS);
}
