/*
  * Khoros: $Id: Manager.h,v 1.1 1996/05/06 21:59:56 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Defines for the Manager Widget
   >>>>
   >>>>     Written By: Mark Young & Danielle Argiro & John Salas
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_Manager_h_
#define _kwidgets_Manager_h_

        /*-------------------------------------*
        |       #includes
        ---------------------------------------*/

#include <kwidgets/ManagerRelLayout.h>    /* attrs for relative layout       */
#include <kwidgets/ManagerPixelGeom.h>    /* attrs for pixel geometry bounds */
#include <kwidgets/ManagerPixelSpacing.h> /* attrs for pixel spacing         */
#include <kwidgets/ManagerPref.h>         /* attrs for preferred w & h       */
#include <kwidgets/ManagerManip.h>        /* attrs for direct manipulation   */
#include <kwidgets/ManagerTack.h>         /* attrs for tacking               */

        /*-------------------------------------*
        |       #defines
        ---------------------------------------*/

/*
 *  The attributes below are UNDOCUMENTED for a good reason.  Either
 *  we don't want people using them, or they are not implemented yet.
 */
#define XVW_MANAGER_RELAYOUT  	   "managerRelayout"
#define XVW_MANAGER_DELAYED_LAYOUT "managerDelayedLayout"
#define XVW_CANVAS_COLOR   	   "canvasColor"
#define XVW_CANVAS_PIXEL   	   "canvasPixel"
#define XVW_TOP_MARGIN             "topMargin"
#define XVW_BOTTOM_MARGIN          "bottomMargin"
#define XVW_LEFT_MARGIN            "leftMargin"
#define XVW_RIGHT_MARGIN           "rightMargin"
#define XVW_HORIZ_SPACING          "horizSpacing"
#define XVW_VERT_SPACING           "vertSpacing"

#define XVW_SHADOW_TYPE		   "shadowType"
#define XVW_SHADOW_THICKNESS	   "shadowThickness"
#define XVW_TOP_SHADOW_COLOR       "topShadowColorname"
#define XVW_TOP_SHADOW_PIXEL   	   "topShadowPixel"
#define XVW_BOTTOM_SHADOW_PIXEL	   "bottomShadowPixel"
#define XVW_BOTTOM_SHADOW_COLOR    "bottomShadowColorname"

#define KSHADOW_NONE         0
#define KSHADOW_OFF          1
#define KSHADOW_IN           2
#define KSHADOW_OUT          3
#define KSHADOW_ETCHED_IN    4
#define KSHADOW_ETCHED_OUT   5

#define KMANAGER_UNDEFINED   (&manager_undefined)

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Manager Object by.
 */
#define ManagerWidgetClass	xvwManagerWidgetClass


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit WidgetClass Declaration ManagerWidgetClass
 */
extern   WidgetClass     ManagerWidgetClass;
extern   long		 manager_undefined;


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

/*
 *  Khoros Function Definition for Manager Object
 */
xvobject xvw_create_manager PROTO((xvobject, char *));


#endif /* _kwidgets_Manager_h_ */
/* Do not add after this line */
