 /*
  * Khoros: $Id: xvcycle.h,v 1.4 1996/04/19 09:33:37 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                          <<<<
   >>>>       Purpose: Attributes for Cycle Selections           <<<<
   >>>>                                                          <<<<
   >>>>    Written By: Danielle Argiro                           <<<<
   >>>>                                                          <<<<
   >>>>          Date: Aug 4, 1995                               <<<<
   >>>>                                                          <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvforms_xvcycle_h_
#define _xvforms_xvcycle_h_


/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_ADD
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/CycleAdd.sec
| Type:		char *
| Valid Items:	Cycles
| Legal Values:	any string to add as new cycle member
------------------------------------------------------------------------*/
#define XVF_CYCLE_ADD  KVF_CYCLE_ADD

/*
 * this is not a public attribute; it is used only by guise
 */
#define XVF_CYCLE_CHOICES KVF_CYCLE_CHOICES

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_CONTENTS
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/CycleContents.sec
| Type:		char **
| Valid Items:	Cycles
| Legal Values:	array of strings to establish as cycle members
------------------------------------------------------------------------*/
#define XVF_CYCLE_CONTENTS  KVF_CYCLE_CONTENTS

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_DELETE
|
| Description: 	.include $DESIGN/manual/shared/xvforms/attribs/CycleDelete.sec
| Type:		char *
| Valid Items:	Cycles
| Legal Values:	string representing cycle member to delete
------------------------------------------------------------------------*/
#define XVF_CYCLE_DELETE  KVF_CYCLE_DELETE

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_DELETEALL
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/CycleDeleteAll.sec
| Type:		int
| Valid Items:	Cycles
| Legal Values:	TRUE (action attribute)
------------------------------------------------------------------------*/
#define XVF_CYCLE_DELETEALL  KVF_CYCLE_DELETEALL

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_INDEX
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/CycleIndex.sec
| Type:		int
| Valid Items:	Cycles
| Legal Values:	.symbol index XVF_CYCLE_START 
|		<= index < 
|		.symbol index XVF_CYCLE_NUM + 
|		.symbol index XVF_CYCLE_START
------------------------------------------------------------------------*/
#define XVF_CYCLE_INDEX KVF_CYCLE_INDEX

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_LABEL
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/CycleLabel.sec
| Type:		char *
| Valid Items:	Cycles
| Legal Values:	any string
------------------------------------------------------------------------*/
#define XVF_CYCLE_LABEL KVF_CYCLE_LABEL

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_SIZE
|
| Description: 	.include $DESIGN/manual/shared/xvforms/attribs/CycleSize.sec
| Type:         int
| Valid Items:  Cycles
| Legal Values:	size >= 0
------------------------------------------------------------------------*/
#define XVF_CYCLE_SIZE KVF_CYCLE_SIZE

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_START
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/CycleStart.sec
| Type:		int
| Valid Items:	Cycles
| Legal Values:	any integer value
------------------------------------------------------------------------*/
#define XVF_CYCLE_START KVF_CYCLE_START

/*------------------------------------------------------------------------
| Attribute:    XVF_CYCLE_VAL
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/CycleVal.sec
| Type:       	int
| Valid Items:	Cycles
| Legal Values: .symbol index XVF_CYCLE_START 
|		< val <= 
|		.symbol index XVF_CYCLE_START + 
|		.symbol index XVF_CYCLE_NUM
------------------------------------------------------------------------*/
#define XVF_CYCLE_VAL KVF_CYCLE_VAL

#endif /* _xvforms_xvcycle_h_ */
/* Don't add after this line */

