/*
  * Khoros: $Id: Ellipse.h,v 1.4 1996/04/04 23:21:47 fas Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines and #includes for creating a
   >>>>		       ellipse annotation.
   >>>>
   >>>>    Written By: Danielle Argiro & Steve Kubica
   >>>>
   >>>>          Date: January 8, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_Ellipse_h_
#define _xvisual_Ellipse_h_

	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

/*
 *  Attributes for Ellipse Visual Object
 */

/*------------------------------------------------------------------------
| Attribute:    XVW_ELLIPSE_XCENTER
| Description:  This double value specifies the x location of the center 
|		of the ellipse in world coordinates.
| Type:         double
| Default:      0.0
| Legal Values: +/- double
| Resource:     N/A
------------------------------------------------------------------------*/
#define XVW_ELLIPSE_XCENTER	"ellipseXcenter"

/*------------------------------------------------------------------------
| Attribute:    XVW_ELLIPSE_YCENTER
| Description:  This double value specifies the y location of the center 
|		of the ellipse in world coordinates.
| Type:         double
| Default:      0.0
| Legal Values: +/- double
| Resource:     N/A
------------------------------------------------------------------------*/
#define XVW_ELLIPSE_YCENTER	"ellipseYcenter"

/*------------------------------------------------------------------------
| Attribute:    XVW_ELLIPSE_WIDTH
| Description:  This double value specifies the width of the ellipse in 
|		world coordinates.
| Type:         double
| Default:      1.0
| Legal Values: +/- double
| Resource:     N/A
------------------------------------------------------------------------*/
#define XVW_ELLIPSE_WIDTH	"ellipseWidth"

/*------------------------------------------------------------------------
| Attribute:    XVW_ELLIPSE_HEIGHT
| Description:  This double value specifies the height of the ellipse in 
|		world coordinates.
| Type:         double
| Default:      0.75
| Legal Values: +/- double
| Resource:     N/A
------------------------------------------------------------------------*/
#define XVW_ELLIPSE_HEIGHT	"ellipseHeight"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Ellipse Object by.
 */
#define EllipseGadgetClass	xvwEllipseGadgetClass

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/*
 *  Function definitions for Ellipse Visual Object
 */
xvobject xvw_create_ellipse PROTO((xvobject, char *));


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit WidgetClass Declaration EllipseGadgetClass
 */
extern   WidgetClass     EllipseGadgetClass;


#endif /* _xvisual_Ellipse_h_ */
/* Don't add after this point */
