/*
  * Khoros: $Id: GraphicsGen.h,v 1.6 1996/04/04 23:21:54 fas Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines for general graphics attributes 
   >>>>
   >>>>    Written By: John Salas, Danielle Argiro, Mark Young
   >>>>
   >>>>          Date: Aug 20, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_GraphicsGen_h_
#define _xvisual_GraphicsGen_h_

	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_FILLED
| Description:  When set to true, this attribute indicates that the object 
|		should be filled with the foreground color;  objects are not 
|		filled by default.
| Type:         int
| Default:      FALSE
| Legal Values: TRUE/FALSE
| Resource:     graphicsFilled
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_FILLED		"graphicsFilled"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_LINETYPE
|
| Description:  Visual objects involving a line may specify the line type.
|
| Type:         int
| Default:      .symbol index KLINE_SOLID
| Legal Values: .symbol index KLINE_SOLID
|               .symbol index KLINE_DOTTED
|               .symbol index KLINE_DOT_DASH
|               .symbol index KLINE_SHORT_DASH
|               .symbol index KLINE_LONG_DASH
|               .symbol index KLINE_ODD_DASH
|               .symbol index KLINE_GRID_DOTTED
| Resource:     graphicsLinetype
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_LINETYPE		"graphicsLinetype"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_MARKERTYPE
|
| Description:  Visual objects involving one or more markers may specify 
|		the marker type to be used by the marker(s).  Choices include
|		an arc, a bow tie, a box, a caret, a circle, a cross, a dagger,
|		a diamond, a dot, a hexagon, a point, a pixel, a square, a
|		triangle, an "X", or a "V".
| Type:         int
| Type:         int
| Default:      .symbol index KMARKER_SQUARE
| Legal Values: .symbol index KMARKER_ARC
|               .symbol index KMARKER_BOW_TIE
|               .symbol index KMARKER_BOX
|               .symbol index KMARKER_CARET
|               .symbol index KMARKER_CIRCLE
|               .symbol index KMARKER_CROSS
|               .symbol index KMARKER_DAGGER
|               .symbol index KMARKER_DIAMOND
|               .symbol index KMARKER_DOT
|               .symbol index KMARKER_HEXAGON
|               .symbol index KMARKER_POINT
|               .symbol index KMARKER_PIXEL
|               .symbol index KMARKER_SQUARE
|               .symbol index KMARKER_TRIANGLE
|               .symbol index KMARKER_X
|               .symbol index KMARKER_V
| Resource:     graphicsMarkertype
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_MARKERTYPE		"graphicsMarkertype"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_MARKERSCALE
| Description:  Visual objects involving one or more markers may specify
|		the size of marker(s).
| Type:         integer
| Default:      1
| Legal Values: value >= 1
| Resource:     graphicsMarkerScale
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_MARKERSCALE     "graphicsMarkerScale"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_LINEWIDTH
| Description:  Visual objects involving a line may specify the line width.
| Type:         int
| Default:      .symbol index KLINE_EXTRA_FINE
| Legal Values: .symbol index KLINE_EXTRA_FINE
|               .symbol index KLINE_FINE
|               .symbol index KLINE_MEDIUM_FINE
|               .symbol index KLINE_MEDIUM
|               .symbol index KLINE_MEDIUM_WIDE
|               .symbol index KLINE_WIDE
|               .symbol index KLINE_EXTRA_WIDE
| Resource:     graphicsLinewidth
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_LINEWIDTH		"graphicsLinewidth"

/*
 * the XVW_GRAPHICS_TYPE attribute is used internally, but should
 * not be used by the calling application.
 */
#define XVW_GRAPHICS_TYPE		"graphicsType"

#endif /* _xvisual_GraphicsGen_h_ */
/* Don't add after this point */
