 /*
  * Khoros: $Id: GlyphP.h,v 1.16.4.1 1996/12/06 20:29:00 fas Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for Glyph object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: May 21, 1993 09:42
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvlang_GlyphP_h_
#define _xvlang_GlyphP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvlang/Glyph.h>
#include <xvlang/NodeP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct _XvwGlyphWidgetClassPart
{
   XtPointer  extension;
} XvwGlyphWidgetClassPart;

typedef struct _XvwGlyphWidgetClassRec
{
   CoreClassPart		core_class;
   CompositeClassPart		composite_class;
   ConstraintClassPart		constraint_class;
   XvwManagerWidgetClassPart	manager_class;
   XvwNodeWidgetClassPart	node_class;
   XvwGlyphWidgetClassPart	glyph_class;
} XvwGlyphWidgetClassRec;

extern  XvwGlyphWidgetClassRec xvwGlyphWidgetClassRec;

typedef struct
{
   kform    *form;
   String   tbname;
   String   oname;
   String   panefile;

   int      echo;
   Boolean  reporting;
   kaddr    expression_id;      /* the parent to create the connection on     */
   Widget   connection_parent;  /* the parent to create the connection on     */

   xvobject menuform;
   xvobject error;
   xvobject help, cli;
   xvobject cflow_in;		/* the input control flow object 	      */
   xvobject cflow_out;		/* the output control flow object 	      */

   Pixmap   error_pixmap;
   Pixmap   info_pixmap;
   Pixmap   openpane_pixmap;
   Pixmap   closepane_pixmap;

   int		rsize;
   kform_struct	**rsels;
   kform_struct **isels;
   kform_struct **osels;

   xvobject last_iport;
   Boolean  created_form;          /* whether we created the form or not     */
   xvobject export_button;         /* export selection button		     */
   xvobject options_button;        /* options button for options pulldown    */
   Boolean  options_initialized;   /* export selection button		     */

   pid_t       dbxpid;        /* the debugger process id		     */
   Boolean     debug;         /* whether process debugging is on or off      */
   Boolean     runtime;       /* whether runtime logging is on or off        */
   size_t      num_runs;      /* number of times process has been run        */
   time_t      start_time;    /* time process was executed (for time/date)   */
   time_t      end_time;      /* time process ended (for time/date)          */
   char	       *command;
} XvwGlyphPart;


typedef struct _XvwGlyphWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwNodePart		node;
  XvwGlyphPart		glyph;

} XvwGlyphWidgetRec;

typedef struct {int empty;} XvwGlyphConstraintsPart;

typedef struct _XvwGlyphWidgetConstraintsRec {
    XvwManagerConstraintsPart	manager;
    XvwNodeConstraintsPart	node;
    XvwGlyphConstraintsPart	glyph;
} XvwGlyphWidgetConstraintsRec, *XvwGlyphWidgetConstraints;

typedef struct  _XvwGlyphWidgetClassRec  *XvwGlyphWidgetClass;
typedef struct  _XvwGlyphWidgetRec       *XvwGlyphWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwGlyphWidget
 */
extern XvwGlyphWidgetClassRec xvwGlyphWidgetClassRec;


#endif /* _xvlang_GlyphP_h_ */
/* Do not add after this line */
