 /*
  * Khoros: $Id: ToolboxMenu.h,v 1.6 1996/04/19 09:34:30 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Definitions for Khoros ToolboxMenu Object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Jul 02, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvlang_ToolboxMenu_h_
#define _xvlang_ToolboxMenu_h_

        /*-------------------------------------*
        |       #defines
        ---------------------------------------*/


/*------------------------------------------------------------------------
| Attribute:    XVW_TOOLBOXMENU_CREATE
|
| Description:  If desired,  \fIxvw_add_callback()\fP may be used to install
|               a callback on the toolboxmenu object which will be fired each
|               time the user selects an operator from the toolboxmenu using 
|		the walking menus.
|
|               When calling \fIxvw_add_callback()\fP, pass this attribute
|               directly, as in
|               .begin code
|               xvw_add_callback(toolboxlist, XVW_TOOLBOXMENU_CREATE,
|                                toolboxlist_cb, client_data);
|               .end code
|               An \fIxvw_program_info\fP structure will be passed into
|               the callback as the \fIcall_data\fP; this structure consists
|               of the information about the operator that was selected from 
|		the toolbox list.
|
|               The xvw_program_info() structure is defined as follows:
|               .begin code
|               typedef struct
|               {
|                   int  type;         { type of glyph; one of:
|                                        XVL_OPERATOR    (normal operator),
|                                        XVL_PROCEDURE   (procedure),
|                                        XVL_LOOP        (loop), or
|                                        XVL_CONDITIONAL (conditional) }
|                   char *tbname;      {  toolbox name       }
|                   char *oname;       {  object name        }
|                   char *category;    {  category           }
|                   char *subcategory; {  subcategory        }
|                   char *icon_name;   {  icon name          }
|                   char *panefile;    {  filename of pane file  }
|                   char *short_desc;  {  short description  }
|                   char *workspace;   {  saved workspace file from which
|                                         glyph originated (if applicable)  }
|               } xvw_program_info;
|
|               Inside the callback, the call_data must be cast to the
|               xvw_program_info typedef before use, as follows:
|               .begin code
|               xvw_program_info *program_info = (xvw_program_info *) call_data;
|               .end code
|
| Type:         kfunc_void
| Default:      NULL
| Legal Values: N/A
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_TOOLBOXMENU_CREATE   "toolboxmenuCreate"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the ToolboxMenu Object by.
 */
#define ToolboxMenuWidgetClass	xvwToolboxMenuWidgetClass

        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit WidgetClass Declaration ToolboxMenuWidgetClass
 */
extern   WidgetClass     ToolboxMenuWidgetClass;


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

/*
 *  Khoros Function Definition for ToolboxMenu Object
 */
xvobject xvw_create_toolboxmenu PROTO((xvobject, char *));


#endif /* _xvlang_ToolboxMenu_h_ */
/* Do not add after this line */
