 /*
  * Khoros: $Id: xvlang.h,v 1.7.4.1 1996/12/06 20:29:05 fas Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: all #defines, structures, and global
   >>>>		       definitions used by the xvlang library
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Apr 16, 1993 11:26
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _xvlang_xvlang_h_
#define _xvlang_xvlang_h_


	/*-------------------------------------*
	|       #include 
	---------------------------------------*/

#include <xvlang/Procedure.h>
#include <xvlang/Loop.h>
#include <xvlang/Conditional.h>
#include <xvlang/Workspace.h>
#include <xvlang/Node.h>
#include <xvlang/Glyph.h>
#include <xvlang/Port.h>
#include <xvlang/ExtPort.h>

#include <xvlang/CommandBar.h>
#include <xvlang/ToolboxMenu.h>
#include <xvlang/ToolboxList.h>
#include <xvlang/FinderList.h>


	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

#define XVL_OPERATOR    1
#define XVL_PROCEDURE   2
#define XVL_CONDITIONAL 3
#define XVL_LOOP	4

#define XVL_EXPR_ADD    1
#define XVL_EXPR_DELETE 2
#define XVL_EXPR_UPDATE 3

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

/*
 *  Callback structure for the toolbox and finder objects.  The calldata
 *  consists of the information necessary to create or print info about
 *  operators.
 */
typedef struct
{
	int  type;
	char *tbname;
	char *oname;
	char *category;
	char *subcategory;
	char *icon_name;
	char *panefile;
	char *workspace;
	char *short_desc;
} xvw_program_info;


	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/


	/*-------------------------------------*
	|       macros
	---------------------------------------*/


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/*
 *  updateform.c
 */
void xvl_set_contents   PROTO((klist *, klist *));
void xvl_get_contents   PROTO((klist **, klist **));
int  xvl_load_contents  PROTO((klist *, xvw_program_info *));
 
void xvl_expr_add_callback     PROTO((kfunc_void, kaddr));
void xvl_expr_remove_callback  PROTO((kfunc_void, kaddr));

/*
 *  utilities.c
 */
void  xvl_enable_reporting  PROTO((int));
kfile *xvl_get_logfile      PROTO((void));
void  xvl_propagate_wksp_attributes PROTO((xvobject, xvobject));

#endif /* _xvlang_xvlang_h_ */
/* Don't add after this point */
