/*
  * Khoros: $Id: InfoP.h,v 1.5 1996/05/06 22:05:27 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for Info object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_InfoP_h_
#define _xvobjects_InfoP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvobjects/Info.h>
#include <kwidgets/ManagerP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct _XvwInfoWidgetClassPart
{
     XtPointer  extension;
} XvwInfoWidgetClassPart;

typedef struct _XvwInfoWidgetClassRec
{
   CoreClassPart		core_class;
   CompositeClassPart		composite_class;
   ConstraintClassPart		constraint_class;
   XvwManagerWidgetClassPart	manager_class;
   XvwInfoWidgetClassPart	info_class;
} XvwInfoWidgetClassRec;

extern  XvwInfoWidgetClassRec xvwInfoWidgetClassRec;

typedef struct
{
   xvobject button;
   xvobject label;
   xvobject text;
   Pixmap   info_pixmap;
   XtCallbackList info_callback;

} XvwInfoPart;


typedef struct _XvwInfoWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwInfoPart		info;

} XvwInfoWidgetRec;

typedef struct {int empty;} XvwInfoConstraintsPart;

typedef struct _XvwInfoWidgetConstraintsRec {
    XvwManagerConstraintsPart	manager;
    XvwInfoConstraintsPart	info;
} XvwInfoWidgetConstraintsRec, *XvwInfoWidgetConstraints;

typedef struct  _XvwInfoWidgetClassRec  *XvwInfoWidgetClass;
typedef struct  _XvwInfoWidgetRec       *XvwInfoWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwInfoWidget
 */
extern XvwInfoWidgetClassRec xvwInfoWidgetClassRec;


#endif /* _xvobjects_InfoP_h_ */
/* Do not add after this line */
