 /*
  * Khoros: $Id: TitleBar.h,v 1.3 1996/06/13 21:26:05 mirage Exp $
  */


/*
 * Copyright (C) 1993, 1994, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Attributes of  TitleBar Widget
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Dec 17, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_TitleBar_h_
#define _xvobjects_TitleBar_h_

        /*-------------------------------------*
        |       #defines
        ---------------------------------------*/


/*------------------------------------------------------------------------
| Attribute:	XVW_TITLEBAR_TITLE_OBJECT
|
| Description:  This \fIread-only\fP attribute allows you to obtain the
|               title label object component of the the titlebar object.
|
| Type:         xvobject
| Default:      NULL
| Legal Values: The title label object (read-only).
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_TITLEBAR_TITLE_OBJECT	"titlebarTitleObject"

/*------------------------------------------------------------------------
| Attribute:	XVW_TITLEBAR_ICONIFY_OBJECT
|
| Description:  This \fIread-only\fP attribute allows you to obtain the
|               iconify button object component of the the titlebar object.
|
| Type:         xvobject
| Default:      NULL
| Legal Values: The iconify button object (read-only).
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_TITLEBAR_ICONIFY_OBJECT	"titlebarIconifyObject"

/*------------------------------------------------------------------------
| Attribute:	XVW_TITLEBAR_DETACH_OBJECT
|
| Description:  This \fIread-only\fP attribute allows you to obtain the
|               detach object component of the the titlebar object.
|
| Type:         xvobject
| Default:      NULL
| Legal Values: The title object (read-only).
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_TITLEBAR_DETACH_OBJECT	"titlebarDetachObject"

/*------------------------------------------------------------------------
| Attribute:	XVW_TITLEBAR_ICON_OBJECT
|
| Description:  This attribute allows you to set the icon object, which is
|		mapped when the user iconifies the parent via the iconify
|		button located on the titlebar.  The icon object will have
|		a double click action placed on it, in order for the titlebar
|		to know how to uniconify the parent.
|
| Type:         xvobject
| Default:      NULL
| Legal Values: The icon object
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_TITLEBAR_ICON_OBJECT	"titlebarIconObject"

/*------------------------------------------------------------------------
| Attribute:	XVW_TITLEBAR_CALLBACK
|
| Description:  If desired, \fIxvw_add_callback()\fP may be used to install
|               a callback on the titlebar object which will be fired when
|               the user closes or iconifies the parent object, thru the
|		iconify buttons on the titlebar.
|               When calling \fIxvw_add_callback()\fP, pass this attribute
|               directly, as in
|               .begin code
|               xvw_add_callback(titlebarobj, XVW_TITLEBAR_CALLBACK,
|                                titlebar_cb, client_data);
|               .end code
|               Note that the current text appearing in the titlebar object 
|		will be passed to the callback in the \fIcall_data\fP.  The 
|		value must be cast to a string before use, as in:
|               .br
|               \f(CWint iconify = *((int *) call_data);\fP
|               .br
|
| Type:         kfunc_void
| Default:      NULL
| Legal Values: callback function, in the form:
|		.begin code
|		void callback_function
|		   xvobject object,
|		   kaddr client_data,
|		   kaddr call_data)
|		.end code
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_TITLEBAR_CALLBACK		"titlebarCallback"


/*
 *  Define the Class name, by which people should be externally referencing
 *  the TitleBar Object by.
 */
#define TitleBarWidgetClass	xvwTitleBarWidgetClass


/*
 *  Callback type for the indicating what action needs to be preformed.
 */
#define KTITLEBAR_ICONIFIED     1
#define KTITLEBAR_DETACHED      2
#define KTITLEBAR_REATTACHED    3


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit WidgetClass Declaration TitleBarWidgetClass
 */
extern   WidgetClass     TitleBarWidgetClass;


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

/*
 *  Khoros Function Definition for TitleBar Object
 */
xvobject xvw_create_titlebar PROTO((xvobject, char *));


#endif /* _xvobjects_TitleBar_h_ */
/* Do not add after this line */
