 /*
  * Khoros: $Id: kcat.c,v 1.13 1996/07/05 01:43:58 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: kcat.c,v 1.13 1996/07/05 01:43:58 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for kcat
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "kcat.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Utility for sequencing of file display in cantata.
|
|       Purpose: main program for kcat
|
|         Input:
|		char *clui_info->i_string; {Input List of Images}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {Resulting output data object}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: Mark Young
|          Date: Jul 04, 1996
| Modifications:
|
------------------------------------------------------------*/

void main(
   int  argc,
   char **argv)
{

	kform  *pane;         /* form tree representing *.pane file */
/* -main_variable_list */
	char *outfile, *infile, **files;
	int  i; 
	size_t num = 0; 
	int  mode = KFILE|KPATH|KLINK;
/* -main_variable_list_end */

	khoros_initialize(argc, argv, "DESIGN");
	kexit_handler(kcat_free_args, NULL);

/* -main_get_args_call */
	kclui_initialize(PANEPATH, KGEN_KROUTINE, "DESIGN", "kcat",
		kcat_usage_additions, kcat_get_args,
		kcat_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
	outfile = clui_info->o_file;
	infile  = clui_info->i_string;
	files = karray_dirlist(infile, NULL, NULL, mode, FALSE, &num);
/* -main_before_lib_call_end */

/* -main_library_call */
	for (i = 0; i < num; i++)
	   kcopyfile(files[i], outfile);
/* -main_library_call_end */

/* -main_after_lib_call */
	karray_free(files, KSTRING, num, NULL);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: kcat_usage_additions
| 
|       Purpose: Prints usage additions in kcat_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcat
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void kcat_usage_additions(void)
{
	kfprintf(kstderr, "\tUtility for sequencing of file display in cantata.\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: kcat_free_args
| 
|       Purpose: Frees CLUI struct allocated in kcat_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcat
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
kcat_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_string);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
