 /*
  * Khoros: $Id: ToolTips.c,v 1.4 1996/06/21 07:04:58 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: ToolTips.c,v 1.4 1996/06/21 07:04:58 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>	              Khoros ToolTips Widget
   >>>>  Private:
   >>>>   Static:
   >>>> 		ClassInitialize()
   >>>> 		Realize()
   >>>>                 SetValues()
   >>>>                 UpdateMessage()
   >>>>			Initialize()
   >>>>   Public:
   >>>>			xvw_create_tooltips()
   >>>>	
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"
#include <xvobjects/ToolTipsP.h>

static void ClassInitialize PROTO((void));
static void Realize        PROTO((Widget,XtValueMask *,XSetWindowAttributes *));
static void Initialize	   PROTO((Widget, Widget, ArgList, Cardinal *));
static Boolean SetValues   PROTO((Widget, Widget, Widget, ArgList, Cardinal *));
static void UpdateMessage  PROTO((XtPointer, XtIntervalId  *id));


/*-------------------------------------------------------------------*
|
|   Full class attributes
|
--------------------------------------------------------------------*/

static xvattribute attributes[] = {
{XVW_TOOLTIPS_MESSAGE, NULL,   XtRString,   NULL},
};


/*-------------------------------------------------------------------*
|
|   Full class record constant
|
--------------------------------------------------------------------*/

#define offset(field) XtOffsetOf(XvwToolTipsWidgetRec, tooltips.field)

static XtResource resources[] = { 

{XVW_TOOLTIPS_MESSAGE, NULL, XtRString, sizeof(String),
        offset(message), XtRString, (XtPointer) NULL},

{XVW_SHADOW_TYPE, NULL, XtRInt, sizeof(int),
        XtOffsetOf(XvwToolTipsWidgetRec, manager.shadow_type),
        XtRImmediate, (XtPointer) KSHADOW_OUT},
{XVW_PREFERRED_WIDTH, NULL, XtRDimension, sizeof(Dimension),
        XtOffsetOf(XvwToolTipsWidgetRec, manager.preferred_width),
        XtRImmediate, (XtPointer) 100},
{XVW_PREFERRED_HEIGHT, NULL, XtRDimension, sizeof(Dimension),
        XtOffsetOf(XvwToolTipsWidgetRec, manager.preferred_height),
        XtRImmediate, (XtPointer) 20},
};
#undef offset


/*-------------------------------------------------------------------*
|
|   Class Declaration for ToolTips Widget
|
--------------------------------------------------------------------*/

#define superclass (&xvwManagerWidgetClassRec)

XvwToolTipsWidgetClassRec xvwToolTipsWidgetClassRec =
{
  {
    (WidgetClass) superclass,		/* superclass		  */	
    "ToolTips",			/* class_name		  */
    sizeof(XvwToolTipsWidgetRec),	/* size			  */
    ClassInitialize,			/* class_initialize	  */
    NULL,				/* class_part_initialize  */
    FALSE,				/* class_inited		  */
    Initialize,				/* initialize		  */
    NULL,				/* initialize_hook	  */
    Realize,				/* realize		  */
    NULL,				/* actions		  */
    0,					/* num_actions		  */
    resources,				/* resources		  */
    XtNumber(resources),		/* resource_count	  */
    NULLQUARK,				/* xrm_class		  */
    TRUE,				/* compress_motion	  */
    XtExposeCompressMaximal,		/* compress_exposure	  */
    TRUE,				/* compress_enterleave    */
    FALSE,				/* visible_interest	  */
    NULL,				/* destroy		  */
    NULL,				/* resize		  */
    XtInheritExpose,			/* expose		  */
    SetValues,				/* set_values		  */
    NULL,				/* set_values_hook	  */
    XtInheritSetValuesAlmost,		/* set_values_almost	  */
    NULL,				/* get_values_hook	  */
    NULL,				/* accept_focus		  */
    XtVersion,				/* version		  */
    NULL,				/* callback_private	  */
    NULL,				/* tm_table		  */
    XtInheritQueryGeometry,		/* query_geometry	  */
    XtInheritDisplayAccelerator,	/* display_accelerator	  */
    NULL				/* extension		  */
  },  /* CoreClass fields initialization */
  {
    NULL,                    		/* geometry_manager	  */
    XtInheritChangeManaged,		/* change_managed	  */
    XtInheritInsertChild,		/* insert_child	  	  */
    XtInheritDeleteChild,		/* delete_child	  	  */
    NULL,				/* extension	 	  */
  },  /* CompositeClass fields initialization */
  {
    NULL,				    /* subresources	  */
    0,					    /* subresources_count */
    sizeof(XvwToolTipsWidgetConstraintsRec),  /* constraint_size	  */
    NULL,				    /* initialize	  */
    NULL,				    /* destroy		  */
    NULL,				    /* set_values	  */
    NULL,				    /* extension	  */
  },  /* ConstraintClass fields initialization */
  {
    XtInheritLayout,			    /* pre-layout routine     */
    XtInheritLayout,			    /* post-layout routine    */
    XtInheritChangeSel,			    /* change selected proc   */
    XtInheritEraseSel,			    /* erase selected proc    */
    XtInheritRefreshSel,		    /* refresh selection proc */
    XtInheritResize,			    /* resize		      */
    XtInheritGeometryManager,		    /* geometry_manager	      */
  },  /* XvwManagerWidgetClass fields initialization */
  {
    NULL,  		                    /* extension          */
  },  /* XvwToolTipsWidgetClass fields initialization */
};
#undef superclass

  /* for public consumption */
WidgetClass xvwToolTipsWidgetClass = (WidgetClass) &xvwToolTipsWidgetClassRec;


/*-------------------------------------------------------------------*
|
|   Miscelleanous defines for widget definition
|
--------------------------------------------------------------------*/

#undef  kwidget
#define kwidget(widget)	     (XvwToolTipsWidget) (widget)


/*-----------------------------------------------------------
|
|  Routine Name: ClassInitialize
|
|       Purpose: This method is called the first time an
|                instance of a XvwToolTipsWidget class has been created.
|                This is where the attributes for the class are
|		 initialized. 
|
|    Written By: Mark Young
|          Date: Apr 06, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */
static void ClassInitialize(void)
{
	xvw_init_attributes(xvwToolTipsWidgetClass, attributes,
		XtNumber(attributes), NULL, 0, NULL);
	xvw_load_resources("$DESIGN/objects/library/xvobjects/app-defaults/ToolTips");
}

/*-----------------------------------------------------------
|
|  Routine Name: Initialize
|
|	Purpose: This method will set up the initial tooltips widget
|		 instance.
|
|	  Input: request - not used
|                new     - widget instance after initialization
|    Written By: Mark Young
|          Date: Apr 06, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */
static void Initialize(
   Widget   request,
   Widget   new,
   ArgList  args,
   Cardinal *num_args)
{
	XvwToolTipsWidget xwid = kwidget(new);
	xvobject object = xvw_object(new);


	xwid->tooltips.id = 0;
	xwid->tooltips.visible = FALSE;
	xwid->tooltips.elapsed_time = 1.0;
	xwid->tooltips.text = xvw_create_label(object, "text");
	xvw_set_attributes(xwid->tooltips.text,
			XVW_LABEL, "",
			XVW_BELOW, NULL,
			XVW_RIGHT_OF, NULL,
			XVW_CHAR_MIN_HEIGHT, 1.0,
			XVW_CHAR_MIN_WIDTH,  10.0,
			NULL);
}

/*-----------------------------------------------------------
|
|  Routine Name: Realize
|
|       Purpose: This method will set up the window attributes
|                and create a window for the XvwToolTipsWidget. 
|                The desired initial window attributes are passed 
|                in via a mask and list of specification attributes.
|
|         Input: widget     - the widget to realize
|                valuemask  - determines the window attributes being passed in
|                attributes - the list of window attributes to be set
|    Written By: Mark Young
|          Date: Apr 06, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */
static void Realize(
   Widget               widget,
   XtValueMask          *valuemask,
   XSetWindowAttributes *winattrib)
{
	XvwToolTipsWidget xwid = kwidget(widget);

	xvobject object = xvw_object(widget);

	(*xvwToolTipsWidgetClass->core_class.superclass->core_class.realize)
		(widget, valuemask, winattrib);

	if (xwid->tooltips.visible == FALSE)
	   xvw_unmap(object);
}

/*-----------------------------------------------------------
|
|  Routine Name: SetValues
|
|       Purpose: This method is used to set the public values
|                of a XvwToolTipsWidget instance.  The public values
|                which can be changed are all related to the display
|		 of the tooltips.
|
|         Input: current - the widget containing current settings
|                request - the widget containing requested settings
|                new     - the widget processed through all set values methods
|       Returns: TRUE (1) if redisplay is required, FALSE (0) otherwise
|    Written By: Mark Young
|          Date: Apr 06, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */
static Boolean SetValues(
   Widget   current,
   Widget   request,
   Widget   new,
   ArgList  args,
   Cardinal *num)
{
	XvwToolTipsWidget cxwid = kwidget(current);
	XvwToolTipsWidget nxwid = kwidget(new);

	if (cxwid->tooltips.message != nxwid->tooltips.message)
	{
	   xvobject object = xvw_object(new);

 	   if (nxwid->tooltips.id != 0)
	      XtRemoveTimeOut(nxwid->tooltips.id);

	   xvw_unmap(object);
	   nxwid->tooltips.id = 0;
	   nxwid->tooltips.visible = FALSE;
	   if (kstrlen(nxwid->tooltips.message))
	   {
	      unsigned long show_time = nxwid->tooltips.elapsed_time * 1000;

              nxwid->tooltips.id = XtAppAddTimeOut(xvw_appcontext(object),
			show_time, UpdateMessage, (XtPointer) object);
	      xvw_set_attribute(nxwid->tooltips.text, XVW_LABEL,
			nxwid->tooltips.message);
	      nxwid->tooltips.message = "";
	   }
	}
	return(FALSE);
}

/*-----------------------------------------------------------
|
|  Routine Name: UpdateMessage - update and display the tooltips message
|
|       Purpose: This routine will refresh display the tooltips message. 
|
|         Input: object - the object which update the connection
|    Written By: Mark Young
|          Date: Apr 06, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */
static void UpdateMessage(
   XtPointer     client_data,
   XtIntervalId  *id)
{
	xvobject object = (xvobject) client_data;
	XvwToolTipsWidget xwid = (XvwToolTipsWidget) xvw_widget(object);


	/* 
	 * Place the update
	 */
	xvw_place(object, NULL, 0, 35);
	xwid->tooltips.visible = TRUE;
}

/************************************************************
*
*  Routine Name: xvw_create_tooltips - create a tooltips object
*
*       Purpose: The tooltips object provides a convenient mechanism
*		 for the application to bubble the user when it is performing
*		 an operation that will take some time, and that the user
*		 is expected to wait patiently until it is done.  
*
*		 The tooltips object pops up without placement;
*		 it contains an icon (by default, an hourglass), a
*		 label, and a message so that the application may inform
*		 the user exactly why they are waiting. 
*
*		 When necessary, the message displayed 
*		 by the tooltips can be updated using the 
*		 \f(CWXVW_TOOLTIPS_MESSAGE\fP attribute, and the 
*                tooltips object popped up if no update is set
*		 after so much time.
*         Input: parent - parent of the tooltips object; NULL will cause
*                         a default toplevel to be created automatically
*                name   - a name for this particular instance of the object
*                         (for use in app-defaults files, etc)
*
*        Output:
*       Returns: The tooltips object on success, NULL on failure
*
*  Restrictions:
*    Written By: Mark Young
*          Date: Apr 06, 1996
*      Verified: 
*  Side Effects:
* Modifications:
*
*******************************************************************/

xvobject xvw_create_tooltips(
   xvobject parent,
   char     *name)
{
	xvobject object;

	object = xvw_create(parent, TRUE, FALSE, name, ToolTipsWidgetClass);
	if (object == NULL)
	   return(NULL);

	if (parent == NULL)
	{
	   Widget widget = xvw_widget(xvw_toplevel(object));
	   XtVaSetValues(widget, XtNoverrideRedirect, TRUE, NULL);
	}
	return(object);
}
