 /*
  * Khoros: $Id: resources.c,v 1.8 1996/05/20 11:03:07 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: resources.c,v 1.8 1996/05/20 11:03:07 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Private Resources Routines
   >>>>		
   >>>>  Private:
   >>>>                 xvw_load_resources()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"


/*--------------------------------------------------------------
|
|  Routine Name: xvw_load_resources
|
|       Purpose: load resources for a specific resource filename..
|         Input: filename - the name of resource file
|		 global_dir - the path to the resource file
|        Output: none
|	Returns: none
|
|          Date: Jun 17, 1993
|    Written By: Mark Young
| Modifications:
|
----------------------------------------------------------------*/

void xvw_load_resources(
   char *path)
{
	Display *display;
	char *file, filename[KLENGTH], temp[KLENGTH], dbpath[KLENGTH];


	/*
	 *  Sanity check to make sure we've initialized
	 */
	if ((display = xvw_display(NULL)) == NULL)
	   return;

	if (!kbasename(path, filename))
	    return;

	if ((kfullpath(filename, "~/app-defaults", temp) &&
	     kaccess(temp, R_OK) == 0))
	{
	   kstrcpy(dbpath, temp);
	}
	else if ((file = XtResolvePathname(display, "app-defaults", filename,
			NULL, NULL, NULL, 0, NULL)) != NULL &&
		 kstrcmp(kbasename(file, temp), filename) == 0)
	{
	   kstrcpy(dbpath, file);
	   kfree_and_NULL(file);
	}
	else if (kaccess(path, R_OK) == 0)
	   kfullpath(path, NULL, dbpath);
	else
	   return;

#if (XlibSpecificationRelease == 4)
#define XLIB_ILLEGAL_ACCESS
	{
	   XrmDatabase newdb = XrmGetFileDatabase(dbpath);
	   (void) XrmMergeDatabases(newdb, &display->db);
	}
#else
	{
	   XrmDatabase database = XrmGetDatabase(display);
	   XrmCombineFileDatabase(dbpath, &database, TRUE);
	}
#endif
}
