 /*
  * Khoros: $Id: create.c,v 1.26.4.1 1996/12/06 20:30:40 fas Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: create.c,v 1.26.4.1 1996/12/06 20:30:40 fas Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Routines For Creating and Initializing Cantata
   >>>> 
   >>>>  Private: 
   >>>>			initialize_cantata()
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "cantata.h"

xvobject default_workspace;
/*-----------------------------------------------------------
|
|  Routine Name: initialize_cantata
|
|       Purpose: Initialize cantata
|       Returns:
|    Written By: Mark Young
|          Date: Sep 10, 1994
| Modifications:
|
------------------------------------------------------------*/
/* ARGSUSED */
void initialize_cantata(void)
{
	xvobject   parent, tmp;
	int	   width, height; 
	kobject    toolbox, obj, program = NULL;
	char	   *tbname, *oname, *filename = NULL;

        notifier = xvw_create_notifywindow(NULL, "notifier");
        xvw_set_attributes(notifier,
                           XVW_NOTIFYWINDOW_VISIBLE, TRUE,
                           XVW_RESIZABLE,            TRUE,
                           XVW_WIDTH,                382,
                           XVW_NOTIFYWINDOW_TITLE,   "Working . . .",
                           XVW_NOTIFYWINDOW_LABEL,   "Please Wait",
                           XVW_NOTIFYWINDOW_MESSAGE, "Initializing Cantata",
                           NULL);

	gui_parent = xvw_parent(gui_info->workspace);
	sash = xvw_create_sash(gui_parent, "Sash");
	xvw_set_attributes(gui_info->workspace,
		XVW_ABOVE, sash,
		XVW_TACK_EDGE, KMANAGER_TACK_ALL,
		NULL);
	if (clui_info->mini_flag == TRUE)
	{
	   xvw_set_attribute(sash, XVW_YPOSITION, 450);
	   xvw_set_attributes(gui_parent,
		XVW_WIDTH,  500,
		XVW_HEIGHT, 450,
		NULL);
 	   cantata_size_mini = TRUE;
	   xvf_set_attribute(gui_info->size_struct, XVF_TITLE, "Large Size");
	}
	else
	{
	   xvw_set_attribute(sash, XVW_YPOSITION, 600);
	   xvw_set_attributes(gui_parent,
		XVW_WIDTH,  750,
		XVW_HEIGHT, 700,
		NULL);
	   cantata_size_mini = FALSE;
	   xvf_set_attribute(gui_info->size_struct, XVF_TITLE, "Small Size");
	}
	tmp = xvf_get_xvobject(gui_info->cantata_struct, XVF_LABEL_OBJ, TRUE);
	xvw_unmap(tmp);

	/*
	 *  Create the menu area in which we will allow the user to play 
	 */
	tbmenu = xvf_get_pulldown_parent();
	xvw_set_attributes(tbmenu,
	        XVW_BELOW,     NULL,
	        XVW_TACK_EDGE, KMANAGER_TACK_HORIZ,
		NULL);
	if (!clui_info->tbmenus_logic)
	   xvw_unmanage(tbmenu);

	/*
	 *  Create the commandbar object 
	 */
	commandbar = xvw_create_commandbar(gui_parent, "CommandBar");
	xvw_set_attributes(commandbar,
		   XVW_BELOW,     tbmenu,
		   XVW_TACK_EDGE, KMANAGER_TACK_HORIZ,
		   NULL);

	xvw_set_attribute(gui_info->workspace, XVW_BELOW, commandbar);
	if (clui_info->commandbar_logic == FALSE || clui_info->mini_flag)
	{
	   xvw_unmanage(commandbar);
           xvf_set_attribute(gui_info->commandbar_struct, 
				XVF_TITLE, "Show Commandbar");
	}
	else
	{
           xvf_set_attribute(gui_info->commandbar_struct, 
				XVF_TITLE, "Hide Commandbar");
	}

	/*
	 *  Create the console for cantata
	 */
	console = xvw_create_console(gui_parent, "Console");
        xvw_set_attributes(console,
		XVW_TACK_EDGE, KMANAGER_TACK_ALL,
		XVW_CONSOLE_MAXLINES, 100,
		XVW_MINIMUM_HEIGHT,   100,
		XVW_ABOVE, NULL,
		XVW_BELOW, sash,
		NULL);
	if (clui_info->console_logic == FALSE || clui_info->mini_flag)
	{
	   xvw_unmanage(console);
           xvf_set_attribute(gui_info->console_struct, 
				XVF_TITLE, "Show Console");
	}
	else
 	{
           xvf_set_attribute(gui_info->console_struct, 
				XVF_TITLE, "Hide Console");
 	}

	/*
	 *  Create the active workspace indicator
	 */
	active_indicator = xvw_create_label(gui_info->workspace, "Active");
	xvw_set_attributes(active_indicator,
                XVW_BORDER_WIDTH,    1,
		XVW_CHAR_HEIGHT,     1.0,
                XVW_SHADOW_TYPE,     KSHADOW_IN,
		XVW_ABOVE,           NULL,
		XVW_LEFT_OF,         NULL,
		XVW_LABEL,	     "MainWorkspace",
		NULL);

        statusobj = xvw_create_label(gui_info->workspace, "Status");
        xvw_set_attributes(statusobj,
                XVW_BORDER_WIDTH,    1,
		XVW_CHAR_HEIGHT,     1.0,
                XVW_SHADOW_TYPE,     KSHADOW_IN,
                XVW_TACK_EDGE,       KMANAGER_TACK_HORIZ,
                XVW_ABOVE,           NULL,
		XVW_RIGHT_OF,	     NULL,
		XVW_FORCE_REDISPLAY, TRUE,
		XVW_LEFT_OF,	     active_indicator,
		XVW_TACK_EDGE,	     KMANAGER_TACK_HORIZ,
                NULL);

        /*
         *  Create the notebook in which to hold our workspaces
         */
        notebook = xvw_create_notebook(gui_info->workspace, "MainWorkspace");
        xvw_set_attributes(notebook,
                XVW_ABOVE,     active_indicator,
                XVW_TACK_EDGE, KMANAGER_TACK_ALL,
                NULL);
	xvw_add_callback(notebook, XVW_NOTEBOOK_CALLBACK,change_workspace,NULL);

	/*
	 *  Create the accelerated toolbox list
	 */
	parent = gui_info->find->routines->rlists;
	xvw_get_attributes(parent, XVW_WIDTH, &width, XVW_HEIGHT, &height,NULL);
	routines = xvw_create_toolboxlist(parent, "ToolboxList");
        xvw_set_attributes(routines,
		XVW_TACK_EDGE, KMANAGER_TACK_ALL,
		XVW_WIDTH,  width,
		XVW_HEIGHT, height,
		NULL);
        xvw_set_attribute(parent, XVW_BORDER_WIDTH, 0);
	xvw_set_attribute(parent, XVW_TACK_EDGE,
		KMANAGER_TACK_RIGHT | KMANAGER_TACK_BOTTOM);

	/*
	 *  Create the accelerated finder list
	 */
	parent = gui_info->find->finder->flist;
	finder = xvw_create_finderlist(parent, "FinderList");
        xvw_set_attribute(finder, XVW_TACK_EDGE, KMANAGER_TACK_ALL);

	/*
	 *  Add associated callbacks to our user interface to either create
	 *  glyphs or update the announce status
	 */
	if (tbmenu != NULL)
	   xvw_add_callback(tbmenu, XVW_TOOLBOXMENU_CREATE, create_glyph, NULL);

	xvw_add_callback(finder, XVW_FINDERLIST_CREATE,  create_glyph, NULL);
	xvw_add_callback(routines, XVW_TOOLBOXLIST_CREATE, create_glyph, NULL);
	xvw_add_callback(finder, XVW_FINDERLIST_SELECT,  status_callback, NULL);
	xvw_add_callback(routines,XVW_TOOLBOXLIST_SELECT, status_callback,NULL);
        
	/*
	 *  Create the initial workspace.
	 */
	create_workspace();
	default_workspace = main_workspace;

	init_pref_values();

	/*
	 *  add callback for updates of variables subform for expression
	 *  parser.
	 */
	xvl_expr_add_callback(update_variables_subform_cb, NULL);

	/*
	 *  Restore file if one is supplied on the command line
	 */
	if (clui_info->wksp_flag == -1)
	    kerror(NULL, "initialize_cantata",
		   "Invalid workspace file specified\n");
	if (clui_info->wksp_file)
	   filename = clui_info->wksp_file;
	else if (clui_info->tb_string && clui_info->oname_string)
	{
	   tbname = clui_info->tb_string;
	   oname  = clui_info->oname_string;
	   if ((toolbox = kcms_open_toolbox(tbname)) == NULL ||
	       (program = kcms_open_cmobj(toolbox, oname)) == NULL)
	   {
	      (void) kerror(NULL, "main()", "Cannot open %s '%s'.",
			(!toolbox) ? "toolbox" : "program",
			(!toolbox) ? clui_info->tb_string :
			clui_info->oname_string);
	      kexit(KEXIT_FAILURE);
	   }

	   if (kcms_get_attribute(program, KCMS_CMOBJ_WORKSPACE, &obj) && obj)
	      kcms_get_attribute(obj, KCMS_PATH, &filename);

	   kcms_close(program); kcms_close(toolbox);
	}
	tooltips = xvw_create_tooltips(NULL, "ToolTips");
	xvw_unmanage(tooltips);

        /*
         *  Add GUI extra call handler so that when the Configure Remote Hosts
         *  subform is opened, the routine to initialize the remote machines
         *  list is initialized .
         */
	xvf_add_extra_call(gui_info->distcomp_struct,
			   update_distcomp_info, NULL, XVF_CALL_FIRST); 

        /*
         *  Add GUI extra call handler so that when the Encapsulate Workspace
         *  subform is opened, the routine to initialize the list of toolboxes
         *  and software objects is initialized.
         */
        xvf_add_extra_call(gui_info->create_struct,
                init_encap_wksp, (kaddr) gui_info->create->program,
                XVF_CALL_FIRST);

	/*
	 * Initialize the menu item icons.
	 */
	init_menu_icons();
	if (filename != NULL)
	   restore_workspace(filename);

	/*
	 *  Add GUI extra call handler so that when the Preferences
	 *  subform is opened, the routine to initialize the icons
	 *  that appear selected on it are up-to-date.
	 */
	xvf_add_extra_call(gui_info->pref_struct,
			   init_pref_subform, NULL, XVF_CALL_FIRST); 

        /*
         * Post an environment variable which is used to detect registration
         * of xvroutines for cantata only and not xvroutines executed
         * by cantata.
         */
        if (kputenv("khoros_registration=displayed") != 0)
	{
	   kwarn("cantata", "initialize_cantata", 
                "Unable to set KHOROS registration environment variable.  "
                "You may be prompted multiple times to register.");
	}
	kset_announcehandler(update_status);
	kannounce(NULL, "main", "Ready... ");
}
