 /*
  * Khoros: $Id: preview.h,v 1.11 1996/07/05 01:55:56 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for preview
   >>>> 
   >>>>    Written By: John Rasure, Mark Young
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _preview_h_
#define _preview_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <design.h>
#include <xvinclude.h>
#include "form_info.h"

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
#define  PREVIEW_DELAY   2.0
#define  EDITOR  "vi"
/* -include_defines_end */

#define PANEPATH "$DESIGN/objects/xvroutine/preview/uis/preview.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Alternate UIS file (optional infile)
 */
char	*form_file;	/* Alternate UIS file FILENAME */
int	 form_flag;	/* Alternate UIS file FLAG */

/*
 *  (x,y) position for automatic GUI placement */

int	 x_int;		/* x position INT */
int	 x_flag;	/* x position FLAG */

int	 y_int;		/* y position INT */
int	 y_flag;	/* y position FLAG */

/*
 *  input UIS file (optional infile)
 */
char	*i_file;	/* input UIS file FILENAME */
int	 i_flag;	/* input UIS file FLAG */

/*
 *  display GUI of specified UIS file only, not preview's GUI (optional flag)
 */
int	 noform_flag;  	/* display GUI of specified UIS file only, not preview's GUI FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern gui_info_struct *gui_info;

/* -include_variables */
extern kform *display_form;
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void preview_get_args PROTO((kform *));
void preview_usage_additions PROTO((void));
void preview_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void run_display              PROTO((kform *, ksubform *, kaddr));
int  update_displayed_uisfile PROTO((xvobject, char *, char *));
/* -include_routines_end */

#endif
