#include <xvinclude.h>

/*
 * This example creates a window with a single line annotation in it.
 *
 * After the manager object parent is put into edit mode (hold down
 * shift key and click the left mouse button), the line can be 
 * interactively moved by "grabbing" it in the middle with the left mouse 
 * button; grabbing it near an end will cause the line to resize.
 *
 * The internal menuform for the line may be displayed by clicking
 * the middle mouse button on the line; the menuform may then be
 * used to set attributes of the line.
 */

void main(
   int  argc,
   char *argv[])
{
        xvobject line;
        xvobject image;

        /* initialize Khoros program */
        khoros_initialize(argc, argv, "ENVISION");

	/* initialize the xvwidgets lib */
        if (!xvw_initialize(XVW_MENUS_XVFORMS))
        {
           kerror(NULL, "main", "unable to open display");
           kexit(KEXIT_FAILURE);
        }

	/* 
	 * create image object to serve as backplane for line annotation
	 */
	image = xvw_create_image(NULL, "image");
	xvw_set_attribute(image, XVW_IMAGE_IMAGEFILE, "image:kitten");

	/*
	 *  create red line object; specify endpoints in world coordinates. 
	 */
        line = xvw_create_line(image, "line");
        xvw_set_attributes(line,
                           XVW_LINE_XBEGIN, 45.0,
                           XVW_LINE_YBEGIN, 145.0,
                           XVW_LINE_XEND,   100.0,
                           XVW_LINE_YEND,   155.0,
			   XVW_FOREGROUND_COLOR, "red",
                           NULL);
	/* display & run the program */
        xvf_run_form();
}
