#include <xvinclude.h>

/*
 * This example creates a window with a single circle annotation in it.
 *
 * After the manager object parent is put into edit mode (hold down
 * shift key and click the left mouse button), the circle can be
 * interactively moved by "grabbing" it in the middle with the left mouse
 * button; grabbing it near an end will cause the circle to resize.
 *
 * In this example, the internal menuform for the circle is displayed 
 * automatically.
 */

void main(
   int  argc,
   char *argv[])
{
        xvobject parent;
        xvobject circle;

        /* initialize Khoros program */
        khoros_initialize(argc, argv, "ENVISION");

        /* initialize the xvwidgets lib */
        if (!xvw_initialize(XVW_MENUS_XVFORMS))
        {
           kerror(NULL, "main", "unable to open display");
           kexit(KEXIT_FAILURE);
        }

        /*
         *  create black manager backplane, width & height of 300.
         */
        parent = xvw_create_manager(NULL, "parent");
        xvw_set_attributes(parent,
                           XVW_WIDTH,            300,
                           XVW_HEIGHT,           300,
                           XVW_BACKGROUND_COLOR, "black",
                           NULL);

	/*
	 *  create the circle object.  specify dimensions in world coordinates,
	 */
        circle = xvw_create_circle(parent, "circle");
        xvw_set_attributes(circle,
                           XVW_CIRCLE_XCENTER, 0.5,
                           XVW_CIRCLE_YCENTER, 0.5,
                           XVW_CIRCLE_RADIUS,  0.1,
                           NULL);
	/*
	 *  activate menuform so user doesn't have to bring it up.
	 */
	xvw_activate_menu(circle);

	/* display & run the program */
        xvf_run_form();
}
