#include <xvinclude.h>

/*
 * This example creates a window with a timer object.  A timer object
 * uses the system clock to emulate a stop-watch type capability.
 */

void main(int  argc,
   char *argv[])
{
        xvobject parent;
        xvobject timer;

        /* initialize Khoros program */
        khoros_initialize(argc, argv, "ENVISION");

        /* initialize the xvwidgets lib */
        if (!xvw_initialize(XVW_MENUS_XVFORMS))
        {
           kerror(NULL, "main", "unable to open display");
           kexit(KEXIT_FAILURE);
        }

        /*
         *  create a manager backplane, width & height of 100.
         */
        parent = xvw_create_manager(NULL, "parent");
        xvw_set_attributes(parent,
                           XVW_WIDTH,  100,
                           XVW_HEIGHT, 100,
			   NULL);

        /*
         *  create timer object, specifying placement in world coordinates, 
	 *  string formatting specifications, 
         */
        timer = xvw_create_timer(parent, "timer");
        xvw_set_attributes(timer,
                           XVW_STRING_XPLACEMENT,  0.5,
                           XVW_STRING_YPLACEMENT,  0.5,
	                   NULL);

	/*
         *  activate the menuform so user doesn't have to bring it up
         */
        xvw_activate_menu(timer);

	/* display & run the program */
        xvf_run_form();
}
