#include <xvinclude.h>

/* 
 *  This simple introductory program creates a window with an image object; the
 *  image displayed is the mandril image, which is specified using the keyword
 *  syntax rather than the absolute path to the image.  
 */
void main(
   int  argc,
   char *argv[])
{
	xvobject parent, image, position;
	char *filename = "image:mandril-rgb";

        /* initialize Khoros program */
        khoros_initialize(argc, argv, "ENVISION");

	/* Initialize the xvwidgets library */
	if (!xvw_initialize(XVW_MENUS_XVFORMS)) 
	{
	   kerror("test", "main", "unable to open display");
	   kexit(KEXIT_FAILURE);
	}

	/*
	 *  Create the image display.  Since the parent is NULL, a toplevel 
	 *  window will be created automatically, and the image object placed 
         *  inside.  The xvw_set_attribute() call is used to specify the image 
         *  file to be displayed.
	 */
	parent = xvw_create_manager(NULL, "parent");
	image = xvw_create_image(parent, "image");
	xvw_set_attribute(image, XVW_IMAGE_IMAGEFILE, filename); 
	position = xvw_create_position(parent, "position");
	xvw_set_attributes(position, 
			   XVW_POSITION_FILENAME, filename,
			   XVW_BELOW, image,
			   XVW_LEFT_OF, NULL,
			   XVW_RIGHT_OF, NULL,
			  NULL);

	/* display & run; there is no way to exit the program but ^C */
	xvf_run_form();
}
