 /*
  * Khoros: $Id: usage.c,v 1.12 1996/07/05 02:49:34 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.12 1996/07/05 02:49:34 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcolorspace.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcolorspace_get_args
| 
|       Purpose: Gets command line args for kcolorspace
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcolorspace
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void kcolorspace_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for kcolorspace is out of sync with arguments specified in kcolorspace's *.pane file; please rerun ghostwriter on kcolorspace.";

	char  *value_string;


	/*
	 * allocate the kcolorspace structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kcolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kcolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->type_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kcolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



