 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 02:51:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 02:51:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "editcmap.h"
/*-----------------------------------------------------------
| 
|  Routine Name: editcmap_get_args
| 
|       Purpose: Gets command line args for editcmap
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname editcmap
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void editcmap_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for editcmap is out of sync with arguments specified in editcmap's *.pane file; please rerun ghostwriter on editcmap.";


	/*
	 * allocate the editcmap structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pseudo",
			  &(clui_info->pseudo_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "thresh",
			  &(clui_info->thresh_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cmap_only",
			  &(clui_info->cmap_only_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x",
			  &(clui_info->x_int),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y",
			  &(clui_info->y_int),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "width",
			  &(clui_info->width_int),
			  &(clui_info->width_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "height",
			  &(clui_info->height_int),
			  &(clui_info->height_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



