 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 02:53:53 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 02:53:53 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "spectrum.h"
/*-----------------------------------------------------------
| 
|  Routine Name: spectrum_get_args
| 
|       Purpose: Gets command line args for spectrum
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname spectrum
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void spectrum_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for spectrum is out of sync with arguments specified in spectrum's *.pane file; please rerun ghostwriter on spectrum.";


	/*
	 * allocate the spectrum structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "l",
			  &(clui_info->l_file),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "t",
			  &(clui_info->t_file),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "p",
			  &(clui_info->p_file),
			  &(clui_info->p_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "method", KVF_LIST_LABEL,
			  &(clui_info->method_label),
			  &(clui_info->method_flag)) &&
	      kclui_get_value(pane, "method", KVF_LIST_VAL,
			  &(clui_info->method_cycle),
			  &(clui_info->method_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



