 /*
  * Khoros: $Id: usage.c,v 1.4 1996/07/05 02:41:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.4 1996/07/05 02:41:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "g3daxis.h"
/*-----------------------------------------------------------
| 
|  Routine Name: g3daxis_get_args
| 
|       Purpose: Gets command line args for g3daxis
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname g3daxis
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void g3daxis_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for g3daxis is out of sync with arguments specified in g3daxis's *.pane file; please rerun ghostwriter on g3daxis.";


	/*
	 * allocate the g3daxis structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_auto_extents",
			  &(clui_info->do_auto_extents_logic),
			  &(clui_info->do_auto_extents_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xmin",
			  &(clui_info->xmin_float),
			  &(clui_info->xmin_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xmax",
			  &(clui_info->xmax_float),
			  &(clui_info->xmax_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ymin",
			  &(clui_info->ymin_float),
			  &(clui_info->ymin_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ymax",
			  &(clui_info->ymax_float),
			  &(clui_info->ymax_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zmin",
			  &(clui_info->zmin_float),
			  &(clui_info->zmin_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zmax",
			  &(clui_info->zmax_float),
			  &(clui_info->zmax_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_ticks",
			  &(clui_info->do_ticks_logic),
			  &(clui_info->do_ticks_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tdensity",
			  &(clui_info->tdensity_int),
			  &(clui_info->tdensity_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_labels",
			  &(clui_info->do_labels_logic),
			  &(clui_info->do_labels_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "sprintf_format",
			  &(clui_info->sprintf_format_string),
			  &(clui_info->sprintf_format_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



