 /*
  * Khoros: $Id: gbindtexture.c,v 1.4 1996/07/05 02:42:07 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: gbindtexture.c,v 1.4 1996/07/05 02:42:07 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for gbindtexture
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "gbindtexture.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Assign a Texture to a Geometry Object
|
|       Purpose: main program for gbindtexture
|
|         Input:
|		char *clui_info->i_file; {input geometry object}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->i2_file; {texture object to be bound}
|		int   clui_info->i2_flag; {TRUE if -i2 specified}
|
|		char *clui_info->o_file; {output geometry object with bound texture}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: wes
|          Date: Jul 04, 1996
| Modifications:
|
------------------------------------------------------------*/

void main(
   int  argc,
   char **argv)
{

	kform  *pane;         /* form tree representing *.pane file */
/* -main_variable_list */
	kobject in_geom,in_texture,out_geom;
	char *in_texture_tname;
/* -main_variable_list_end */

	khoros_initialize(argc, argv, "GEOMETRY");
	kexit_handler(gbindtexture_free_args, NULL);

/* -main_get_args_call */
	kclui_initialize(PANEPATH, KGEN_KROUTINE, "GEOMETRY", "gbindtexture",
		gbindtexture_usage_additions, gbindtexture_get_args,
		gbindtexture_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
/*	in_geom = kpds_open_object(clui_info->i_file,KOBJ_READ); */
	in_geom = kgeom_open_input_object(clui_info->i_file);
	in_texture_tname = clui_info->i2_file;
	
	in_texture = kgeom_open_input_object(in_texture_tname);
	out_geom = kgeom_open_output_object(clui_info->o_file);
/*	
	in_texture = kpds_open_object(in_texture_tname,KOBJ_READ);
	out_geom = kpds_open_object(clui_info->o_file,KOBJ_WRITE);
	*/
/* -main_before_lib_call_end */

/* -main_library_call */
	lgbindtexture(in_geom,out_geom,in_texture,in_texture_tname);
/* -main_library_call_end */

/* -main_after_lib_call */
#if 0
	kpds_close_object(in_geom);
	kpds_close_object(out_geom);
	kpds_close_object(in_texture);
#endif
	kgeom_close_object(in_geom);
	kgeom_close_object(out_geom);
	kgeom_close_object(in_texture);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: gbindtexture_usage_additions
| 
|       Purpose: Prints usage additions in gbindtexture_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gbindtexture
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void gbindtexture_usage_additions(void)
{
	kfprintf(kstderr, "\tAssign a Texture to a Geometry Object\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: gbindtexture_free_args
| 
|       Purpose: Frees CLUI struct allocated in gbindtexture_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gbindtexture
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
gbindtexture_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->i2_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
