 /*
  * Khoros: $Id: gcmaplegend.h,v 1.7 1996/07/05 02:42:28 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gcmaplegend
   >>>> 
   >>>>    Written By: Wes Bethel
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gcmaplegend_h_
#define _gcmaplegend_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
#include "geometry/geometry.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$GEOMETRY/objects/kroutine/gcmaplegend/uis/gcmaplegend.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input vis colormap (required infile)
 */
char	*i_file;	/* input vis colormap FILENAME */
int	 i_flag;	/* input vis colormap FLAG */

/*
 *  output geometry object (required outfile)
 */
char	*o_file;	/* output geometry object FILENAME */
int	 o_flag;	/* output geometry object FLAG */

/*
 *  color legend (optional string)
 */
char	*name_string;	/* color legend STRING */
int	 name_flag;   	/* color legend FLAG */

/*
 * legend orientation (Optional boolean toggle)
 *	1 (Horizontal)
 *	2 (Vertical),
 */
int	 orient_toggle;		/* legend orientation LOGICAL TOGGLE */
int	 orient_flag;		/* legend orientation FLAG */

/*
 *  reverse colors? (optional logical)
 */
int	 reverse_logic;	/* reverse colors? LOGIC */
int	 reverse_flag;  	/* reverse colors? FLAG */

/*
 *  make outline? (optional logical)
 */
int	 outline_logic;	/* make outline? LOGIC */
int	 outline_flag;  	/* make outline? FLAG */

/*
 *  length of legend (optional float)
 */
float	 length_float;	/* length of legend FLOAT */
int	 length_flag;   	/* length of legend FLAG */

/*
 *  thickness of legend (optional float)
 */
float	 thickness_float;	/* thickness of legend FLOAT */
int	 thickness_flag;   	/* thickness of legend FLAG */

/*
 *  x position (optional float)
 */
float	 xpos_float;	/* x position FLOAT */
int	 xpos_flag;   	/* x position FLAG */

/*
 *  y position (optional float)
 */
float	 ypos_float;	/* y position FLOAT */
int	 ypos_flag;   	/* y position FLAG */

/*
 *  Boolean value indicating whether or not text labels will be drawn. (optional logical)
 */
int	 do_text_labels_logic;	/* Boolean value indicating whether or not text labels will be drawn. LOGIC */
int	 do_text_labels_flag;  	/* Boolean value indicating whether or not text labels will be drawn. FLAG */

/*
 *  Number of subdivisions along color legend for text labels. (optional integer)
 */
int	 num_labels_int; 	/* Number of subdivisions along color legend for text labels. INT */
int	 num_labels_flag;	/* Number of subdivisions along color legend for text labels. FLAG */

/*
 *  C-style formatting string.  No error checking is perfomed.  Use %g for most stuff. (optional string)
 */
char	*sprintf_format_string;	/* C-style formatting string.  No error checking is perfomed.  Use %g for most stuff. STRING */
int	 sprintf_format_flag;   	/* C-style formatting string.  No error checking is perfomed.  Use %g for most stuff. FLAG */

/*
 *  Offset of text in either the horizontal or vertical dimension, depending upon the orientation of the legend. (optional float)
 */
float	 text_offset_float;	/* Offset of text in either the horizontal or vertical dimension, depending upon the orientation of the legend. FLOAT */
int	 text_offset_flag;   	/* Offset of text in either the horizontal or vertical dimension, depending upon the orientation of the legend. FLAG */

/*
 *  Boolean indicating whether or not to generate a title to go along with the legend. (optional logical)
 */
int	 do_title_logic;	/* Boolean indicating whether or not to generate a title to go along with the legend. LOGIC */
int	 do_title_flag;  	/* Boolean indicating whether or not to generate a title to go along with the legend. FLAG */

/*
 *  The text for the title. (optional string)
 */
char	*title_string_string;	/* The text for the title. STRING */
int	 title_string_flag;   	/* The text for the title. FLAG */

/*
 *  X-Offset of title relative to the origin of the legend. (optional float)
 */
float	 title_x_offset_float;	/* X-Offset of title relative to the origin of the legend. FLOAT */
int	 title_x_offset_flag;   	/* X-Offset of title relative to the origin of the legend. FLAG */

/*
 *  Y-offset of title relative to legend origin. (optional float)
 */
float	 title_y_offset_float;	/* Y-offset of title relative to legend origin. FLOAT */
int	 title_y_offset_flag;   	/* Y-offset of title relative to legend origin. FLAG */

/*
 *  Choices for point size for the title. (Optional list)
 */
int	 title_font_size_list;	/* Choices for point size for the title. LIST INDEX */
char	 *title_font_size_label;	/* Choices for point size for the title. LIST LABEL */
int	 title_font_size_flag;	/* Choices for point size for the title. FLAG */

/*
 *  List of available font families.  Based upon those commonly available on X servers.  This works reliably only in the software renderer. (Optional list)
 */
int	 title_font_family_list;	/* List of available font families.  Based upon those commonly available on X servers.  This works reliably only in the software renderer. LIST INDEX */
char	 *title_font_family_label;	/* List of available font families.  Based upon those commonly available on X servers.  This works reliably only in the software renderer. LIST LABEL */
int	 title_font_family_flag;	/* List of available font families.  Based upon those commonly available on X servers.  This works reliably only in the software renderer. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void gcmaplegend_get_args PROTO((kform *));
void gcmaplegend_usage_additions PROTO((void));
void gcmaplegend_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
