 /*
  * Khoros: $Id: usage.c,v 1.7 1996/07/05 02:42:30 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.7 1996/07/05 02:42:30 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "gcmaplegend.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gcmaplegend_get_args
| 
|       Purpose: Gets command line args for gcmaplegend
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gcmaplegend
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void gcmaplegend_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for gcmaplegend is out of sync with arguments specified in gcmaplegend's *.pane file; please rerun ghostwriter on gcmaplegend.";

	char  *value_string;


	/*
	 * allocate the gcmaplegend structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "orient", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->orient_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->orient_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_logical(pane, "reverse",
			  &(clui_info->reverse_logic),
			  &(clui_info->reverse_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "outline",
			  &(clui_info->outline_logic),
			  &(clui_info->outline_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "length",
			  &(clui_info->length_float),
			  &(clui_info->length_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "thickness",
			  &(clui_info->thickness_float),
			  &(clui_info->thickness_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xpos",
			  &(clui_info->xpos_float),
			  &(clui_info->xpos_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ypos",
			  &(clui_info->ypos_float),
			  &(clui_info->ypos_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_text_labels",
			  &(clui_info->do_text_labels_logic),
			  &(clui_info->do_text_labels_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "num_labels",
			  &(clui_info->num_labels_int),
			  &(clui_info->num_labels_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "sprintf_format",
			  &(clui_info->sprintf_format_string),
			  &(clui_info->sprintf_format_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "text_offset",
			  &(clui_info->text_offset_float),
			  &(clui_info->text_offset_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_title",
			  &(clui_info->do_title_logic),
			  &(clui_info->do_title_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "title_string",
			  &(clui_info->title_string_string),
			  &(clui_info->title_string_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "title_x_offset",
			  &(clui_info->title_x_offset_float),
			  &(clui_info->title_x_offset_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "title_y_offset",
			  &(clui_info->title_y_offset_float),
			  &(clui_info->title_y_offset_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "title_font_size", KVF_LIST_LABEL,
			  &(clui_info->title_font_size_label),
			  &(clui_info->title_font_size_flag)) &&
	      kclui_get_value(pane, "title_font_size", KVF_LIST_VAL,
			  &(clui_info->title_font_size_list),
			  &(clui_info->title_font_size_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "title_font_family", KVF_LIST_LABEL,
			  &(clui_info->title_font_family_label),
			  &(clui_info->title_font_family_flag)) &&
	      kclui_get_value(pane, "title_font_family", KVF_LIST_VAL,
			  &(clui_info->title_font_family_list),
			  &(clui_info->title_font_family_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



