 /*
  * Khoros: $Id: gcreate2dtex.h,v 1.4 1996/07/05 02:43:12 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gcreate2dtex
   >>>> 
   >>>>    Written By: wes
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gcreate2dtex_h_
#define _gcreate2dtex_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
#include <geometry/geometry.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$GEOMETRY/objects/kroutine/gcreate2dtex/uis/gcreate2dtex.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  First Input data object (required infile)
 */
char	*i_file;	/* First Input data object FILENAME */
int	 i_flag;	/* First Input data object FLAG */

/*
 *  Resulting output data object (required outfile)
 */
char	*o_file;	/* Resulting output data object FILENAME */
int	 o_flag;	/* Resulting output data object FLAG */

/*
 *  Control over the method used in filtering the input image when making a texture. (Required list)
 */
int	 tex_filter_list;	/* Control over the method used in filtering the input image when making a texture. LIST INDEX */
char	 *tex_filter_label;	/* Control over the method used in filtering the input image when making a texture. LIST LABEL */
int	 tex_filter_flag;	/* Control over the method used in filtering the input image when making a texture. FLAG */

/*
 *  Minimum u-coordinate value associated with origin of image data. (optional float)
 */
float	 umin_float;	/* Minimum u-coordinate value associated with origin of image data. FLOAT */
int	 umin_flag;   	/* Minimum u-coordinate value associated with origin of image data. FLAG */

/*
 *  Mininum v-coordinate assigned to the origin of the texture. (optional float)
 */
float	 vmin_float;	/* Mininum v-coordinate assigned to the origin of the texture. FLOAT */
int	 vmin_flag;   	/* Mininum v-coordinate assigned to the origin of the texture. FLAG */

/*
 *  Maximum u-coordinate to use for the non-origin corner of the texture image. (optional float)
 */
float	 umax_float;	/* Maximum u-coordinate to use for the non-origin corner of the texture image. FLOAT */
int	 umax_flag;   	/* Maximum u-coordinate to use for the non-origin corner of the texture image. FLAG */

/*
 *  Maximum v-coordinate to use for the non-origin corner of the texture image. (optional float)
 */
float	 vmax_float;	/* Maximum v-coordinate to use for the non-origin corner of the texture image. FLOAT */
int	 vmax_flag;   	/* Maximum v-coordinate to use for the non-origin corner of the texture image. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void gcreate2dtex_get_args PROTO((kform *));
void gcreate2dtex_usage_additions PROTO((void));
void gcreate2dtex_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
