 /*
  * Khoros: $Id: usage.c,v 1.4 1996/07/05 02:43:14 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.4 1996/07/05 02:43:14 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "gcreate2dtex.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gcreate2dtex_get_args
| 
|       Purpose: Gets command line args for gcreate2dtex
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gcreate2dtex
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void gcreate2dtex_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for gcreate2dtex is out of sync with arguments specified in gcreate2dtex's *.pane file; please rerun ghostwriter on gcreate2dtex.";


	/*
	 * allocate the gcreate2dtex structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "umin",
			  &(clui_info->umin_float),
			  &(clui_info->umin_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "vmin",
			  &(clui_info->vmin_float),
			  &(clui_info->vmin_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "umax",
			  &(clui_info->umax_float),
			  &(clui_info->umax_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "vmax",
			  &(clui_info->vmax_float),
			  &(clui_info->vmax_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "tex_filter", KVF_LIST_LABEL,
			  &(clui_info->tex_filter_label),
			  &(clui_info->tex_filter_flag)) &&
	      kclui_get_value(pane, "tex_filter", KVF_LIST_VAL,
			  &(clui_info->tex_filter_list),
			  &(clui_info->tex_filter_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



