 /*
  * Khoros: $Id: usage.c,v 1.5 1996/07/05 02:47:35 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.5 1996/07/05 02:47:35 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "gstreamlines.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gstreamlines_get_args
| 
|       Purpose: Gets command line args for gstreamlines
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gstreamlines
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void gstreamlines_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for gstreamlines is out of sync with arguments specified in gstreamlines's *.pane file; please rerun ghostwriter on gstreamlines.";


	/*
	 * allocate the gstreamlines structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "rake",
			  &(clui_info->rake_file),
			  &(clui_info->rake_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "step",
			  &(clui_info->step_float),
			  &(clui_info->step_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "nsteps",
			  &(clui_info->nsteps_int),
			  &(clui_info->nsteps_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



