 /*
  * Khoros: $Id: gtransform.h,v 1.4 1996/07/05 02:47:50 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gtransform
   >>>> 
   >>>>    Written By: wes
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gtransform_h_
#define _gtransform_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
#include <geometry/geometry.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$GEOMETRY/objects/kroutine/gtransform/uis/gtransform.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input Geometry Object  (required infile)
 */
char	*i_file;	/* Input Geometry Object  FILENAME */
int	 i_flag;	/* Input Geometry Object  FLAG */

/*
 *  Output Geometry Object  (required outfile)
 */
char	*o_file;	/* Output Geometry Object  FILENAME */
int	 o_flag;	/* Output Geometry Object  FLAG */

/*
 *  Scale to be applied to X coordinates of vertices (and normals, if present). (optional float)
 */
float	 xscale_float;	/* Scale to be applied to X coordinates of vertices (and normals, if present). FLOAT */
int	 xscale_flag;   	/* Scale to be applied to X coordinates of vertices (and normals, if present). FLAG */

/*
 *  Scale to be applied to Y coordinates of vertices (and normals, if present). (optional float)
 */
float	 yscale_float;	/* Scale to be applied to Y coordinates of vertices (and normals, if present). FLOAT */
int	 yscale_flag;   	/* Scale to be applied to Y coordinates of vertices (and normals, if present). FLAG */

/*
 *  Scale to be applied to Z coordinates of vertices (and normals, if present). (optional float)
 */
float	 zscale_float;	/* Scale to be applied to Z coordinates of vertices (and normals, if present). FLOAT */
int	 zscale_flag;   	/* Scale to be applied to Z coordinates of vertices (and normals, if present). FLAG */

/*
 *  Toggle to enable or prohibit transformation of the normals, if present. (optional logical)
 */
int	 do_normals_logic;	/* Toggle to enable or prohibit transformation of the normals, if present. LOGIC */
int	 do_normals_flag;  	/* Toggle to enable or prohibit transformation of the normals, if present. FLAG */

/*
 *  indicates how many nodes will be used in a threaded operation. (optional integer)
 */
int	 parallel_int; 	/* indicates how many nodes will be used in a threaded operation. INT */
int	 parallel_flag;	/* indicates how many nodes will be used in a threaded operation. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void gtransform_get_args PROTO((kform *));
void gtransform_usage_additions PROTO((void));
void gtransform_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
