 /*
  * Khoros: $Id: usage.c,v 1.4 1996/07/05 02:47:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.4 1996/07/05 02:47:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "gtransform.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gtransform_get_args
| 
|       Purpose: Gets command line args for gtransform
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gtransform
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void gtransform_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for gtransform is out of sync with arguments specified in gtransform's *.pane file; please rerun ghostwriter on gtransform.";


	/*
	 * allocate the gtransform structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xscale",
			  &(clui_info->xscale_float),
			  &(clui_info->xscale_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yscale",
			  &(clui_info->yscale_float),
			  &(clui_info->yscale_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zscale",
			  &(clui_info->zscale_float),
			  &(clui_info->zscale_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_normals",
			  &(clui_info->do_normals_logic),
			  &(clui_info->do_normals_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "parallel",
			  &(clui_info->parallel_int),
			  &(clui_info->parallel_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



