
/*
 * Copyright (c) 1996,  The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Visualization
 *      Group at Lawrence Berkeley National Laboratory.
 * 4. Neither the name of the University of California, Berkeley nor of the 
 *    Lawrence Berkeley National Laboratory may be used to endorse or 
 *    promote products derived from this software without specific prior 
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 * This work is supported by the U. S. Department of Energy under contract 
 * number DE-AC03-76SF00098 between the U. S. Department of Energy and the 
 * University of California.
 *
 *	Author: Wes Bethel
 *		Lawrence Berkeley National Laboratory
 *              Berkeley, California 
 *
 *  "this software is 100% hand-crafted by a human being in the USA"
 */
 
 /*
  * Khoros: $Id: do_Output.c,v 1.5 1996/06/24 22:15:33 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_Output.c,v 1.5 1996/06/24 22:15:33 mirage Exp $";
#endif

 /*
  * $Log: do_Output.c,v $
  * Revision 1.5  1996/06/24 22:15:33  mirage
  * mark is on a plane and wes is in Norway... committing to get the latest version
  *
  * Revision 1.4  1996/05/30 15:48:01  mirage
  * wes visit to kri may 96
  *
  */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Functionality routines for pane Output
   >>>> 
   >>>>  Private: 
   >>>> 	Output_output_image_fname
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "rmonster.h"
#include "vrxfrm.h"

/*-----------------------------------------------------------
| 
|  Routine Name: Output_output_image_fname
| 
|       Purpose: Do routine which is called when
|                  output selection output_image_fname is used
| 
|         Input: Output_info - ptr to PaneInfo struct for Output pane
| 
|        Output: None
|    Written By: 
|          Date: Apr 11, 1995
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void Output_output_image_fname(
     RenderMonster_Output *Output_info)
{
    /* PUT YOUR CODE HERE ! */
    char *fname;

    fname = Output_info->output_image_fname;
    
    if ((fname == NULL) || (fname[0] == '\0'))
	set_do_named_output(FALSE);
    else
	set_do_named_output(TRUE);
	
    set_output_transport_name(Output_info->output_image_fname);
}


void
init_output_pane_GUI(clui_info_struct *cli,
                     RenderMonster_Output *ri)
{
    if (cli->o_flag)
    {
        xvf_set_attribute(ri->output_image_fname_struct,
                          XVF_FILE_NAME,
                          cli->o_file);
        xvf_set_attribute(ri->output_image_fname_struct,
                          XVF_ACTIVATE,
                          TRUE);
        xvf_set_attribute(ri->output_image_fname_struct,
                          XVF_OPTSEL,
                          TRUE);
    }
    if (cli->oxfrm_flag)
    {
        xvf_set_attribute(ri->oxfrm_struct,
			  XVF_FILE_NAME,
			  cli->oxfrm_file);
        xvf_set_attribute(ri->oxfrm_struct,
                          XVF_ACTIVATE,
                          TRUE);
        xvf_set_attribute(ri->oxfrm_struct,
                          XVF_OPTSEL,
                          TRUE);
    }
}


/*-----------------------------------------------------------
| 
|  Routine Name: Output_oxfrm
| 
|       Purpose: Do routine which is called when
|                  output selection oxfrm is used
| 
|         Input: Output_info - ptr to PaneInfo struct for Output pane
| 
|        Output: None
|    Written By: 
|          Date: May 22, 1996
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void Output_oxfrm(
     RenderMonster_Output *Output_info)
{
  /* PUT YOUR CODE HERE ! */
  init_xform_output(Output_info->oxfrm);
}


