 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:06:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:06:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "minvert.h"
/*-----------------------------------------------------------
| 
|  Routine Name: minvert_get_args
| 
|       Purpose: Gets command line args for minvert
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname minvert
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void minvert_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for minvert is out of sync with arguments specified in minvert's *.pane file; please rerun ghostwriter on minvert.";


	/*
	 * allocate the minvert structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "minvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "diag",
			  &(clui_info->diag_flag))))
	{
	    kerror(NULL, "minvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "minvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



