 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:07:31 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:07:31 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mpow.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mpow_get_args
| 
|       Purpose: Gets command line args for mpow
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mpow
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void mpow_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for mpow is out of sync with arguments specified in mpow's *.pane file; please rerun ghostwriter on mpow.";


	/*
	 * allocate the mpow structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "mpow_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "pow",
			  &(clui_info->pow_int),
			  &(clui_info->pow_flag))))
	{
	    kerror(NULL, "mpow_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "mpow_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



