 /*
  * Khoros: $Id: mkproto.c,v 1.12 1996/07/05 03:13:32 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: mkproto.c,v 1.12 1996/07/05 03:13:32 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for mkproto
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "mkproto.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Make prototypes for functions
|
|       Purpose: main program for mkproto
|
|         Input:
|		int clui_info->n_logic; {put line numbers of declarations as comments}
|		int clui_info->n_flag; {TRUE if -n specified}
|
|		int clui_info->s_logic; {include declarations for static functions}
|		int clui_info->s_flag; {TRUE if -s specified}
|
|		int clui_info->v_logic; {include variable name in declaration}
|		int clui_info->v_flag; {TRUE if -v specified}
|
|		int clui_info->d_logic; {include declaration for the PROTO() definition}
|		int clui_info->d_flag; {TRUE if -d specified}
|
|		int clui_info->p_logic; {do not make header files readable by non-ANSI compiler}
|		int clui_info->p_flag; {TRUE if -p specified}
|
|		int clui_info->h_logic; {do file headers}
|		int clui_info->h_flag; {TRUE if -h specified}
|
|		char *clui_info->i_file; {input file}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: Jul 04, 1996
| Modifications:
|
------------------------------------------------------------*/

void main(
   int  argc,
   char **argv)
{

	kform  *pane;         /* form tree representing *.pane file */
/* -main_variable_list */
/*	argv++; argc--;*/
	kfile *infile = kstdin;
/* -main_variable_list_end */

	khoros_initialize(argc, argv, "MIGRATION");
	kexit_handler(mkproto_free_args, NULL);

/* -main_get_args_call */
	kclui_initialize(PANEPATH, KGEN_KROUTINE, "MIGRATION", "mkproto",
		mkproto_usage_additions, mkproto_get_args,
		mkproto_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
	if (clui_info->p_logic && clui_info->d_logic) {
		kprintf("#ifdef __STDC__\n");
		kprintf("# define\tPROTO(s) s\n");
		kprintf("#else\n");
		kprintf("# define PROTO(s) ()\n");
		kprintf("#endif\n\n");
	}

	if (clui_info->i_flag && ((infile=kfinput(clui_info->i_file)) == NULL))
	{
		kerror(NULL, NULL, "Cannot open input file '%s'",
			clui_info->i_file);
		kexit(KEXIT_FAILURE);
	}

	getdecl(infile);

	if (clui_info->p_logic && clui_info->d_logic) {
		kprintf("\n#undef PROTO\n");	/* clean up namespace */
	}
/* -main_before_lib_call_end */

/* -main_library_call */
/* -main_library_call_end */

/* -main_after_lib_call */
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: mkproto_usage_additions
| 
|       Purpose: Prints usage additions in mkproto_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mkproto
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void mkproto_usage_additions(void)
{
	kfprintf(kstderr, "\tMake prototypes for functions\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: mkproto_free_args
| 
|       Purpose: Frees CLUI struct allocated in mkproto_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mkproto
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
mkproto_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
