eval 'exec perl -S $0 $*'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kuptbdef2 - 
# Purposed:	long description goes here
#
# RCS ID:	Khoros: $Id: kuptbdef2.pl,v 1.3 1996/04/05 00:43:02 fas Exp $
#========================================================================

# Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.


if (! defined $ENV{'KHOROS_TOOLBOX'})
{
   die "The KHOROS_TOOLBOX environment variable must be set.\n";
}

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "KHOROS_TOOLBOX environment variable points to existing files.\n";
   };

   while (<TBS>)
   {
      chop($_);
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               $notfound = 0;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check your\n";
               warn "KHOROS_TOOLBOX environment variable and the file(s)\n";
               warn "pointed to by it and make sure that all toolboxes are\n";
               die  "only defined once.\n";
            }
         }
      }
   }
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment variable KHOROS_TOOLBOX.\n";
}


@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = '';
@clui_args  = (
        '[tb]',     'toolbox',      'name of toolbox',
        '[oname]',  'object-name',  'name of software object'
);

# initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

#-- End of Template Code

unless (defined $khoros'toolboxPath{'BOOTSTRAP'})
{
   die "Can't determine path to BOOTSTRAP toolbox\n"
}
$bootpath = $khoros'toolboxPath{'BOOTSTRAP'};

@toolboxes = &khoros'get_toolbox_list();
print "ALL TOOLBOXES: @toolboxes\n";

foreach $toolbox (@toolboxes)
{
   &UpdateImakeConfig($toolbox);
   print STDERR "\n";
}

#========================================================================
#
#========================================================================
sub UpdateImakeConfig
{
   local($toolbox) = @_;
   local($TOOLBOX);
   local($tbpath);
   local(*OLD, *NEW, *TEMPLATE);
   local($filename);
   local($line);
   local(@libs);
   local(@deptbs);

   print STDERR "Toolbox: $toolbox\n";
   $TOOLBOX = "\U$toolbox";
   $toolbox = "\L$toolbox";
   $tbpath = $khoros'toolboxPath{$TOOLBOX}; # '

   #------------------------------------------------------------------------
   # first we parse the information we want out of the existing imake config
   #------------------------------------------------------------------------
   $filename = "$tbpath/repos/config/imake_config/toolbox.def.bak";
   rename("$tbpath/repos/config/imake_config/toolbox.def", $filename) || do
   {
      warn "   Cannot rename current 'toolbox.def' file for $TOOLBOX\n";
      return;
   };
   open (OLD, "< $tbpath/repos/config/imake_config/toolbox.def.bak") || do
   {
      warn "   Could not read old imake config file:\n\t$filename\n";
      return;
   };
   undef $line;
   while (<OLD>)
   {
      $_ = $line.$_;
      # escaped newline, suck in next line.
      if (/\\$/)
      {
	($line = $_) =~ s/\\$//;
	next;
      }
      s/\n./ /g;

      push(@deptbs, $_) if /^\s*#\s*include\s+\w+_INCLUDE/;

      push(@libs, "${1}\$(${TOOLBOX}_LIBDIR))\n") if (/^\s*(AddLibrary\s*\([^,]+,[^,]+,\s*).*\)\s*$/);

      undef $line;
   }
   close;

   #------------------------------------------------------------------------
   # Next we generate a new toolbox.def from the new template.
   #------------------------------------------------------------------------
   $filename = "$tbpath/repos/config/imake_config/toolbox.def";
   open(NEW, "> $filename") || do
   {
      warn "    Could not write new imake config file:\n\t$filename\n";
      return;
   };

   $filename = "$bootpath/objects/library/kcms/templates/toolbox/toolbox.def";
#   $filename = "/research/devel/mirage/work/steve/toolbox.def";
   open(TEMPLATE, "< $filename") || do
   {
      warn "    Could not read new imake config template:\n\t$filename\n";
      close NEW;
      return;
   };

   while (<TEMPLATE>)
   {
      s/#TOOLBOX-NAME#/$TOOLBOX/g;
      s/#toolbox-name#/$toolbox/g;
      if (/^#include DESIGN_INCLUDE/)
      {
	 foreach $tb (@deptbs)
	 {
	    print NEW "$tb";
	 }
	 next;
      }
      print NEW;
      if (/-toolbox_libraries /)
      {
         foreach $library (@libs)
         {
	    print NEW "$library";
         }
      }
   }
   close TEMPLATE;
   close NEW;
};
