 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:19:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:19:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "lrftrain.h"
/*-----------------------------------------------------------
| 
|  Routine Name: lrftrain_get_args
| 
|       Purpose: Gets command line args for lrftrain
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname lrftrain
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void lrftrain_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for lrftrain is out of sync with arguments specified in lrftrain's *.pane file; please rerun ghostwriter on lrftrain.";


	/*
	 * allocate the lrftrain structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "cv",
			  &(clui_info->cv_float),
			  &(clui_info->cv_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "meu",
			  &(clui_info->meu_float),
			  &(clui_info->meu_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "delta",
			  &(clui_info->delta_float),
			  &(clui_info->delta_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "d",
			  &(clui_info->d_int),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f",
			  &(clui_info->f_file),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



