 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:19:36 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:19:36 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vbandsp3.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vbandsp3_get_args
| 
|       Purpose: Gets command line args for vbandsp3
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vbandsp3
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vbandsp3_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vbandsp3 is out of sync with arguments specified in vbandsp3's *.pane file; please rerun ghostwriter on vbandsp3.";


	/*
	 * allocate the vbandsp3 structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



