 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:20:11 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:20:11 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vcmtrans.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vcmtrans_get_args
| 
|       Purpose: Gets command line args for vcmtrans
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vcmtrans
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vcmtrans_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vcmtrans is out of sync with arguments specified in vcmtrans's *.pane file; please rerun ghostwriter on vcmtrans.";


	/*
	 * allocate the vcmtrans structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vcmtrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vcmtrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "n",
			  &(clui_info->n_float),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vcmtrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vcmtrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



