 /*
  * Khoros: $Id: vcmtrans.h,v 1.11 1996/07/05 03:20:13 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vcmtrans
   >>>> 
   >>>>    Written By: Tom Sauer
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vcmtrans_h_
#define _vcmtrans_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$RETRO/objects/kroutine/vcmtrans/uis/vcmtrans.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i1_file;	/* input image FILENAME */
int	 i1_flag;	/* input image FLAG */

/*
 *  input transformation matrix (required infile)
 */
char	*i2_file;	/* input transformation matrix FILENAME */
int	 i2_flag;	/* input transformation matrix FLAG */

/*
 *  output resulting image (required outfile)
 */
char	*o_file;	/* output resulting image FILENAME */
int	 o_flag;	/* output resulting image FLAG */

/*
 *  specifies normalization factor (optional float)
 */
float	 n_float;	/* specifies normalization factor FLOAT */
int	 n_flag;   	/* specifies normalization factor FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(image) \
image = readimage(clui_info->i1_file); \
   if(image == NULL){ \
      kerror(NULL, NULL,"Image could not be read\n"); \
      kexit(1); \
   }

#define READINPUT1(image1) \
image1 = readimage(clui_info->i2_file); \
if(image1 == NULL){ \
    kerror(NULL, NULL,"Image could not be read\n"); \
    kexit(1); \
}
#define CHECKINPUT(program, image) \
   (void) proper_num_images(program,image,1,TRUE); \
   \
   (void) proper_num_bands(program,image,3,TRUE); \
   \
   (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE); \
   \
   (void) propertype(program, image, VFF_TYP_FLOAT, TRUE)

#define CHECKMATRIXINPUT(program, image1) \
   (void) proper_num_images(program,image1,1,TRUE); \
   \
   (void) proper_num_bands(program,image1,1,TRUE); \
   \
   (void) proper_map_enable(program,image1,VFF_MAP_OPTIONAL,TRUE); \
   \
   (void) propertype(program, image1, VFF_TYP_FLOAT, TRUE); \
   \
   (void) propersize(program, image1, 3, 3, TRUE); \
   \
   (void) propersize(program, image1, 3, 3, TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void vcmtrans_get_args PROTO((kform *));
void vcmtrans_usage_additions PROTO((void));
void vcmtrans_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
