 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:20:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:20:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vconvert.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vconvert_get_args
| 
|       Purpose: Gets command line args for vconvert
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vconvert
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vconvert_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vconvert is out of sync with arguments specified in vconvert's *.pane file; please rerun ghostwriter on vconvert.";


	/*
	 * allocate the vconvert structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_logical(pane, "b",
			  &(clui_info->b_logic),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "n",
			  &(clui_info->n_float),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "s",
			  &(clui_info->s_float),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



