 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:21:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:21:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vgcirc.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vgcirc_get_args
| 
|       Purpose: Gets command line args for vgcirc
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vgcirc
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vgcirc_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vgcirc is out of sync with arguments specified in vgcirc's *.pane file; please rerun ghostwriter on vgcirc.";


	/*
	 * allocate the vgcirc structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "d",
			  &(clui_info->d_float),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "x",
			  &(clui_info->x_float),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "y",
			  &(clui_info->y_float),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "b",
			  &(clui_info->b_float),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "f",
			  &(clui_info->f_float),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



