 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:22:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:22:15 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vgpwl.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vgpwl_get_args
| 
|       Purpose: Gets command line args for vgpwl
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vgpwl
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vgpwl_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vgpwl is out of sync with arguments specified in vgpwl's *.pane file; please rerun ghostwriter on vgpwl.";


	/*
	 * allocate the vgpwl structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "s",
			  &(clui_info->s_float),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "l",
			  &(clui_info->l_float),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "m",
			  &(clui_info->m_float),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xp",
			  &(clui_info->xp_float),
			  &(clui_info->xp_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yp",
			  &(clui_info->yp_float),
			  &(clui_info->yp_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xr",
			  &(clui_info->xr_float),
			  &(clui_info->xr_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yr",
			  &(clui_info->yr_float),
			  &(clui_info->yr_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xf",
			  &(clui_info->xf_float),
			  &(clui_info->xf_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yf",
			  &(clui_info->yf_float),
			  &(clui_info->yf_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xw",
			  &(clui_info->xw_float),
			  &(clui_info->xw_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yw",
			  &(clui_info->yw_float),
			  &(clui_info->yw_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



