 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:22:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:22:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vhxray.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vhxray_get_args
| 
|       Purpose: Gets command line args for vhxray
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vhxray
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vhxray_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vhxray is out of sync with arguments specified in vhxray's *.pane file; please rerun ghostwriter on vhxray.";


	/*
	 * allocate the vhxray structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vhxray_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "w",
			  &(clui_info->w_int),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "vhxray_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "h",
			  &(clui_info->h_int),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "vhxray_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "t",
			  &(clui_info->t_logic),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vhxray_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vhxray_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



