 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:22:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:22:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vlabel.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vlabel_get_args
| 
|       Purpose: Gets command line args for vlabel
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vlabel
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vlabel_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vlabel is out of sync with arguments specified in vlabel's *.pane file; please rerun ghostwriter on vlabel.";

	char  *value_string;


	/*
	 * allocate the vlabel structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "w",
			  &(clui_info->w_int),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "m", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->m_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_value(pane, "c", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->c_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_float(pane, "s",
			  &(clui_info->s_float),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "merge",
			  &(clui_info->merge_logic),
			  &(clui_info->merge_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "asc",
			  &(clui_info->asc_file),
			  &(clui_info->asc_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "f",
			  &(clui_info->f_float),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



