 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:04 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:04 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vmarr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vmarr_get_args
| 
|       Purpose: Gets command line args for vmarr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vmarr
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vmarr_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vmarr is out of sync with arguments specified in vmarr's *.pane file; please rerun ghostwriter on vmarr.";


	/*
	 * allocate the vmarr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "v",
			  &(clui_info->v_float),
			  &(clui_info->v_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



