 /*
  * Khoros: $Id: vmarr.c,v 1.11 1996/07/05 03:23:05 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: vmarr.c,v 1.11 1996/07/05 03:23:05 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vmarr
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vmarr.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Create a Marr Type Edge Detection Filter Kernel  (K1)
|
|       Purpose: main program for vmarr
|
|         Input:
|		char *clui_info->o_file; {Marr kernel output image}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		char *clui_info->trigger_file; {trigger input}
|		int   clui_info->trigger_flag; {TRUE if -trigger specified}
|
|		int clui_info->r_int; {specify the number of rows in the kernel}
|		int clui_info->r_flag; {TRUE if -r specified}
|
|		int clui_info->c_int; {specify the number of columns in the kernel}
|		int clui_info->c_flag; {TRUE if -c specified}
|
|		float clui_info->v_float; {variance of the Gaussian}
|		int   clui_info->v_flag; {TRUE if -v specified}
|
|        Output:
|       Returns:
|
|    Written By: Richard Krukar, John Rasure, Robert Estes
|          Date: Jul 04, 1996
| Modifications:
|
------------------------------------------------------------*/

void main(
   int  argc,
   char **argv)
{

	kform  *pane;         /* form tree representing *.pane file */
/* -main_variable_list */
char *program = NULL;

    xvimage *image;
/* -main_variable_list_end */

	khoros_initialize(argc, argv, "RETRO");
	kexit_handler(vmarr_free_args, NULL);

/* -main_get_args_call */
	kclui_initialize(PANEPATH, KGEN_KROUTINE, "RETRO", "vmarr",
		vmarr_usage_additions, vmarr_get_args,
		vmarr_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
/* -main_before_lib_call_end */

/* -main_library_call */
/* Call the procedure that does the work */

    if (! lvmarr( &image, clui_info->r_int, clui_info->c_int, clui_info->v_float))
    {
        (void) kfprintf(kstderr, "lvmarr Failed\n");
        kexit(KEXIT_FAILURE);
    }
/* -main_library_call_end */

/* -main_after_lib_call */
    (void) writeimage(clui_info->o_file,image);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vmarr_usage_additions
| 
|       Purpose: Prints usage additions in vmarr_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vmarr
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vmarr_usage_additions(void)
{
	kfprintf(kstderr, "\tCreate a Marr Type Edge Detection Filter Kernel  (K1)\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vmarr_free_args
| 
|       Purpose: Frees CLUI struct allocated in vmarr_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vmarr
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vmarr_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info->trigger_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
