 /*
  * Khoros: $Id: vmarr.h,v 1.11 1996/07/05 03:23:06 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vmarr
   >>>> 
   >>>>    Written By: Richard Krukar, John Rasure, Robert Estes
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vmarr_h_
#define _vmarr_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$RETRO/objects/kroutine/vmarr/uis/vmarr.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Marr kernel output image (required outfile)
 */
char	*o_file;	/* Marr kernel output image FILENAME */
int	 o_flag;	/* Marr kernel output image FLAG */

/*
 *  trigger input (optional infile)
 */
char	*trigger_file;	/* trigger input FILENAME */
int	 trigger_flag;	/* trigger input FLAG */

/*
 *  specify the number of rows in the kernel (optional integer)
 */
int	 r_int; 	/* specify the number of rows in the kernel INT */
int	 r_flag;	/* specify the number of rows in the kernel FLAG */

/*
 *  specify the number of columns in the kernel (optional integer)
 */
int	 c_int; 	/* specify the number of columns in the kernel INT */
int	 c_flag;	/* specify the number of columns in the kernel FLAG */

/*
 *  variance of the Gaussian (optional float)
 */
float	 v_float;	/* variance of the Gaussian FLOAT */
int	 v_flag;   	/* variance of the Gaussian FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void vmarr_get_args PROTO((kform *));
void vmarr_usage_additions PROTO((void));
void vmarr_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
