 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vmindis.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vmindis_get_args
| 
|       Purpose: Gets command line args for vmindis
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vmindis
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vmindis_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vmindis is out of sync with arguments specified in vmindis's *.pane file; please rerun ghostwriter on vmindis.";


	/*
	 * allocate the vmindis structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vmindis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vmindis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vmindis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vmindis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



