 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:37 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:37 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vpml.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vpml_get_args
| 
|       Purpose: Gets command line args for vpml
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vpml
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vpml_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vpml is out of sync with arguments specified in vpml's *.pane file; please rerun ghostwriter on vpml.";


	/*
	 * allocate the vpml structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "l",
			  &(clui_info->l_int),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "u",
			  &(clui_info->u_int),
			  &(clui_info->u_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s",
			  &(clui_info->s_int),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "q",
			  &(clui_info->q_int),
			  &(clui_info->q_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f1",
			  &(clui_info->f1_file),
			  &(clui_info->f1_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



