 /*
  * Khoros: $Id: vqerr.c,v 1.11 1996/07/05 03:23:47 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: vqerr.c,v 1.11 1996/07/05 03:23:47 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vqerr
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vqerr.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Compute Error between Quantized Image and Original  (K1)
|
|       Purpose: main program for vqerr
|
|         Input:
|		char *clui_info->i1_file; {Quantized image}
|		int   clui_info->i1_flag; {TRUE if -i1 specified}
|
|		char *clui_info->i2_file; {Original image}
|		int   clui_info->i2_flag; {TRUE if -i2 specified}
|
|		char *clui_info->o_file; {Output ASCII File}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		char *clui_info->m_file; {operation masking image}
|		int   clui_info->m_flag; {TRUE if -m specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: Jul 04, 1996
| Modifications:
|
------------------------------------------------------------*/

void main(
   int  argc,
   char **argv)
{

	kform  *pane;         /* form tree representing *.pane file */
/* -main_variable_list */
	char	*program = NULL;
	xvimage	*img1, *img2, *img3;
	kfile	*file;
	double	rms;
/* -main_variable_list_end */

	khoros_initialize(argc, argv, "RETRO");
	kexit_handler(vqerr_free_args, NULL);

/* -main_get_args_call */
	kclui_initialize(PANEPATH, KGEN_KROUTINE, "RETRO", "vqerr",
		vqerr_usage_additions, vqerr_get_args,
		vqerr_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
/* -main_before_lib_call_end */

/* -main_library_call */
	if(! lvqerr(img1, img2, img3, clui_info->m_flag,&rms) )
        {
            kexit(KEXIT_FAILURE);
        }
/* -main_library_call_end */

/* -main_after_lib_call */
	file = kfopen(clui_info->o_file,"w");
        kfprintf(file,"%e\n",rms);
        kfclose(file);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vqerr_usage_additions
| 
|       Purpose: Prints usage additions in vqerr_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vqerr
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vqerr_usage_additions(void)
{
	kfprintf(kstderr, "\tCompute Error between Quantized Image and Original  (K1)\n");

/* -usage_additions */
kfprintf(kstderr, "\tOptional third input is a masking image.\n");
        kfprintf(kstderr, "\t\n");
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vqerr_free_args
| 
|       Purpose: Frees CLUI struct allocated in vqerr_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vqerr
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vqerr_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i1_file);
		kfree_and_NULL(clui_info->i2_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info->m_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
