 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:53 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:23:53 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vquant.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vquant_get_args
| 
|       Purpose: Gets command line args for vquant
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vquant
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vquant_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vquant is out of sync with arguments specified in vquant's *.pane file; please rerun ghostwriter on vquant.";

	char  *value_string;


	/*
	 * allocate the vquant structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "m",
			  &(clui_info->m_logic),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "s",
			  &(clui_info->s_logic),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "axis", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->axis_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->axis_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



