 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:01 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:01 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vsamp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vsamp_get_args
| 
|       Purpose: Gets command line args for vsamp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vsamp
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vsamp_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vsamp is out of sync with arguments specified in vsamp's *.pane file; please rerun ghostwriter on vsamp.";


	/*
	 * allocate the vsamp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x1",
			  &(clui_info->x1_int),
			  &(clui_info->x1_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x2",
			  &(clui_info->x2_int),
			  &(clui_info->x2_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y1",
			  &(clui_info->y1_int),
			  &(clui_info->y1_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y2",
			  &(clui_info->y2_int),
			  &(clui_info->y2_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



