 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:10 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:10 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vsdef.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vsdef_get_args
| 
|       Purpose: Gets command line args for vsdef
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vsdef
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vsdef_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vsdef is out of sync with arguments specified in vsdef's *.pane file; please rerun ghostwriter on vsdef.";


	/*
	 * allocate the vsdef structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "a0",
			  &(clui_info->a0_float),
			  &(clui_info->a0_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "t1",
			  &(clui_info->t1_int),
			  &(clui_info->t1_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "t2",
			  &(clui_info->t2_int),
			  &(clui_info->t2_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "l",
			  &(clui_info->l_int),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



