 /*
  * Khoros: $Id: vsdef.h,v 1.11 1996/07/05 03:24:13 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vsdef
   >>>> 
   >>>>    Written By: Pascal ADAM
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: Jul 04, 1996
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vsdef_h_
#define _vsdef_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

#define PANEPATH "$RETRO/objects/kroutine/vsdef/uis/vsdef.pane"
        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input Image (required infile)
 */
char	*i_file;	/* Input Image FILENAME */
int	 i_flag;	/* Input Image FLAG */

/*
 *  Output Image (required outfile)
 */
char	*o_file;	/* Output Image FILENAME */
int	 o_flag;	/* Output Image FLAG */

/*
 *  Exponential Filter Parameter for GEF (optional float)
 */
float	 a0_float;	/* Exponential Filter Parameter for GEF FLOAT */
int	 a0_flag;   	/* Exponential Filter Parameter for GEF FLAG */

/*
 *  1st Hysteresis Threshold (optional integer)
 */
int	 t1_int; 	/* 1st Hysteresis Threshold INT */
int	 t1_flag;	/* 1st Hysteresis Threshold FLAG */

/*
 *  2nd Hysteresis Threshold (optional integer)
 */
int	 t2_int; 	/* 2nd Hysteresis Threshold INT */
int	 t2_flag;	/* 2nd Hysteresis Threshold FLAG */

/*
 *  Minimum Number of Pixels in a Segment (optional integer)
 */
int	 l_int; 	/* Minimum Number of Pixels in a Segment INT */
int	 l_flag;	/* Minimum Number of Pixels in a Segment FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(image1) \
image1 = readimage(clui_info->i_file);  \
if (image1 == NULL) {  \
   (void) kfprintf(kstderr,"vsdef: Can not read first input image \n");  \
   kexit(1);  /* Quit if bad image */ \
}
#define CHECKINPUT(program, image) \
    propertype(program,image,VFF_TYP_1_BYTE,TRUE); \
    proper_num_images(program,image,1,TRUE);  \
    proper_num_bands(program,image,1,TRUE);  \
    proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE);
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void main PROTO((int, char **));
void vsdef_get_args PROTO((kform *));
void vsdef_usage_additions PROTO((void));
void vsdef_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
