 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vshape.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vshape_get_args
| 
|       Purpose: Gets command line args for vshape
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vshape
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vshape_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vshape is out of sync with arguments specified in vshape's *.pane file; please rerun ghostwriter on vshape.";


	/*
	 * allocate the vshape structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_logical(pane, "ms",
			  &(clui_info->ms_logic),
			  &(clui_info->ms_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mc",
			  &(clui_info->mc_logic),
			  &(clui_info->mc_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mi",
			  &(clui_info->mi_logic),
			  &(clui_info->mi_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mr",
			  &(clui_info->mr_logic),
			  &(clui_info->mr_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "col",
			  &(clui_info->col_logic),
			  &(clui_info->col_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f",
			  &(clui_info->f_file),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



