 /*
  * Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:27 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11 1996/07/05 03:24:27 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vslope.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vslope_get_args
| 
|       Purpose: Gets command line args for vslope
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vslope
|          Date: Jul 04, 1996
| Modifications: 
| 
------------------------------------------------------------*/
void vslope_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for vslope is out of sync with arguments specified in vslope's *.pane file; please rerun ghostwriter on vslope.";

	char  *value_string;


	/*
	 * allocate the vslope structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "so", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->so_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->so_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_value(pane, "to", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->to_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->to_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_float(pane, "z",
			  &(clui_info->z_float),
			  &(clui_info->z_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "s",
			  &(clui_info->s_file),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "t",
			  &(clui_info->t_file),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



