/*
  * Khoros: $Id: match_enc.c,v 1.6 1996/04/05 00:53:37 fas Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: match_enc.c,v 1.6 1996/04/05 00:53:37 fas Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 match_encode_scheme()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: match_encode_scheme
*
*       Purpose: Check to see if two viff data structures have the same data
*               storage endcoding scheme. 
*
*         Input: prog 	- program name
*		*img1	- viff data structure one
*		*img2	- viff data structure two
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int match_encode_scheme(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
        if( img1->data_encode_scheme != img2->data_encode_scheme ){
	    if (exit_flag == TRUE) {
		    (void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		    (void) kfprintf(kstderr,
"The viff data structues use a different encoding or compression scheme.\n");
		    kexit(KEXIT_FAILURE);
	    }
	else return(0);
        }
return(1);
}
