/*
  * Khoros: $Id: proper_enc.c,v 1.6 1996/04/05 00:53:50 fas Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: proper_enc.c,v 1.6 1996/04/05 00:53:50 fas Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 proper_encode_scheme()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: proper_encode_scheme
*
*       Purpose: Check to see if a viff data has the correct
*               encoding scheme.
*
*         Input: prog 	- program name
*		*image	- viff data
*		type	- desired encoding scheme
*		exit_flag
*
*        Output: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*       Returns: 
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int proper_encode_scheme(char *prog, xvimage *image, long unsigned int type, int exit_flag)
{
   if(image->data_encode_scheme != type) {
      if (exit_flag == TRUE) {
         (void) kfprintf(kstderr, "\nError in program %s: \n",prog);
         (void) kfprintf(kstderr, 
"The encoding or compression shceme used on the viff data file is incorrect.\n");
         switch(type){
            case VFF_DES_RAW :
               (void) kfprintf(kstderr, "Data encoding scheme should be VFF_DES_RAW\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_DES_COMPRESS :
               (void) kfprintf(kstderr, "Data encoding scheme should be VFF_DES_COMPRESS\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_DES_RLE :
               (void) kfprintf(kstderr, "Data encoding scheme should be VFF_DES_RLE\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_DES_ADPCM :
               (void) kfprintf(kstderr, "Data encoding scheme should be VFF_DES_ADPCM\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_DES_CCITT :
               (void) kfprintf(kstderr, "Data encoding scheme should be VFF_DES_CCITT\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_DES_TRANSFORM :
               (void) kfprintf(kstderr, "Data encoding scheme should be VFF_DES_TRANSFORM\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_DES_GENERIC :
               (void) kfprintf(kstderr, "Data encoding scheme should be VFF_DES_GENERIC\n");
               kexit(KEXIT_FAILURE);
               break;
            default :
               (void) kfprintf(kstderr, "Data encoding scheme is unknown.\n");
               kexit(KEXIT_FAILURE);
               break;
	 }
      }
      else return(0);
   }
return(1);
}
