/*
  * Khoros: $Id: cp_header.c,v 1.5 1996/04/05 00:56:12 fas Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: cp_header.c,v 1.5 1996/04/05 00:56:12 fas Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 copyheader()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: copyheader - copy the header from one image to another
*
*       Purpose: copy the header from one image to another
*
*         Input: image1 - the source image
*
*        Output: image2 - with the header from image 1
*
*       Returns: TRUE (1) on success, FALSE (0) otherwise
*
*  Restrictions: 
*    Written By: Tom Sauer
*          Date: 5/19/89
*      Verified:
*  Side Effects:
* Modifications:
**************************************************************/
void copyheader(xvimage *image1, xvimage *image2)
{

	image2->identifier = image1->identifier;
	image2->file_type = image1->file_type;
	image2->release = image1->release;
	image2->version = image1->version;
	image2->machine_dep = image1->machine_dep;
	(void) kstrcpy(image2->comment, image1->comment);
	image2->row_size = image1->row_size;
	image2->col_size = image1->col_size;
	image2->subrow_size = image1->subrow_size;
	image2->startx = image1->startx;
	image2->starty = image1->starty;
	image2->pixsizx = image1->pixsizx; 
	image2->pixsizy = image1->pixsizy;
	image2->location_type = image1->location_type;
	image2->location_dim = image1->location_dim;
	image2->num_of_images = image1->num_of_images;
	image2->num_data_bands = image1->num_data_bands;
	image2->data_storage_type = image1->data_storage_type;
	image2->data_encode_scheme = image1->data_encode_scheme;
	image2->map_scheme = image1->map_scheme;
	image2->map_storage_type = image1->map_storage_type;
	image2->map_row_size = image1->map_row_size;
	image2->map_col_size = image1->map_col_size;
	image2->map_subrow_size = image1->map_subrow_size;
	image2->map_enable = image1->map_enable;
	image2->maps_per_cycle = image1->maps_per_cycle;
	image2->color_space_model = image1->color_space_model;
	image2->ispare1 = image1->ispare1;
	image2->ispare2 = image1->ispare2;
	image2->fspare1 = image1->fspare1;
	image2->fspare2 = image1->fspare2;
}
