/*
  * Khoros: $Id: cp_locdata.c,v 1.6 1996/04/05 00:56:13 fas Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: cp_locdata.c,v 1.6 1996/04/05 00:56:13 fas Exp $";
#endif


/*
 * Copyright (C) 1993 - 1996, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 copylocationdata()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: copylocationdata - Copy location data
*
*       Purpose: Copy location data
*
*         Input: img1 - image location data to be copied
*		 img2 - pointer to copied location data
*                malloc_flg - if set (=1) malloc room
*
*        Output: 
*
*       Returns: TRUE (1) on success, FALSE (0) otherwise
*
*  Restrictions: Restrictions on data or input as applicable
*    Written By: Ron E. Neher
*          Date: 3/23/89
*      Verified:
*  Side Effects:
* Modifications:
*
*************************************************************/
int copylocationdata(xvimage *img1, xvimage **img2, int malloc_flg)
{
float	fsize;

/* room for the location */

    switch (img1->location_type)
    {
	case VFF_LOC_IMPLICIT:
	    (*img2)->location = NULL;
	    break;
	case VFF_LOC_EXPLICIT:
	    fsize = img1->row_size*img1->col_size*
		    img1->location_dim*sizeof(float);
	    if (malloc_flg)
                if (((*img2)->location =
		    (float *) kmalloc((size_t) fsize)) == NULL)
                {
	            (void) kfprintf(kstderr,"copylocationdata: Not enough\
 memory for location data!\n");
		    return(FALSE);
	        }
	    kmemcpy((kaddr) (*img2)->location, (kaddr) img1->location,
		  (size_t) fsize);
	    break;
	default:
	    (void) kfprintf(kstderr,"copylocationdata: Not a valid \
location type\n");
	    return(FALSE);
    }

    (*img2)->location_type = img1->location_type;
    (*img2)->location_dim = img1->location_dim;
    (*img2)->col_size = img1->col_size;
    (*img2)->row_size = img1->row_size;

    return(TRUE);
}
